@q commands.w@>
@q Created by Laurence D. Finston (LDF) 2006.11.13.@>

@q $Id: commands.w,v 1.6 2007/02/13 20:42:40 lfinsto1 Exp $ @>

@q * (1) Copyright and License. @>

@q This file is part of the LDF Metadata Exchange Utilities,            @>
@q a package for metadata exchange.                                     @>
@q It contains code from the the IWF Metadata Harvester, a package for  @>
@q metadata harvesting.                                                 @> 

@q The following copyright notice applies to the contents of this file up to  @>      
@q and including January 31, 2007:                                            @> 

@q Copyright (C) 2006, 2007 IWF Wissen und Medien gGmbH  @>

@q The following copyright notice applies to all changes and additions to this file  @>      
@q starting on February 1, 2007:                                                     @> 

@q Copyright (C) 2007 Laurence D. Finston  @>

@q The state of this file as of January 31, 2007 is stored in the  	  @>    
@q revision of this file with the symbolic tag "LAST_IWF"          	  @>
@q in the CVS repository for the LDF Metadata Exchange Utilities:  	  @>
@q http://cvs.savannah.nongnu.org/viewcvs/iwf-mdh/?root=iwf-mdh    	  @>
@q If necessary, changes and additions after this date can be determined  @>
@q by comparing this revision with later ones using the GNU diffutils:    @>
@q http://www.gnu.org/software/diffutils/diffutils.html                   @>

@q The author is Laurence D. Finston.  @>

@q The LDF Metadata Exchange Utilities are free software;                  @>
@q you can redistribute them and/or modify                                 @>
@q them under the terms of the GNU General Public License as published by  @>
@q the Free Software Foundation; either version 2 of the License, or       @>
@q (at your option) any later version.                                     @>

@q The LDF Metadata Exchange Utilities are distributed in the hope               @>          
@q that they will be useful, but WITHOUT ANY WARRANTY; without even              @>
@q the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  @>
@q See the GNU General Public License for more details.                          @>

@q You should have received a copy of the GNU General Public License                   @>
@q along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  @>
@q Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          @>

@q The LDF Metadata Exchange Utilities are available for downloading from the @>
@q following FTP server:                                                      @>
@q ftp://ftp.gwdg.de/pub/gnu2/iwfmdh/                                         @>

@q "@@" stands for a single "at"-sign in the following email adresses.  @>

@q Please send bug reports to lfinsto1@@gwdg.de  @>

@q The author can be contacted at: @>

@q Laurence D. Finston @>
@q Kreuzbergring 41    @>
@q D-37075 Goettingen  @>
@q Germany             @>

@q lfinsto1@@gwdg.de               @>
@q s246794@@stud.uni-goettingen.de @>


@q ** (2) Commands.@>
@*1 Commands (\filename{commands.w}).
\initials{LDF 2006.11.13.}

\LOG
\initials{LDF 2006.11.13.}
Added this file.
\ENDLOG

@<\filename{commands.w}@>=
static char commands_id_string[] 
   = "$Id: commands.w,v 1.6 2007/02/13 20:42:40 lfinsto1 Exp $"; 

@
@<Type declarations for non-terminal symbols@>=
@=%type <int_value> command@>

@q *** (3) Messages.@>
@*2 Messages.
\initials{LDF 2006.11.15.}

\LOG
\initials{2006.11.15.}
Added this section.
\ENDLOG



@q **** (4) message_or_errmessage@>
@*3 \message or errmessage>.
\initials{LDF 2006.11.15.}

\LOG
\initials{2006.11.15.}
Added this type declaration.
\ENDLOG


@<Type declarations for non-terminal symbols@>=
@=%type <int_value> message_or_errmessage@>

@q ***** (5) message_or_errmessage: MESSAGE.@>
@*4  \message or errmessage> $\longrightarrow$  \.{MESSAGE}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=message_or_errmessage: MESSAGE@>
{

@q **** (4) @>

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `message_or_errmessage: MESSAGE'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

   @=$$@> = MESSAGE;

};

@q ***** (5) message_or_errmessage: ERRMESSAGE.@>
@*4  \message or errmessage> $\longrightarrow$  \.{ERRMESSAGE}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=message_or_errmessage: ERRMESSAGE@>
{

@q **** (4) @>

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `message_or_errmessage: ERRMESSAGE'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

   @=$$@> = ERRMESSAGE;

};



@q **** (4) command: message_or_errmessage STRING.@>
@*2  \command> $\longrightarrow$ \message or errmessage>.
\.{STRING}.
\initials{LDF 2006.11.13.}

\LOG
\initials{2006.11.13.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=command: message_or_errmessage STRING@>
{

@q **** (4) @>

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

#ifdef DEBUG_OUTPUT 
    temp_strm << endl 
              << "Rule `command: message_or_errmessage STRING'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    if (@=$1@> == ERRMESSAGE)
       temp_strm << "ERROR!  ";

    temp_strm << @=$2@> << endl;

    if (@=$1@> == ERRMESSAGE)
       temp_strm << "Type <RETURN> to continue: ";

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");

    if (@=$1@> == ERRMESSAGE)
       getchar();

    cerr_mutex.unlock();

};

@q *** (3) command: PAUSE.@>
@*2  \command> $\longrightarrow$ \.{PAUSE}.
\initials{LDF 2006.11.13.}

\LOG
\initials{2006.11.13.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=command: PAUSE@>
{

@q **** (4) @>

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

#ifdef DEBUG_OUTPUT 
    temp_strm << endl 
              << "Rule `command: PAUSE'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    temp_strm << "Enter <RETURN> to continue: ";
    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
    getchar();
    cerr_mutex.unlock();

};



@q *** (3) command: SHOW query_variable.@>
@*2  \command> $\longrightarrow$ \.{SHOW} \query variable>.
\initials{LDF 2006.11.13.}

\LOG
\initials{2006.11.13.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=command: SHOW query_variable@>
{

@q **** (4) @>

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

#ifdef DEBUG_OUTPUT 
    temp_strm << endl 
              << "Rule `command: SHOW query_variable'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    Id_Node curr_id_node = static_cast<Id_Node>(@=$2@>);

@q **** (4) @>

    if (curr_id_node == 0)
    {
        temp_strm << "WARNING!  In `yyparse', rule `command: SHOW query_variable':"
                  << endl
                  << "`query_variable' is NULL.  Can't show.  Continuing.";

        cerr_mutex.lock();
        cerr <<  temp_strm.str();
        cerr_mutex.unlock();
        scanner_node->log_strm << temp_strm.str();
        temp_strm.str("");

        @=$$@> = 1;

    }  /* |if (curr_id_node == 0)|  */


@q **** (4) @>

    else if (curr_id_node->value == 0)
    {
        temp_strm << "WARNING!  In `yyparse', rule `command: SHOW query_variable':"
                  << endl
                  << "The `value' element of `query_variable' is NULL.  "
                  << "Can't show.  Continuing.";

        cerr_mutex.lock();
        cerr <<  temp_strm.str();
        cerr_mutex.unlock();
        scanner_node->log_strm << temp_strm.str();
        temp_strm.str("");

        @=$$@> = 1;

    }  /* |if (curr_id_node == 0)|  */

@q **** (4) @>

    else if (curr_id_node && curr_id_node->value)
    {
        Query_Node curr_query_node = static_cast<Query_Node>(curr_id_node->value);
        cerr_mutex.lock();
        curr_query_node->show("Query_Type:");
        cerr_mutex.unlock(); 
        @=$$@> = 0;
    }

@q **** (4) @>

#undef DEBUG_OUTPUT 
};


@q *** (3) command: SHOW datasource_variable.@>
@*2  \command> $\longrightarrow$ \.{SHOW} \datasource variable>.
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=command: SHOW datasource_variable@>
{

@q **** (4) @>

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

#ifdef DEBUG_OUTPUT 
    temp_strm << endl 
              << "Rule `command: SHOW datasource_variable'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    Id_Node curr_id_node = static_cast<Id_Node>(@=$2@>);

@q **** (4) @>

    if (curr_id_node == 0)
    {
        temp_strm << "WARNING!  In `yyparse', rule `command: SHOW datasource_variable':"
                  << endl
                  << "`datasource_variable' is NULL.  Can't show.  Continuing.";

        cerr_mutex.lock();
        cerr <<  temp_strm.str();
        cerr_mutex.unlock();
        scanner_node->log_strm << temp_strm.str();
        temp_strm.str("");

        @=$$@> = 1;

    }  /* |if (curr_id_node == 0)|  */


@q **** (4) @>

    else if (curr_id_node->value == 0)
    {
        temp_strm << "WARNING!  In `yyparse', rule `command: SHOW datasource_variable':"
                  << endl
                  << "The `value' element of `datasource_variable' is NULL.  "
                  << "Can't show.  Continuing.";

        cerr_mutex.lock();
        cerr <<  temp_strm.str();
        cerr_mutex.unlock();
        scanner_node->log_strm << temp_strm.str();
        temp_strm.str("");

        @=$$@> = 1;

    }  /* |if (curr_id_node == 0)|  */

@q **** (4) @>

    else if (curr_id_node && curr_id_node->value)
    {
        Datasource_Node curr_datasource_node = static_cast<Datasource_Node>(curr_id_node->value);
        cerr_mutex.lock();
        curr_datasource_node->show("Datasource_Type:");
        cerr_mutex.unlock(); 
        @=$$@> = 0;
    }

@q **** (4) @>

#undef DEBUG_OUTPUT 
};

@q *** (3) command: SHOW datetime_variable.@>
@*2  \command> $\longrightarrow$ \.{SHOW} \datetime variable>.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=command: SHOW datetime_variable@>
{

@q **** (4) @>

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

#ifdef DEBUG_OUTPUT 
    temp_strm << endl 
              << "Rule `command: SHOW datetime_variable'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    Id_Node curr_id_node = static_cast<Id_Node>(@=$2@>);

@q **** (4) @>

    if (curr_id_node == 0)
    {
        temp_strm << "WARNING!  In `yyparse', rule `command: SHOW datetime_variable':"
                  << endl
                  << "`datetime_variable' is NULL.  Can't show.  Continuing.";

        cerr_mutex.lock();
        cerr <<  temp_strm.str();
        cerr_mutex.unlock();
        scanner_node->log_strm << temp_strm.str();
        temp_strm.str("");

        @=$$@> = 1;

    }  /* |if (curr_id_node == 0)|  */


@q **** (4) @>

    else if (curr_id_node->value == 0)
    {
        temp_strm << "WARNING!  In `yyparse', rule `command: SHOW datetime_variable':"
                  << endl
                  << "The `value' element of `datetime_variable' is NULL.  "
                  << "Can't show.  Continuing.";

        cerr_mutex.lock();
        cerr <<  temp_strm.str();
        cerr_mutex.unlock();
        scanner_node->log_strm << temp_strm.str();
        temp_strm.str("");

        @=$$@> = 1;

    }  /* |if (curr_id_node == 0)|  */

@q **** (4) @>

    else if (curr_id_node && curr_id_node->value)
    {
        Date_Time_Node curr_date_time_node = static_cast<Date_Time_Node>(curr_id_node->value);
        cerr_mutex.lock();
        curr_date_time_node->show("Date_Time_Type:");
        cerr_mutex.unlock(); 
        @=$$@> = 0;
    }

@q **** (4) @>

#undef DEBUG_OUTPUT 
};



@q *** (3) command: SHOW string_expression.@>
@*2  \command> $\longrightarrow$ \.{SHOW} \string expression>.
\initials{LDF 2006.11.16.}

\LOG
\initials{LDF 2006.11.16.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=command: SHOW string_expression@>
{

@q **** (4) @>

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

#ifdef DEBUG_OUTPUT 
    temp_strm << endl 
              << "Rule `command: SHOW string_expression'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

   temp_strm << "string == " << @=$2@> << endl;

@q **** (4) @>

#undef DEBUG_OUTPUT 
};

@q *** (3) command: OUTPUT TEX string_expression.@>
@*2  \command> $\longrightarrow$ \.{OUTPUT} \.{TEX} \string expression>.
\initials{LDF 2006.11.23.}

\LOG
\initials{LDF 2006.11.23.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=command: OUTPUT TEX string_expression@>
{

@q **** (4) @>

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

#ifdef DEBUG_OUTPUT 
    temp_strm << endl 
              << "Rule `command: OUTPUT TEX string_expression'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    stringstream temp_filename;

    tex_mutex.lock();
    temp_filename << tex_filename_str << tex_file_ctr++ << ".tex";
    tex_file_strm.open(temp_filename.str().c_str());
    
    tex_file_strm << copyright_tex_str << endl;

    time_t tp;
    time(&tp);

    time_mutex.lock();
    tm* local_time = localtime(&tp);
    char* datestamp = asctime(local_time);
    time_mutex.unlock();


    tex_file_strm << "%% This file was generated by `Scantest' on " 
                  << datestamp << "\n\n";

    tex_file_strm << "\\input chrtbase.tex\n\n" << @=$3@>
                  << "\n\n\\bye\n";
    tex_file_strm.close();
    tex_mutex.unlock();


@q **** (4) @>

#undef DEBUG_OUTPUT 
};



@q *** (3) @>

@q ** (2) @>

@q * (1) Emacs-Lisp code for use in indirect buffers.  LDF 2006.10.11.@>

@q (progn (outline-mode) (abbrev-mode t) (ignore '(                          @>
@q )) (setq outline-regexp (concat (char-to-string 64) "q [*\f]+")) (ignore'(@>
@q )) (make-variable-buffer-local 'outline-regexp))                          @>

@q * (1) Local Variables for Emacs  @>

@q Local Variables: @>
@q mode:CWEB @>
@q abbrev-mode:t @>
@q End: @>
