@q dbcrprsr.w@>
@q Created by Laurence D. Finston (LDF) Tue Feb 13 11:44:40 CET 2007  @>

@q * (1) Copyright and License. @>

@q This file is part of the LDF Metadata Exchange Utilities,            @>
@q a package for metadata exchange.                                     @>

@q Copyright (C) 2007 Laurence D. Finston  @>

@q The author is Laurence D. Finston.  @>

@q The LDF Metadata Exchange Utilities are free software;                  @>
@q you can redistribute them and/or modify                                 @>
@q them under the terms of the GNU General Public License as published by  @>
@q the Free Software Foundation; either version 2 of the License, or       @>
@q (at your option) any later version.                                     @>

@q The LDF Metadata Exchange Utilities are distributed in the hope               @>          
@q that they will be useful, but WITHOUT ANY WARRANTY; without even              @>
@q the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  @>
@q See the GNU General Public License for more details.                          @>

@q You should have received a copy of the GNU General Public License                   @>
@q along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  @>
@q Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          @>

@q The LDF Metadata Exchange Utilities are available for downloading from the @>
@q following FTP server:                                                      @>
@q ftp://ftp.gwdg.de/pub/gnu2/iwfmdh/                                         @>

@q "@@" stands for a single "at"-sign in the following email adresses.  @>

@q Please send bug reports to lfinsto1@@gwdg.de  @>

@q The author can be contacted at: @>

@q Laurence D. Finston @>
@q Kreuzbergring 41    @>
@q D-37075 Goettingen  @>
@q Germany             @>

@q lfinsto1@@gwdg.de               @>
@q s246794@@stud.uni-goettingen.de @>


@q * (0) @>
@** Dublin Core Parser (\filename{dbcrprsr.w}).
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this file.
\ENDLOG

@q {@>
@!@:dbcrprsr.w}{{\filename{dbcrprsr.w}}@>@>
@q }@>

@<\filename{dbcrprsr.w}@>=
static char dbcrprsr_id_string[] 
   = "$Id: dbcrprsr.w,v 1.6 2007/02/13 20:08:02 lfinsto1 Exp $";


@q * (1) Include files.@>
@* Include files.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this section.
\ENDLOG

@<Include files@>=

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <ios>
#include <iomanip>
#include <iostream>
#include <iosfwd>
#include <fstream>
#include <sstream>
#include <new>
#include <ctype.h>
#include <string.h>

#include "dbcrprsr.hxx"
#include "dbcrscan.hxx"


@q * (1) Preprocessor macro definitions.  @>
@* Preprocessor macro definitions.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this section.
\ENDLOG

@<Preprocessor macro definitions@>=

#define YYPARSE_PARAM parameter
#define YYLEX_PARAM parameter

@q * (1) Declare |xxerror|.@>
@* Declare {\bf xxerror}.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this section.
\ENDLOG

@<Declare Dublin Core parser functions@>=

void 
xxerror(const char* s);


@q * (1) Bison options.@>
@* Bison options.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this section.
\ENDLOG

@<Bison options@>=

@=%debug@>@/
@=%defines@>@/
@=%locations@>@/
@=%name-prefix="xx"@>@/
@=%output="dbcrprsr.cxx"@>@/
@=%pure_parser@>@/
@=%verbose@>@/


@q * (1) |union| declaration for |YYSTYPE|.@>
@* |union| declaration for |YYSTYPE|.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this section.
\ENDLOG

@<|union| declaration for |YYSTYPE|@>=
@=%union {@>
    int int_value;
    float float_value;
    char string_value[2048];
    void* pointer_value;
}

@q * (1) Token and type declarations.@>
@* Token and type declarations.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this section.
\ENDLOG

@q ** (2) Record.@>

@*1 Record.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this section.
\ENDLOG

@<Token and type declarations@>=

@=%token<int_value> DATESTAMP_START_TAG@>@/
@=%token<int_value> DATESTAMP_END_TAG@>@/

@=%token<int_value> HEADER_START_TAG@>@/
@=%token<int_value> HEADER_END_TAG@>@/

@=%token<int_value> IDENTIFIER_START_TAG@>@/
@=%token<int_value> IDENTIFIER_END_TAG@>@/

@=%token<int_value> METADATA_START_TAG@>@/
@=%token<int_value> METADATA_END_TAG@>@/

@=%token<int_value> OAI_DC_DC_START_TAG@>@/
@=%token<int_value> OAI_DC_DC_END_TAG@>@/

@=%token<int_value> RECORD_START_TAG@>@/
@=%token<int_value> RECORD_END_TAG@>@/

@q ** (2) Dublin Core Namespace.@>
@*1 Dublin Core Namespace.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this section.
\ENDLOG

@<Token and type declarations@>=

@=%token<int_value> DC_CREATOR_START_TAG@>@/
@=%token<int_value> DC_CREATOR_END_TAG@>@/

@=%token<int_value> DC_CONTRIBUTOR_START_TAG@>@/
@=%token<int_value> DC_CONTRIBUTOR_END_TAG@>@/

@=%token<int_value> DC_DESCRIPTION_START_TAG@>@/
@=%token<int_value> DC_DESCRIPTION_END_TAG@>@/

@=%token<int_value> DC_DATE_START_TAG@>@/
@=%token<int_value> DC_DATE_END_TAG@>@/

@=%token<int_value> DC_IDENTIFIER_START_TAG@>@/
@=%token<int_value> DC_IDENTIFIER_END_TAG@>@/

@=%token<int_value> DC_LANGUAGE_START_TAG@>@/
@=%token<int_value> DC_LANGUAGE_END_TAG@>@/

@=%token<int_value> DC_RIGHTS_START_TAG@>@/
@=%token<int_value> DC_RIGHTS_END_TAG@>@/

@=%token<int_value> DC_SUBJECT_START_TAG@>@/
@=%token<int_value> DC_SUBJECT_END_TAG@>@/

@=%token<int_value> DC_TYPE_START_TAG@>@/
@=%token<int_value> DC_TYPE_END_TAG@>@/


@=%token<int_value> END_OAI@>@/

@q * (1) Dublin Core parser rules.  @>
@* Dublin Core parser rules.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this section.
\ENDLOG

@q ** (2) program (Start symbol).  @>
@*1 \<program> (Start symbol).
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this rule.
\ENDLOG

@<Dublin Core parser rules@>=

@=program: statement_list END_OAI@>@/
{
   cerr << "`program: statement_list END_OAI'" << endl;

   return 0;
};

@q ** (2) statement_list.@>
@*1 \<statement list>.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this section.
\ENDLOG


@q *** (3) statement_list: /* Empty */.@>
@*2 \<statement list> $\longrightarrow$ \.{Empty}.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this rule.
\ENDLOG

@<Dublin Core parser rules@>=

@=statement_list: /* Empty  */@>@/
{

   cerr << "`statement_list EMPTY'" << endl;

};

@q *** (3) statement_list: statement_list statement.@>
@*2 \<statement list> $\longrightarrow$ \<statement list> 
\<statement>.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this rule.
\ENDLOG

@<Dublin Core parser rules@>=

@=statement_list: statement_list statement@>@/
{

   cerr << "`statement_list: statement_list statement'" << endl;

};


@q ** (2) statement.@>
@*1 \<statement>.

\LOG
\initials{LDF 2007.02.13.}
Added this section.
\ENDLOG

@q *** (3) statement: RECORD_START_TAG RECORD_END_TAG.@>
@*2 \<statement list> $\longrightarrow$ $\ldots$.
\<statement list> $\longrightarrow$ {RECORD\_START\_TAG}
\.{RECORD\_END\_TAG}.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this rule.
\ENDLOG

@<Dublin Core parser rules@>=

@=statement: RECORD_START_TAG RECORD_END_TAG@>@/
{
   cerr << "`statement: RECORD_START_TAG RECORD_END_TAG'" 
        << endl;
};


@q * (1) Putting the Dublin Core parser together.@>
@ Putting the Dublin Core parser together.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this section.
\ENDLOG

@(dbcrprsr.yxx@>=
@=%{@>@;@/ 

@<Include files@>@;

using namespace std;

@<Preprocessor macro definitions@>@;

@<Declare Dublin Core parser functions@>@;


@<\filename{dbcrprsr.w}@>@;

@=%}@>@/
@<|union| declaration for |YYSTYPE|@>@;
@<Bison options@>@;
@<Token and type declarations@>@;

@=%%@>@/

@<Dublin Core parser rules@>@;



@ Empty C section.
\initials{LDF 2007.02.13.}

\LOG
\initials{LDF 2007.02.13.}
Added this section.
\ENDLOG

@c
/* Empty  */

@q * (1) Emacs-Lisp code for use in indirect buffers.  LDF 2006.10.11.@>

@q (progn (cweb-mode) (outline-minor-mode t) (read-abbrev-file))  @>

@q * (1) Local Variables for Emacs  @>

@q Local Variables: @>
@q mode:CWEB @>
@q eval:(outline-minor-mode t) @>
@q abbrev-mode:t @>
@q eval:(read-abbrev-file) @>
@q End: @>
