@q dtsrcexp.w@>
@q Created by Laurence D. Finston (LDF) 2006.12.08.@>

@q $Id: dtsrcexp.w,v 1.6 2007/02/13 20:37:48 lfinsto1 Exp $ @>

@q * (1) Copyright and License. @>

@q This file is part of the LDF Metadata Exchange Utilities,            @>
@q a package for metadata exchange.                                     @>
@q It contains code from the the IWF Metadata Harvester, a package for  @>
@q metadata harvesting.                                                 @> 

@q The following copyright notice applies to the contents of this file up to  @>      
@q and including January 31, 2007:                                            @> 

@q Copyright (C) 2006, 2007 IWF Wissen und Medien gGmbH  @>

@q The following copyright notice applies to all changes and additions to this file  @>      
@q starting on February 1, 2007:                                                     @> 

@q Copyright (C) 2007 Laurence D. Finston  @>

@q The state of this file as of January 31, 2007 is stored in the  	  @>    
@q revision of this file with the symbolic tag "LAST_IWF"          	  @>
@q in the CVS repository for the LDF Metadata Exchange Utilities:  	  @>
@q http://cvs.savannah.nongnu.org/viewcvs/iwf-mdh/?root=iwf-mdh    	  @>
@q If necessary, changes and additions after this date can be determined  @>
@q by comparing this revision with later ones using the GNU diffutils:    @>
@q http://www.gnu.org/software/diffutils/diffutils.html                   @>

@q The author is Laurence D. Finston.  @>

@q The LDF Metadata Exchange Utilities are free software;                  @>
@q you can redistribute them and/or modify                                 @>
@q them under the terms of the GNU General Public License as published by  @>
@q the Free Software Foundation; either version 2 of the License, or       @>
@q (at your option) any later version.                                     @>

@q The LDF Metadata Exchange Utilities are distributed in the hope               @>          
@q that they will be useful, but WITHOUT ANY WARRANTY; without even              @>
@q the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  @>
@q See the GNU General Public License for more details.                          @>

@q You should have received a copy of the GNU General Public License                   @>
@q along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  @>
@q Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          @>

@q The LDF Metadata Exchange Utilities are available for downloading from the @>
@q following FTP server:                                                      @>
@q ftp://ftp.gwdg.de/pub/gnu2/iwfmdh/                                         @>

@q "@@" stands for a single "at"-sign in the following email adresses.  @>

@q Please send bug reports to lfinsto1@@gwdg.de  @>

@q The author can be contacted at: @>

@q Laurence D. Finston @>
@q Kreuzbergring 41    @>
@q D-37075 Goettingen  @>
@q Germany             @>

@q lfinsto1@@gwdg.de               @>
@q s246794@@stud.uni-goettingen.de @>



@q ** (2) Datasource expressions.@>
@*1 Datasource expressions (\filename{dtsrcexp.w}).
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this file.
\ENDLOG

@
@<\filename{dtsrcexp.w}@>=
static char dtsrcexp_id_string[] 
   = "$Id: dtsrcexp.w,v 1.6 2007/02/13 20:37:48 lfinsto1 Exp $"; 

@q *** (3) datasource_primary.@>
@*2 {\bf datasource primary}.
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> datasource_primary@>

@q **** (4) datasource_primary: datasource_variable@>
@*3 \datasource primary> $\longrightarrow$ \datasource variable>.
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datasource_primary: datasource_variable@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `datasource_primary: datasource_variable'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    Id_Node curr_id_node = static_cast<Id_Node>(@=$1@>);

    if (curr_id_node && curr_id_node->value) 
    {
       Datasource_Node curr_datasource_node = new Datasource_Type;
       *curr_datasource_node = *static_cast<Datasource_Node>(curr_id_node->value);
       @=$$@> = static_cast<void*>(curr_datasource_node); 
    }
    else 
       @=$$@> = 0;


#ifdef DEBUG_OUTPUT 
    temp_strm << endl 
              << "Exiting rule `datasource_primary: datasource_variable'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

};

@q **** (4) datasource_primary: OPEN_PARENTHESIS datasource_expression CLOSE_PARENTHESIS@>
@*3 \datasource primary> $\longrightarrow$ \.{(} \datasource expression> \.{)}.
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datasource_primary: OPEN_PARENTHESIS datasource_expression CLOSE_PARENTHESIS@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `datasource_primary: OPEN_PARENTHESIS datasource_expression "
              << "CLOSE_PARENTHESIS'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    Datasource_Node q = static_cast<Datasource_Node>(@=$2@>);

    @=$$@> = @=$2@>;

};

@q *** (3) datasource_secondary.@>
@*2 {\bf datasource secondary}.
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> datasource_secondary@>

@q **** (4) datasource_secondary: datasource_primary@>
@*3 \datasource secondary> $\longrightarrow$ \datasource primary>.
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datasource_secondary: datasource_primary@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `datasource_secondary: datasource_primary'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = @=$1@>;

};

@q *** (3) datasource_tertiary.@>
@*2 {\bf datasource tertiary}.
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> datasource_tertiary@>

@q **** (4) datasource_tertiary: datasource_secondary@>
@*3 \datasource tertiary> $\longrightarrow$ \datasource secondary>.
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datasource_tertiary: datasource_secondary@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `datasource_tertiary: datasource_secondary'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = @=$1@>;

};

@q *** (3) datasource_expression.@>
@*2 {\bf datasource expression}.
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> datasource_expression@>

@q **** (4) datasource_expression: datasource_tertiary@>
@*3 \datasource expression> $\longrightarrow$ \datasource tertiary>.
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datasource_expression: datasource_tertiary@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `datasource_expression: datasource_tertiary'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = @=$1@>;

};

@q ** (2) @>


@q * (1) Emacs-Lisp code for use in indirect buffers.  LDF 2006.10.11.@>

@q (progn (outline-mode) (abbrev-mode t) (ignore '(                          @>
@q )) (setq outline-regexp (concat (char-to-string 64) "q [*\f]+")) (ignore'(@>
@q )) (make-variable-buffer-local 'outline-regexp))                          @>

@q * (1) Local Variables for Emacs  @>

@q Local Variables: @>
@q mode:Outline @>
@q abbrev-mode:t @>
@q eval:(setq outline-regexp (concat (char-to-string 64) "q [*\f]+")) @>
@q End: @>
