/* * (1) Copyright and License. */

/* This file is part of the LDF Metadata Exchange Utilities,             */
/* a package for metadata exchange.                                      */

/* Copyright (C) 2007 Laurence D. Finston   */

/* The author is Laurence D. Finston.  */

/* The LDF Metadata Exchange Utilities are free software;                   */
/* you can redistribute them and/or modify                                  */
/* them under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation; either version 2 of the License, or        */
/* (at your option) any later version.                                      */

/* The LDF Metadata Exchange Utilities are distributed in the hope               */
/* that they will be useful, but WITHOUT ANY WARRANTY; without even              */
/* the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  */
/* See the GNU General Public License for more details.                          */

/* You should have received a copy of the GNU General Public License                   */
/* along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  */
/* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          */

/* The LDF Metadata Exchange Utilities are available for downloading from the  */
/* following FTP server:                                                       */
/* ftp:/*ftp.gwdg.de/pub/gnu2/iwfmdh/                                          */

/* Please send bug reports to lfinsto1@gwdg.de  */

/* The author can be contacted at:  */

/* Laurence D. Finston  */
/* Kreuzbergring 41     */
/* D-37075 Goettingen   */
/* Germany              */

/* lfinsto1@gwdg.de                */
/* s246794@stud.uni-goettingen.de  */


/*28:*/
#line 569 "dtsrctyp.web"

/*2:*/
#line 96 "dtsrctyp.web"


#include "localldf.h" 

#ifdef NON_WIN_LDF 
#include "nonwin.h" 
#else 
#include "stdafx.h" 
#endif 

#include "parser.hxx" 

#include "dttmtype.h" 
#include "idtype.h" 
#include "scnrtype.h" 
#include "scanner.h" 



/*:2*/
#line 570 "dtsrctyp.web"

/*1:*/
#line 87 "dtsrctyp.web"


static char id_string[]
= "$Id: dtsrctyp.web,v 1.7 2007/02/13 20:38:06 lfinsto1 Exp $";



/*:1*/
#line 571 "dtsrctyp.web"

using namespace std;
using namespace Scan_Parse;
/*4:*/
#line 132 "dtsrctyp.web"


class Scanner_Type;
typedef Scanner_Type*Scanner_Node;

class Datasource_Type;
typedef Datasource_Type*Datasource_Node;

class Id_Type;
typedef Id_Type*Id_Node;


/*:4*/
#line 574 "dtsrctyp.web"

/*5:*/
#line 155 "dtsrctyp.web"


class
Datasource_Type;

typedef Datasource_Type*Datasource_Node;

class
Datasource_Type
{

/*6:*/
#line 197 "dtsrctyp.web"


friend
int
yyparse(void*);


/*:6*/
#line 166 "dtsrctyp.web"


private:

unsigned short type;

static map<unsigned short,string> datasource_type_map;

string name;

void*value;

Scanner_Node scanner_node;

public:

/*7:*/
#line 217 "dtsrctyp.web"


static const unsigned short DATASOURCE_TYPE_NULL_TYPE;
static const unsigned short DBT_TYPE;
static const unsigned short GBV_GVK_TYPE;
static const unsigned short TIMMS_TYPE;
static const unsigned short DATASOURCE_FILE_TYPE;

/*:7*//*10:*/
#line 261 "dtsrctyp.web"



/*:10*/
#line 182 "dtsrctyp.web"


/*13:*/
#line 285 "dtsrctyp.web"


Datasource_Type(void);

/*:13*//*15:*/
#line 310 "dtsrctyp.web"

int
set(unsigned short datasource_type,
Scanner_Node sscanner_node= 0);

/*:15*//*17:*/
#line 337 "dtsrctyp.web"

~Datasource_Type(void);


/*:17*//*21:*/
#line 399 "dtsrctyp.web"

Datasource_Node
operator= (const Datasource_Type&d);


/*:21*//*23:*/
#line 491 "dtsrctyp.web"

static
int
initialize_type_maps(void);

/*:23*//*25:*/
#line 525 "dtsrctyp.web"

int
show(string s= "`Datasource_Type':\n",
Scanner_Node sscanner_node= 0);


/*:25*/
#line 184 "dtsrctyp.web"


};


/*:5*/
#line 575 "dtsrctyp.web"

/*8:*/
#line 226 "dtsrctyp.web"


const unsigned short Datasource_Type::DATASOURCE_TYPE_NULL_TYPE= 0;
const unsigned short Datasource_Type::DBT_TYPE= 1;
const unsigned short Datasource_Type::GBV_GVK_TYPE= 2;
const unsigned short Datasource_Type::TIMMS_TYPE= 3;
const unsigned short Datasource_Type::DATASOURCE_FILE_TYPE= 4;


/*:8*/
#line 576 "dtsrctyp.web"

/*9:*/
#line 243 "dtsrctyp.web"


map<unsigned short,string> Datasource_Type::datasource_type_map;




/*:9*/
#line 577 "dtsrctyp.web"

/*14:*/
#line 290 "dtsrctyp.web"


Datasource_Type::Datasource_Type(void)
{

cerr<<"Entering `Datasource_Type::Datasource_Type(void)'."<<endl;

return;

}


/*:14*//*16:*/
#line 316 "dtsrctyp.web"

int
Datasource_Type::set(unsigned short datasource_type,
Scanner_Node sscanner_node)
{

return 0;

}


/*:16*//*18:*/
#line 342 "dtsrctyp.web"

Datasource_Type::~Datasource_Type(void)
{



#if 0   
#define DEBUG_OUTPUT  
#else 
#undef DEBUG_OUTPUT 
#endif  

stringstream temp_strm;

#ifdef DEBUG_OUTPUT  
temp_strm<<"Entering `Datasource_Type' destructor."<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");
#endif  


/*:18*//*19:*/
#line 366 "dtsrctyp.web"


#ifdef DEBUG_OUTPUT  
temp_strm<<"Exiting `Datasource_Type' destructor."<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");
#endif  


/*:19*//*20:*/
#line 380 "dtsrctyp.web"


scanner_node= 0;

return;

}




/*:20*//*22:*/
#line 405 "dtsrctyp.web"

Datasource_Node
Datasource_Type::operator= (const Datasource_Type&d)
{


#if 0   
#define DEBUG_OUTPUT  
#else 
#undef DEBUG_OUTPUT 
#endif  

stringstream temp_strm;

scanner_node= d.scanner_node;

#ifdef DEBUG_OUTPUT  
temp_strm<<"Entering `Datasource_Type::operator=(const Datasource_Type)'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

#endif  

if(this==&d)
{
#ifdef DEBUG_OUTPUT  
temp_strm<<"In `Datasource_Type::operator=(const Datasource_Type)':"
<<endl
<<"Self-assignment.  Returning `this'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

#endif  



return this;

}



type= d.type;




#ifdef DEBUG_OUTPUT  
temp_strm<<"Exiting `Datasource_Type::operator=(const Datasource_Type)'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

#endif  

return this;

}


/*:22*//*24:*/
#line 497 "dtsrctyp.web"

int
Datasource_Type::initialize_type_maps(void)
{

datasource_type_map[DATASOURCE_TYPE_NULL_TYPE]= "DATASOURCE_TYPE_NULL_TYPE";
datasource_type_map[DBT_TYPE]= "DBT_TYPE";
datasource_type_map[GBV_GVK_TYPE]= "GBV_GVK_TYPE";
datasource_type_map[TIMMS_TYPE]= "TIMMS_TYPE";
datasource_type_map[DATASOURCE_FILE_TYPE]= "DATASOURCE_FILE_TYPE";

return 0;

}




/*:24*//*26:*/
#line 532 "dtsrctyp.web"

int
Datasource_Type::show(string s,
Scanner_Node sscanner_node)

{
stringstream temp_strm;


if(scanner_node==0&&sscanner_node!=0)
scanner_node= sscanner_node;

temp_strm<<s
<<endl
<<"`type' == "<<datasource_type_map[type]
<<" ("<<type<<")"
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");

if(scanner_node!=0&&scanner_node->log_strm.is_open())
scanner_node->log_strm<<temp_strm;

return 0;

}


/*:26*/
#line 578 "dtsrctyp.web"




/*:28*/
