@q dttmexp.w@>
@q Created by Laurence D. Finston (LDF) 2006.12.15.@>

@q $Id: dttmexp.w,v 1.5 2007/02/13 20:38:33 lfinsto1 Exp $ @>

@q * (1) Copyright and License. @>

@q This file is part of the LDF Metadata Exchange Utilities,            @>
@q a package for metadata exchange.                                     @>
@q It contains code from the the IWF Metadata Harvester, a package for  @>
@q metadata harvesting.                                                 @> 

@q The following copyright notice applies to the contents of this file up to  @>      
@q and including January 31, 2007:                                            @> 

@q Copyright (C) 2006, 2007 IWF Wissen und Medien gGmbH  @>

@q The following copyright notice applies to all changes and additions to this file  @>      
@q starting on February 1, 2007:                                                     @> 

@q Copyright (C) 2007 Laurence D. Finston  @>

@q The state of this file as of January 31, 2007 is stored in the  	  @>    
@q revision of this file with the symbolic tag "LAST_IWF"          	  @>
@q in the CVS repository for the LDF Metadata Exchange Utilities:  	  @>
@q http://cvs.savannah.nongnu.org/viewcvs/iwf-mdh/?root=iwf-mdh    	  @>
@q If necessary, changes and additions after this date can be determined  @>
@q by comparing this revision with later ones using the GNU diffutils:    @>
@q http://www.gnu.org/software/diffutils/diffutils.html                   @>

@q The author is Laurence D. Finston.  @>

@q The LDF Metadata Exchange Utilities are free software;                  @>
@q you can redistribute them and/or modify                                 @>
@q them under the terms of the GNU General Public License as published by  @>
@q the Free Software Foundation; either version 2 of the License, or       @>
@q (at your option) any later version.                                     @>

@q The LDF Metadata Exchange Utilities are distributed in the hope               @>          
@q that they will be useful, but WITHOUT ANY WARRANTY; without even              @>
@q the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  @>
@q See the GNU General Public License for more details.                          @>

@q You should have received a copy of the GNU General Public License                   @>
@q along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  @>
@q Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          @>

@q The LDF Metadata Exchange Utilities are available for downloading from the @>
@q following FTP server:                                                      @>
@q ftp://ftp.gwdg.de/pub/gnu2/iwfmdh/                                         @>

@q "@@" stands for a single "at"-sign in the following email adresses.  @>

@q Please send bug reports to lfinsto1@@gwdg.de  @>

@q The author can be contacted at: @>

@q Laurence D. Finston @>
@q Kreuzbergring 41    @>
@q D-37075 Goettingen  @>
@q Germany             @>

@q lfinsto1@@gwdg.de               @>
@q s246794@@stud.uni-goettingen.de @>




@q ** (2) Datetime expressions.@>
@*1 Datetime expressions (\filename{dttmexp.w}).
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this file.
\ENDLOG

@
@<\filename{dttmexp.w}@>=
static char dttmexp_id_string[] 
   = "$Id: dttmexp.w,v 1.5 2007/02/13 20:38:33 lfinsto1 Exp $"; 

@q *** (3) datetime_primary.@>
@*2 {\bf datetime primary}.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> datetime_primary@>





@q **** (4) datetime_primary: datetime_variable@>
@*3 \datetime primary> $\longrightarrow$ \datetime variable>.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datetime_primary: datetime_variable@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `datetime_primary: datetime_variable'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    Id_Node curr_id_node = static_cast<Id_Node>(@=$1@>);

    if (curr_id_node && curr_id_node->value) 
    {
       Date_Time_Node curr_datetime_node = new Date_Time_Type;

       *curr_datetime_node = *static_cast<Date_Time_Node>(curr_id_node->value);

       @=$$@> = static_cast<void*>(curr_datetime_node); 
    }
    else 
       @=$$@> = 0;


#ifdef DEBUG_OUTPUT 
    temp_strm << endl 
              << "Exiting rule `datetime_primary: datetime_variable'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

};

@q **** (4) datetime_primary: OPEN_PARENTHESIS datetime_expression CLOSE_PARENTHESIS@>
@*3 \datetime primary> $\longrightarrow$ \.{(} \datetime expression> \.{)}.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datetime_primary: OPEN_PARENTHESIS datetime_expression CLOSE_PARENTHESIS@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `datetime_primary: OPEN_PARENTHESIS "
              << "datetime_expression CLOSE_PARENTHESIS'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    Date_Time_Node q = static_cast<Date_Time_Node>(@=$2@>);

    @=$$@> = @=$2@>;

};

@q **** (4) datetime_primary: datetime_element_list.@>
@*3 \datetime primary> $\longrightarrow$ \datetime element list>. 
\initials{LDF 2006.12.18.}

\LOG
\initials{LDF 2006.12.18.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datetime_primary: datetime_element_list@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `datetime_primary: datetime_element_list."
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    Date_Time_Node d = 0;

    datetime_assignment_func_1(scanner_node, 
                               d, 
                               ASSIGN, 
                               @=$1@>);


    @=$$@> = static_cast<void*>(d);

};

@q *** (3) datetime_secondary.@>
@*2 {\bf datetime secondary}.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> datetime_secondary@>

@q **** (4) datetime_secondary: datetime_primary@>
@*3 \datetime secondary> $\longrightarrow$ \datetime primary>.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datetime_secondary: datetime_primary@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `datetime_secondary: datetime_primary'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = @=$1@>;

};

@q *** (3) datetime_tertiary.@>
@*2 {\bf datetime tertiary}.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> datetime_tertiary@>

@q **** (4) datetime_tertiary: datetime_secondary@>
@*3 \datetime tertiary> $\longrightarrow$ \datetime secondary>.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datetime_tertiary: datetime_secondary@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `datetime_tertiary: datetime_secondary'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = @=$1@>;

};

@q *** (3) datetime_expression.@>
@*2 {\bf datetime expression}.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> datetime_expression@>

@q **** (4) datetime_expression: datetime_tertiary@>
@*3 \datetime expression> $\longrightarrow$ \datetime tertiary>.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datetime_expression: datetime_tertiary@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `datetime_expression: datetime_tertiary'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = @=$1@>;

};

@q **** (4) @>

@q *** (3) Datetime element list.@>
@*2 Datetime element list.
\initials{LDF 2006.12.18.}

\LOG
\initials{LDF 2006.12.18.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> datetime_element_list@>

@q **** (4) datetime_element_list: INTEGER COLON INTEGER.@>
@*3 \datetime element list> $\longrightarrow$ \.{INTEGER} \.{COLON} \.{INTEGER}.
\initials{LDF 2006.12.18.}

\LOG
\initials{LDF 2006.12.18.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datetime_element_list: INTEGER COLON@>
{

@q ****** (6) @>

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);


    temp_strm << endl 
              << "Rule `datetime_element_list: INTEGER COLON INTEGER'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    vector<pair<int, void*> >* v = new vector<pair<int, void*> >;
    
    int* i = new int(@=$1@>);

    v->push_back(make_pair(INTEGER, static_cast<void*>(i))); 

    @=$$@> = static_cast<void*>(v);

};

@q **** (4) datetime_element_list: FLOAT COLON@>
@*3 \datetime element list> $\longrightarrow$ \.{FLOAT} \.{COLON}.
\initials{LDF 2006.12.18.}

\LOG
\initials{LDF 2006.12.18.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datetime_element_list: FLOAT COLON@>
{

@q ****** (6) @>

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);


    temp_strm << endl 
              << "Rule `datetime_element_list: FLOAT COLON'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    vector<pair<int, void*> >* v = new vector<pair<int, void*> >;
    
    float* f = new float(@=$1@>);

    v->push_back(make_pair(FLOAT, static_cast<void*>(f))); 

    @=$$@> = static_cast<void*>(v);

};


@q **** (4) datetime_element_list: datetime_element_list INTEGER COLON@>
@*3 \datetime element list> $\longrightarrow$ \datetime element list> 
\.{COLON} \.{INTEGER}.
\initials{LDF 2006.12.18.}

\LOG
\initials{LDF 2006.12.18.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datetime_element_list: datetime_element_list INTEGER COLON@>
{

@q ****** (6) @>

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);


    temp_strm << endl 
              << "Rule `datetime_element_list: datetime_element_list "
              << "INTEGER COLON'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 


    vector<pair<int, void*> >* v 
       = static_cast<vector<pair<int, void*> >*>(@=$1@>);
    
    int* i = new int(@=$2@>);

    v->push_back(make_pair(INTEGER, static_cast<void*>(i))); 

    @=$$@> = static_cast<void*>(v);

};


@q **** (4) datetime_element_list: datetime_element_list FLOAT COLON@>
@*3 \datetime element list> $\longrightarrow$ \datetime element list> 
\.{FLOAT} \.{COLON}.
\initials{LDF 2006.12.18.}

\LOG
\initials{LDF 2006.12.18.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datetime_element_list: datetime_element_list FLOAT COLON@>
{

@q ****** (6) @>

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);


    temp_strm << endl 
              << "Rule `datetime_element_list: datetime_element_list "
              << "FLOAT COLON'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    vector<pair<int, void*> >* v 
       = static_cast<vector<pair<int, void*> >*>(@=$1@>);
    
    float* f = new float(@=$2@>);

    v->push_back(make_pair(FLOAT, static_cast<void*>(f))); 

    @=$$@> = static_cast<void*>(v);

};


@q *** (3) @>

@q ** (2) @>

@q * (1) Emacs-Lisp code for use in indirect buffers.  LDF 2006.10.11.@>

@q (progn (outline-mode) (abbrev-mode t) (ignore '(                          @>
@q )) (setq outline-regexp (concat (char-to-string 64) "q [*\f]+")) (ignore'(@>
@q )) (make-variable-buffer-local 'outline-regexp))                          @>

@q * (1) Local Variables for Emacs  @>

@q Local Variables: @>
@q mode:Outline @>
@q abbrev-mode:t @>
@q eval:(setq outline-regexp (concat (char-to-string 64) "q [*\f]+")) @>
@q End: @>
