/* * (1) Copyright and License. */

/* This file is part of the LDF Metadata Exchange Utilities,             */
/* a package for metadata exchange.                                      */

/* Copyright (C) 2007 Laurence D. Finston   */

/* The author is Laurence D. Finston.  */

/* The LDF Metadata Exchange Utilities are free software;                   */
/* you can redistribute them and/or modify                                  */
/* them under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation; either version 2 of the License, or        */
/* (at your option) any later version.                                      */

/* The LDF Metadata Exchange Utilities are distributed in the hope               */
/* that they will be useful, but WITHOUT ANY WARRANTY; without even              */
/* the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  */
/* See the GNU General Public License for more details.                          */

/* You should have received a copy of the GNU General Public License                   */
/* along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  */
/* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          */

/* The LDF Metadata Exchange Utilities are available for downloading from the  */
/* following FTP server:                                                       */
/* ftp:/*ftp.gwdg.de/pub/gnu2/iwfmdh/                                          */

/* Please send bug reports to lfinsto1@gwdg.de  */

/* The author can be contacted at:  */

/* Laurence D. Finston  */
/* Kreuzbergring 41     */
/* D-37075 Goettingen   */
/* Germany              */

/* lfinsto1@gwdg.de                */
/* s246794@stud.uni-goettingen.de  */


/*19:*/
#line 849 "dttmtype.web"

/*2:*/
#line 90 "dttmtype.web"


#include "localldf.h" 

#ifdef NON_WIN_LDF 
#include "nonwin.h" 
#else 
#include "stdafx.h" 
#endif 


#include "parser.hxx" 



/*:2*/
#line 850 "dttmtype.web"

/*1:*/
#line 81 "dttmtype.web"


static char id_string[]
= "$Id: dttmtype.web,v 1.6 2007/02/13 20:38:51 lfinsto1 Exp $";



/*:1*/
#line 851 "dttmtype.web"

using namespace std;
/*4:*/
#line 117 "dttmtype.web"


class Query_Type;

class Date_Time_Type;

typedef Date_Time_Type*Date_Time_Node;


namespace Scan_Parse
{
int
datetime_assignment_func_0(void*v,
Date_Time_Node&curr_date_time_node,
int specifier,
int op,
void*val,
int type);

int
datetime_assignment_func_1(void*v,
Date_Time_Node&d,
int op,
void*&vec);

};




/*:4*/
#line 853 "dttmtype.web"

/*5:*/
#line 166 "dttmtype.web"



class
Date_Time_Type
{
friend class Query_Type;

friend
int
Scan_Parse::datetime_assignment_func_0(void*v,
Date_Time_Node&curr_date_time_node,
int specifier,
int op,
void*val,
int type);
friend
int
Scan_Parse::datetime_assignment_func_1(void*v,
Date_Time_Node&d,
int op,
void*&vec);


friend int yyparse(void*);

friend
ostream&
operator<<(ostream&o,Date_Time_Type&d);


short*year_range_begin;
short*year_range_end;
short*year;
unsigned short*month;
unsigned short*day;
unsigned short*hour;
unsigned short*minute;
float*second;

public:

/*8:*/
#line 239 "dttmtype.web"

Date_Time_Type(void);

/*:8*//*10:*/
#line 271 "dttmtype.web"

~Date_Time_Type(void);

/*:10*//*12:*/
#line 311 "dttmtype.web"

Date_Time_Node
operator= (const Date_Time_Type&d);


/*:12*//*16:*/
#line 724 "dttmtype.web"

int
show(string s= "`Date_Time_Type:'");



/*:16*/
#line 208 "dttmtype.web"


};


/*:5*/
#line 854 "dttmtype.web"

/*14:*/
#line 585 "dttmtype.web"


ostream&operator<<(ostream&o,Date_Time_Type&d);

/*:14*/
#line 855 "dttmtype.web"

/*9:*/
#line 243 "dttmtype.web"

Date_Time_Type::Date_Time_Type(void)
{

year_range_begin= 0;
year_range_end= 0;
year= 0;
month= 0;
day= 0;
hour= 0;
minute= 0;
second= 0;

return;

}




/*:9*//*11:*/
#line 275 "dttmtype.web"

Date_Time_Type::~Date_Time_Type(void)
{

delete year_range_begin;

delete year_range_end;

delete year;

delete month;

delete day;

delete hour;

delete minute;

delete second;

return;

}



/*:11*//*13:*/
#line 317 "dttmtype.web"

Date_Time_Node
Date_Time_Type::operator= (const Date_Time_Type&d)
{



#if 0   
#define DEBUG_OUTPUT  
#else 
#undef DEBUG_OUTPUT 
#endif  

stringstream temp_strm;

#ifdef DEBUG_OUTPUT  
temp_strm<<"Entering `Date_Time_Type' assignment operator."<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");
#endif  



if(this==&d)
{
#ifdef DEBUG_OUTPUT  
temp_strm<<"In `Date_Time_Type::operator=(const Date_Time_Type&)':"
<<endl
<<"Self-assignment.  Returning `this'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");
#endif  
return this;

}





if(year_range_begin&&d.year_range_begin)
{
*year_range_begin= *d.year_range_begin;
}




else if(year_range_begin&&!d.year_range_begin)
{
delete year_range_begin;
year_range_begin= 0;
}



else if(!year_range_begin&&d.year_range_begin)
{
year_range_begin= new short(*d.year_range_begin);
}





if(year_range_end&&d.year_range_end)
{
*year_range_end= *d.year_range_end;
}




else if(year_range_end&&!d.year_range_end)
{
delete year_range_end;
year_range_end= 0;
}



else if(!year_range_end&&d.year_range_end)
{
year_range_end= new short(*d.year_range_end);
}





if(year&&d.year)
{
*year= *d.year;
}




else if(year&&!d.year)
{
delete year;
year= 0;
}



else if(!year&&d.year)
{
year= new short(*d.year);
}





if(month&&d.month)
{
*month= *d.month;
}




else if(month&&!d.month)
{
delete month;
month= 0;
}



else if(!month&&d.month)
{
month= new unsigned short(*d.month);
}





if(day&&d.day)
{
*day= *d.day;
}




else if(day&&!d.day)
{
delete day;
day= 0;
}



else if(!day&&d.day)
{
day= new unsigned short(*d.day);
}





if(hour&&d.hour)
{
*hour= *d.hour;
}




else if(hour&&!d.hour)
{
delete hour;
hour= 0;
}



else if(!hour&&d.hour)
{
hour= new unsigned short(*d.hour);
}





if(minute&&d.minute)
{
*minute= *d.minute;
}




else if(minute&&!d.minute)
{
delete minute;
minute= 0;
}



else if(!minute&&d.minute)
{
minute= new unsigned short(*d.minute);
}





if(second&&d.second)
{
*second= *d.second;
}




else if(second&&!d.second)
{
delete second;
second= 0;
}



else if(!second&&d.second)
{
second= new float(*d.second);
}



#ifdef DEBUG_OUTPUT  
temp_strm<<"Exiting `Date_Time_Type' assignment operator."<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");
#endif  

return this;


}



/*:13*//*17:*/
#line 731 "dttmtype.web"

int
Date_Time_Type::show(string s)
{



stringstream temp_strm;



temp_strm<<s<<endl<<"`year_range_begin'  == ";

if(year_range_begin==0)
temp_strm<<"NULL";
else
temp_strm<<*static_cast<short*> (year_range_begin);

temp_strm<<endl;



temp_strm<<"`year_range_end'  == ";

if(year_range_end==0)
temp_strm<<"NULL";
else
temp_strm<<*static_cast<short*> (year_range_end);

temp_strm<<endl;




temp_strm<<"`year'  == ";

if(year==0)
temp_strm<<"NULL";
else
temp_strm<<*static_cast<short*> (year);

temp_strm<<endl;



temp_strm<<"`month'  == ";

if(month==0)
temp_strm<<"NULL";
else
temp_strm<<*static_cast<unsigned short*> (month);

temp_strm<<endl;



temp_strm<<"`day'  == ";

if(day==0)
temp_strm<<"NULL";
else
temp_strm<<*static_cast<unsigned short*> (day);

temp_strm<<endl;



temp_strm<<"`hour'  == ";

if(hour==0)
temp_strm<<"NULL";
else
temp_strm<<*static_cast<unsigned short*> (hour);

temp_strm<<endl;



temp_strm<<"`minute'  == ";

if(minute==0)
temp_strm<<"NULL";
else
temp_strm<<*static_cast<unsigned short*> (minute);

temp_strm<<endl;



temp_strm<<"`second'  == ";

if(second==0)
temp_strm<<"NULL";
else
temp_strm<<*static_cast<float*> (second);

temp_strm<<endl;



cerr<<temp_strm.str();
temp_strm.str("");

return 0;

}






/*:17*/
#line 856 "dttmtype.web"

/*15:*/
#line 590 "dttmtype.web"

ostream&
operator<<(ostream&o,Date_Time_Type&d)
{



#if 0   
#define DEBUG_OUTPUT  
#else 
#undef DEBUG_OUTPUT 
#endif  

stringstream temp_strm;

#ifdef DEBUG_OUTPUT  
temp_strm<<"Entering `Date_Time_Type' output operator."<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");
#endif  






o<<"year_range_begin == ";

if(d.year_range_begin)
o<<*d.year_range_begin;
else
o<<"NULL";
o<<endl;



o<<"year_range_end == ";

if(d.year_range_end)
o<<*d.year_range_end;
else
o<<"NULL";
o<<endl;



o<<"year == ";

if(d.year)
o<<*d.year;
else
o<<"NULL";
o<<endl;




o<<"month == ";

if(d.month)
o<<*d.month;
else
o<<"NULL";
o<<endl;




o<<"day == ";

if(d.day)
o<<*d.day;
else
o<<"NULL";
o<<endl;




o<<"hour == ";

if(d.hour)
o<<*d.hour;
else
o<<"NULL";
o<<endl;




o<<"minute == ";

if(d.minute)
o<<*d.minute;
else
o<<"NULL";
o<<endl;



o<<"second == ";

if(d.second)
o<<*d.second;
else
o<<"NULL";
o<<endl;





return o;

}







/*:15*/
#line 857 "dttmtype.web"




/*:19*/
