/* * (1) Copyright and License. */

/* This file is part of the LDF Metadata Exchange Utilities,             */
/* a package for metadata exchange.                                      */

/* Copyright (C) 2007 Laurence D. Finston   */

/* The author is Laurence D. Finston.  */

/* The LDF Metadata Exchange Utilities are free software;                   */
/* you can redistribute them and/or modify                                  */
/* them under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation; either version 2 of the License, or        */
/* (at your option) any later version.                                      */

/* The LDF Metadata Exchange Utilities are distributed in the hope               */
/* that they will be useful, but WITHOUT ANY WARRANTY; without even              */
/* the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  */
/* See the GNU General Public License for more details.                          */

/* You should have received a copy of the GNU General Public License                   */
/* along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  */
/* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          */

/* The LDF Metadata Exchange Utilities are available for downloading from the  */
/* following FTP server:                                                       */
/* ftp:/*ftp.gwdg.de/pub/gnu2/iwfmdh/                                          */

/* Please send bug reports to lfinsto1@gwdg.de  */

/* The author can be contacted at:  */

/* Laurence D. Finston  */
/* Kreuzbergring 41     */
/* D-37075 Goettingen   */
/* Germany              */

/* lfinsto1@gwdg.de                */
/* s246794@stud.uni-goettingen.de  */


/*24:*/
#line 507 "idtype.web"

/*2:*/
#line 90 "idtype.web"


#include "localldf.h" 

#ifdef NON_WIN_LDF 
#include "nonwin.h" 
#else 
#include "stdafx.h" 
#endif 

#include "dttmtype.h" 
#include "parser.hxx" 
#include "scnrtype.h" 
#include "querytyp.h" 



/*:2*/
#line 508 "idtype.web"

/*1:*/
#line 81 "idtype.web"


static char id_string[]
= "$Id: idtype.web,v 1.6 2007/02/13 20:39:05 lfinsto1 Exp $";



/*:1*/
#line 509 "idtype.web"

using namespace std;
/*4:*/
#line 119 "idtype.web"


class Scanner_Type;
typedef Scanner_Type*Scanner_Node;

struct Id_Type;
typedef Id_Type*Id_Node;


/*:4*/
#line 511 "idtype.web"

/*5:*/
#line 139 "idtype.web"

struct
Id_Type
{
friend class Scanner_Type;

string name;
void*value;
unsigned short type;
unsigned short subtype;

Id_Node up;
Id_Node left;
Id_Node right;

static map<unsigned short,string> subtype_map;

Scanner_Node scanner_node;

/*12:*/
#line 247 "idtype.web"

Id_Type(void);

/*:12*//*15:*/
#line 282 "idtype.web"

~Id_Type(void);


/*:15*//*18:*/
#line 358 "idtype.web"

static
int
initialize_subtype_map(Scanner_Node s= 0);


/*:18*//*21:*/
#line 433 "idtype.web"

int
show(string= "");


/*:21*/
#line 158 "idtype.web"

/*6:*/
#line 175 "idtype.web"


static const unsigned short TEX_STRING_TYPE;
static const unsigned short SQL_STRING_TYPE;
static const unsigned short PQF_STRING_TYPE;



/*:6*/
#line 159 "idtype.web"


};


/*:5*/
#line 512 "idtype.web"

/*7:*/
#line 192 "idtype.web"


const unsigned short Id_Type::TEX_STRING_TYPE= 1;
const unsigned short Id_Type::SQL_STRING_TYPE= 2;
const unsigned short Id_Type::PQF_STRING_TYPE= 3;


/*:7*/
#line 513 "idtype.web"

/*8:*/
#line 212 "idtype.web"


map<unsigned short,string> Id_Type::subtype_map;


/*:8*/
#line 514 "idtype.web"

/*13:*/
#line 251 "idtype.web"

Id_Type::Id_Type(void)
{
name= "";
value= 0;
type= 0;
subtype= 0;

up= 0;
left= 0;
right= 0;

scanner_node= 0;

return;

}



/*:13*//*16:*/
#line 287 "idtype.web"

Id_Type::~Id_Type(void)
{



#if 0   
#define DEBUG_OUTPUT  
#else 
#undef DEBUG_OUTPUT 
#endif  

stringstream temp_strm;

#ifdef DEBUG_OUTPUT  
temp_strm<<"Entering `~Id_Type'."<<endl
<<"`name' == `"<<name<<"'"
<<endl
<<"`type' == `"<<Scan_Parse::token_map[type]<<"'"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif  



if(type==QUERY_TYPE)
{
delete static_cast<Query_Node> (value);
value= 0;
}

delete left;
delete right;




#ifdef DEBUG_OUTPUT  
temp_strm<<"Exiting `~Id_Type'."<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif  

return;

#undef DEBUG_OUTPUT 

}



/*:16*//*19:*/
#line 365 "idtype.web"

int
Id_Type::initialize_subtype_map(Scanner_Node s)
{



#if 0   
#define DEBUG_OUTPUT  
#else 
#undef DEBUG_OUTPUT 
#endif  

stringstream temp_strm;





#ifdef DEBUG_OUTPUT  
temp_strm<<"Entering `Id_Type::initialize_subtype_map'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(s!=0)
s->log_strm<<temp_strm.str();
temp_strm.str("");
#endif  



Id_Type::subtype_map[TEX_STRING_TYPE]= "TEX_STRING_TYPE";
Id_Type::subtype_map[SQL_STRING_TYPE]= "SQL_STRING_TYPE";
Id_Type::subtype_map[PQF_STRING_TYPE]= "PQF_STRING_TYPE";



#ifdef DEBUG_OUTPUT  
temp_strm<<"Exiting `Id_Type::initialize_subtype_map'."<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(s!=0)
s->log_strm<<temp_strm.str();
temp_strm.str("");
#endif  

return 0;

#undef DEBUG_OUTPUT 

}




/*:19*//*22:*/
#line 439 "idtype.web"

int
Id_Type::show(string s)
{



#if 0   
#define DEBUG_OUTPUT  
#else 
#undef DEBUG_OUTPUT 
#endif  

stringstream temp_strm;



if(s=="")
s= "`Id_Type:'";

temp_strm<<s<<endl
<<"`name' == `"<<name<<"'"
<<endl
<<"`type' == `"<<Scan_Parse::token_map[type]<<"'"
<<endl
<<"`subtype' == "<<subtype_map[subtype]
<<endl;

if(value==0)
temp_strm<<"`value'  == 0"<<endl;
else
temp_strm<<"`value'  != 0"<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");



#ifdef DEBUG_OUTPUT  
temp_strm<<"Exiting `Id_Type::show'."<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif  

return 0;

#undef DEBUG_OUTPUT 

}





/*:22*/
#line 515 "idtype.web"




/*:24*/
