/* * (1) Copyright and License. */

/* This file is part of the LDF Metadata Exchange Utilities,             */
/* a package for metadata exchange.                                      */

/* Copyright (C) 2007 Laurence D. Finston   */

/* The author is Laurence D. Finston.  */

/* The LDF Metadata Exchange Utilities are free software;                   */
/* you can redistribute them and/or modify                                  */
/* them under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation; either version 2 of the License, or        */
/* (at your option) any later version.                                      */

/* The LDF Metadata Exchange Utilities are distributed in the hope               */
/* that they will be useful, but WITHOUT ANY WARRANTY; without even              */
/* the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  */
/* See the GNU General Public License for more details.                          */

/* You should have received a copy of the GNU General Public License                   */
/* along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  */
/* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          */

/* The LDF Metadata Exchange Utilities are available for downloading from the  */
/* following FTP server:                                                       */
/* ftp:/*ftp.gwdg.de/pub/gnu2/iwfmdh/                                          */

/* Please send bug reports to lfinsto1@gwdg.de  */

/* The author can be contacted at:  */

/* Laurence D. Finston  */
/* Kreuzbergring 41     */
/* D-37075 Goettingen   */
/* Germany              */

/* lfinsto1@gwdg.de                */
/* s246794@stud.uni-goettingen.de  */


/*17:*/
#line 489 "main.web"

/*2:*/
#line 84 "main.web"


#include "localldf.h"
#include "nonwin.h"

#include "parser.hxx"
#include "dttmtype.h"
#include "scanner.h"
#include "dtsrctyp.h"
#include "querytyp.h"
#include "idtype.h"
#include "scnrtype.h"

#include "dbcrprsr.hxx"
#include "dbcrscan.hxx"


/*:2*/
#line 490 "main.web"

/*1:*/
#line 79 "main.web"

static char id_string[]
= "$Id: main.web,v 1.12 2007/02/13 20:39:20 lfinsto1 Exp $";

/*:1*/
#line 491 "main.web"

using namespace std;
/*3:*/
#line 119 "main.web"


Mutex_Type cerr_mutex;
Mutex_Type cout_mutex;

Mutex_Type time_mutex;

ofstream tex_file_strm;
Mutex_Type tex_mutex;
unsigned short tex_file_ctr;
string tex_filename_str;
string copyright_tex_str;


/*:3*/
#line 493 "main.web"

/*5:*/
#line 141 "main.web"

int
yyparse(void*);


/*:5*//*6:*/
#line 147 "main.web"

#if 0
int
yywrap(void);
#endif


/*:6*//*7:*/
#line 157 "main.web"

void
yyerror(const char*s);

/*:7*//*9:*/
#line 174 "main.web"

int
xxparse(void*);


/*:9*//*10:*/
#line 182 "main.web"

void
xxerror(const char*s);

/*:10*/
#line 494 "main.web"

/*12:*/
#line 217 "main.web"

int
main(int argc,char*argv[])
{

FILE*fp= fopen("oai.xml","r");

yyscan_t scanner;

xxlex_init(&scanner);

xxset_in(fp,scanner);

YYSTYPE*i= new YYSTYPE;

xxparse(static_cast<void*> (scanner));

xxlex_destroy(scanner);


return 0;


#if 0 

unsigned long long temp_val= 4096LL;

bitset<64> b;

b.flip();

cerr<<"`b' == "<<b<<endl
<<"`temp_val' == "<<temp_val
<<"b & temp_val == "<<(b&temp_val)
<<endl;
getchar();

cerr<<"`sizeof(unsigned long long)' == "<<sizeof(unsigned long long)
<<endl
<<"`ULONG_LONG_MAX' == "<<ULONG_LONG_MAX<<endl;
getchar();

for(int i= 27;i<36;++i)
cerr<<(long long)pow((double)2,i)<<"\n";
getchar();

#endif


#if 0 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif

copyright_tex_str= "%% * (1) Copyright and License.\n\n";

copyright_tex_str+= "%% This file is part of the IWF Metadata Harvester, ";
copyright_tex_str+= "a package for metadata harvesting.\n";
copyright_tex_str+= "%% Copyright (C) 2006, 2007 IWF Wissen und Medien ";
copyright_tex_str+= "gGmbH\n\n";
copyright_tex_str+= "%% The author is Laurence D. Finston.\n\n";

copyright_tex_str+= "%% The IWF Metadata Harvester is free software; ";
copyright_tex_str+= "you can redistribute it and/or modify\n";
copyright_tex_str+= "%% it under the terms of the GNU General Public License ";
copyright_tex_str+= "as published by\n";
copyright_tex_str+= "%% the Free Software Foundation; either version 2 of the ";
copyright_tex_str+= "License, or\n";
copyright_tex_str+= "%% (at your option) any later version.\n\n";

copyright_tex_str+= "%% The IWF Metadata Harvester is distributed in ";
copyright_tex_str+= "the hope that it will be useful,\n";
copyright_tex_str+= "%% but WITHOUT ANY WARRANTY; without even the implied ";
copyright_tex_str+= "warranty of\n";
copyright_tex_str+= "%% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  ";
copyright_tex_str+= "See the\n";
copyright_tex_str+= "%% GNU General Public License for more details.\n\n";

copyright_tex_str+= "%% You should have received a copy of the GNU General ";
copyright_tex_str+= "Public License\n";
copyright_tex_str+= "%% along with the IWF Metadata Harvester; if not, ";
copyright_tex_str+= "write to the Free Software\n";
copyright_tex_str+= "%% Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  ";
copyright_tex_str+= "02110-1301  USA\n\n";

copyright_tex_str+= "%% The IWF Metadata Harvester is available for downloading from the\n";
copyright_tex_str+= "%% following FTP server:\n";
copyright_tex_str+= "%% ftp://ftp.gwdg.de/pub/gnu2/iwfmdh/\n\n";

copyright_tex_str+= "%% Please send bug reports to lfinsto1@gwdg.de\n\n";

copyright_tex_str+= "%% The author can be contacted at:\n\n";

copyright_tex_str+= "%% Laurence D. Finston\n";
copyright_tex_str+= "%% Kreuzbergring 41\n";
copyright_tex_str+= "%% D-37075 Goettingen\n";
copyright_tex_str+= "%% Germany\n\n";
copyright_tex_str+= "%% lfinsto1@gwdg.de\n";
copyright_tex_str+= "%% s246794@stud.uni-goettingen.de\n";
copyright_tex_str+= "\n\n";

using namespace Scan_Parse;

stringstream temp_strm;

int status;

status= initialize_maps();

status= Query_Type::initialize_type_maps();



if((status= Query_Type::initialize_flags())!=0)
{
cerr<<"ERROR! In `main':"
<<endl
<<"`Query_Type::initialize_flags' returned unsuccessfully, "
<<"with return value "<<status
<<endl
<<"Exiting `main' unsuccessfully with return value 1."
<<endl;

return 1;
}



status= Datasource_Type::initialize_type_maps();

tex_file_ctr= 0;
tex_filename_str= "scttex_";



Scanner_Type*scanner_node= new Scanner_Type;

status= Id_Type::initialize_subtype_map(scanner_node);


/*:12*//*13:*/
#line 369 "main.web"


for(int curr_opt= 0;curr_opt>=0;)
{
curr_opt= getopt(argc,argv,"b");

#ifdef DEBUG_OUTPUT
temp_strm<<"`curr_opt'  == "<<curr_opt<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



switch(curr_opt)
{



case'b':
yydebug= 1;
break;



default:
break;



}




}



/*:13*//*14:*/
#line 419 "main.web"


#if 0 
#ifdef DEBUG_OUTPUT

temp_strm<<"`argc' == "<<argc<<", `optind' == "<<optind<<endl;

if(argv[optind]==0)
temp_strm<<"No filename argument.";
else
temp_strm<<"Filename argument == `"<<argv[optind]<<"'";

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
getchar();
#endif
#endif

if(argc> optind)
{
strcpy(scanner_node->in_filename,argv[optind]);
}
else
strcpy(scanner_node->in_filename,"commands.txt");

scanner_node->in_strm.open(scanner_node->in_filename);



strcpy(scanner_node->log_filename,"log_1.txt");
scanner_node->log_strm.open(scanner_node->log_filename);
scanner_node->log_strm<<"%% log_1.txt"
<<endl<<endl
<<copyright_tex_str
<<endl;



/*:14*//*15:*/
#line 461 "main.web"


scanner_node->initialize_id_map();

#ifdef DEBUG_OUTPUT
status= show_keyword_map(scanner_node);
#endif

status= yyparse(scanner_node);



delete scanner_node;
scanner_node= 0;

return 0;

#undef DEBUG_OUTPUT

}



/*:15*/
#line 495 "main.web"

/*8:*/
#line 162 "main.web"

void
yyerror(const char*s)
{
return;
}



/*:8*//*11:*/
#line 187 "main.web"

void
xxerror(const char*s)
{
return;
}


/*:11*/
#line 496 "main.web"











/*:17*/
