@q parser.w@>
@q Created by Laurence D. Finston (LDF) 2006.10.20.@>

@q * (1) Copyright and License. @>

@q This file is part of the LDF Metadata Exchange Utilities,            @>
@q a package for metadata exchange.                                     @>
@q It contains code from the the IWF Metadata Harvester, a package for  @>
@q metadata harvesting.                                                 @> 

@q The following copyright notice applies to the contents of this file up to  @>      
@q and including January 31, 2007:                                            @> 

@q Copyright (C) 2006, 2007 IWF Wissen und Medien gGmbH  @>

@q The following copyright notice applies to all changes and additions to this file  @>      
@q starting on February 1, 2007:                                                     @> 

@q Copyright (C) 2007 Laurence D. Finston  @>

@q The state of this file as of January 31, 2007 is stored in the  	  @>    
@q revision of this file with the symbolic tag "LAST_IWF"          	  @>
@q in the CVS repository for the LDF Metadata Exchange Utilities:  	  @>
@q http://cvs.savannah.nongnu.org/viewcvs/iwf-mdh/?root=iwf-mdh    	  @>
@q If necessary, changes and additions after this date can be determined  @>
@q by comparing this revision with later ones using the GNU diffutils:    @>
@q http://www.gnu.org/software/diffutils/diffutils.html                   @>

@q The author is Laurence D. Finston.  @>

@q The LDF Metadata Exchange Utilities are free software;                  @>
@q you can redistribute them and/or modify                                 @>
@q them under the terms of the GNU General Public License as published by  @>
@q the Free Software Foundation; either version 2 of the License, or       @>
@q (at your option) any later version.                                     @>

@q The LDF Metadata Exchange Utilities are distributed in the hope               @>          
@q that they will be useful, but WITHOUT ANY WARRANTY; without even              @>
@q the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  @>
@q See the GNU General Public License for more details.                          @>

@q You should have received a copy of the GNU General Public License                   @>
@q along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  @>
@q Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          @>

@q The LDF Metadata Exchange Utilities are available for downloading from the @>
@q following FTP server:                                                      @>
@q ftp://ftp.gwdg.de/pub/gnu2/iwfmdh/                                         @>

@q "@@" stands for a single "at"-sign in the following email adresses.  @>

@q Please send bug reports to lfinsto1@@gwdg.de  @>

@q The author can be contacted at: @>

@q Laurence D. Finston @>
@q Kreuzbergring 41    @>
@q D-37075 Goettingen  @>
@q Germany             @>

@q lfinsto1@@gwdg.de               @>
@q s246794@@stud.uni-goettingen.de @>


@q * (0) @>
@** Parser (\filename{parser.w}).
\initials{LDF 2006.10.20.}

\LOG
\initials{LDF 2006.10.20.}
Added this file.

\initials{LDF 2006.10.31.}
Renamed this file.   
Old name:  \filename{parser.web}.  
New name:  \filename{parser.w}. 
\ENDLOG

@q {@>
@!@:parser.w}{{\filename{parser.w}}@>@>
@q }@>

@<\filename{parser.w}@>=
static char parser_id_string[] 
   = "$Id: parser.w,v 1.7 2007/02/13 19:22:07 lfinsto1 Exp $";

@q * (1) Include files.@>
@* Include files.
\initials{LDF 2006.10.20.}

@<Include files@>=

#include "localldf.h"

#ifdef NON_WIN_LDF
#include "nonwin.h"
#else
#include "stdafx.h"
#endif

#include "parser.hxx"

#include "dttmtype.h"
#include "scnrtype.h"
#include "scanner.h"
#include "querytyp.h"
#include "dtsrctyp.h"
#include "idtype.h"

@q * (1) Declare |yylex|.@>
@* Declare {\it yylex}.
\initials{LDF 2006.10.20.}

@<Declare |yylex|@>=

int 
yylex(YYSTYPE* lvalp, void* parameter);

@q * (1) Declare |yyerror|.@>
@* Declare {\it yyerror}.
\initials{LDF 2006.10.20.}

@<Declare |yyerror|@>=

void 
yyerror(const char* s);

@q * (1) |union| declaration for |YYSTYPE|.@>
@* |union| declaration for |YYSTYPE|.



@<|union| declaration for |YYSTYPE|@>=
@=%union {@>
    int int_value;
    float float_value;
    char string_value[2048];
    void* pointer_value;
}

@q * (1) Bison declarations.@>
@* Bison declarations.
\initials{LDF 2006.10.20.}

@<Bison declarations@>=
@=%pure_parser@>
@=%debug@>

@q ** (2) Token and Type Declarations.@>
@*1 Token and Type Declarations.
\initials{LDF 2006.10.20.}


@q *** (3) Punctuation.@>
@*2 Punctuation.
\initials{LDF 2006.10.31.}

\LOG
\initials{2006.10.31.}
Added this section.

\initials{LDF 2006.12.07.}
Added token declaration for |HYPHEN|.

\initials{LDF 2006.12.08.}
Added token declaration for |UNDERLINE|.

\initials{LDF 2006.12.12.}
Added token declaration for |AT_SYMBOL|.

\initials{LDF 2006.12.14.}
Added token declaration for |PERCENT|.
\ENDLOG

@<Token and type declarations@>=
          
@=%token <int_value> AT_SYMBOL@>@;
@=%token <int_value> COMMA@>@;
@=%token <int_value> COLON@>@;
@=%token <int_value> HYPHEN@>@;
@=%token <int_value> UNDERLINE@>@;
@=%token <int_value> PERCENT@>@;
@=%token <int_value> PERIOD@>@;
@=%token <int_value> SEMI_COLON@>@;      
@=%token <int_value> OPEN_PARENTHESIS@>@;      
@=%token <int_value> CLOSE_PARENTHESIS@>@;            
@=%token <int_value> OPEN_BRACKET@>@;      
@=%token <int_value> CLOSE_BRACKET@>@;            

@q *** (3) Assignments.@>
@*2 Assignments.
\initials{LDF 2006.10.31.}

\LOG
\initials{2006.10.31.}
Added this section with the declarations of |ASSIGN|,
|PLUS_ASSIGN|, |MINUS_ASSIGN|, |TIMES_ASSIGN|, 
and |DIVIDE_ASSIGN|.

\initials{LDF 2006.11.14.}
Added the declarations of |AND_ASSIGN|, |OR_ASSIGN|, |XOR_ASSIGN|, 
and |NOT_ASSIGN|.

\initials{LDF 2006.12.11.}
Added the declarations of |LIKE| and |FREETEXT|.

\initials{LDF 2006.12.12.}
Added the declaration of |CONTAINS|.
\ENDLOG

@<Token and type declarations@>=

@=%token <int_value> ASSIGN@>@;
@=%token <int_value> PLUS_ASSIGN@>@;
@=%token <int_value> MINUS_ASSIGN@>@;
@=%token <int_value> TIMES_ASSIGN@>@;
@=%token <int_value> DIVIDE_ASSIGN@>@;

@=%token <int_value> AND_ASSIGN@>@;
@=%token <int_value> OR_ASSIGN@>@;
@=%token <int_value> XOR_ASSIGN@>@;
@=%token <int_value> NOT_ASSIGN@>@;

@=%token <int_value> CONTAINS@>@;
@=%token <int_value> FREETEXT@>@;
@=%token <int_value> LIKE@>@;

@q *** (3) Arithmetical Operations.@>
@*2 Arithmetical Operations.
\initials{LDF 2006.11.14.}

\LOG
\initials{2006.11.14.}
Added this section with the token declarations of 
|PLUS|, |MINUS|, |TIMES|, and |DIVIDE|.
\ENDLOG

@<Token and type declarations@>=

@=%token <int_value> PLUS@>@;
@=%token <int_value> MINUS@>@;
@=%token <int_value> TIMES@>@;
@=%token <int_value> DIVIDE@>@;

@q *** (3) Types with values.@>
@ Types with values.
\initials{LDF 2006.10.31.}

\LOG
\initials{2006.10.31.}
Added this section.
\ENDLOG

@<Token and type declarations@>=

@=%token <string_value> STRING@>@;
@=%token <int_value>    INTEGER@>@;
@=%token <float_value>  FLOAT@>@;

@q *** (3) Control.@>
@*2 Control.
\initials{LDF 2006.10.20.}

@<Token and type declarations@>=

@=%token <int_value> START@>@;
@=%token <int_value> END@>@;
@=%token <int_value> TERMINATE@>@;

@q *** (3) Declarators.@>
@*2 Declarators.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.11.16.}
Added token declaration for |STRING_DECLARATOR|.

\initials{LDF 2006.12.08.}
Added token declaration for |DATASOURCE_DECLARATOR|.

\initials{LDF 2006.12.15.}
Added token declaration for |DATETIME_DECLARATOR|.
\ENDLOG

@<Token and type declarations@>=

@=%token <int_value> DATASOURCE_DECLARATOR@>@;
@=%token <int_value> DATETIME_DECLARATOR@>@;
@=%token <int_value> STRING_DECLARATOR@>@;
@=%token <int_value> QUERY_DECLARATOR@>@;

@q *** (3) Queries.@>
@*2 Queries.
\initials{LDF 2006.10.20.}

\LOG
\initials{LDF 2006.10.31.}
Added token declarations for |DATABASE| and |SERVER|.
\ENDLOG

@<Token and type declarations@>=

@=%token <int_value> LOCAL@>@;
@=%token <int_value> REMOTE@>@;
@=%token <int_value> DATABASE@>@;
@=%token <int_value> SERVER@>@;


@q *** (3) Datasources.@>
@ Datasources.
\initials{LDF 2006.12.08.}

\LOG
\initials{2006.12.08.}
Added this section with the token declarations for |DBT|, |GBV_GVK|, |TIMMS|, 
and |DATASOURCE_FILE|.  |LOCAL|, |DATABASE|, and |SERVER| have already been 
defined, as they are used for queries.
\ENDLOG

@<Token and type declarations@>=

@=%token <int_value> DBT@>@;
@=%token <int_value> GBV_GVK@>@;
@=%token <int_value> TIMMS@>@;

@=%token <int_value> DATASOURCE_FILE@>@;

@q *** (3) Datetimes.@>
@ Datetimes.
\initials{LDF 2006.12.15.}

\LOG
\initials{2006.12.15.}
Added this section with the token declarations for 
|DAY|, |MONTH|, |YEAR|, |HOUR|, |MINUTE|, and 
|SECOND|.

\initials{LDF 2006.12.18.}
Added token declaration for |YEAR_RANGE_BEGIN| and |YEAR_RANGE_END|.
\ENDLOG

@<Token and type declarations@>=

@=%token <int_value>   YEAR_RANGE_BEGIN@>@;
@=%token <int_value>   YEAR_RANGE_END@>@;
@=%token <int_value>   YEAR@>@;
@=%token <int_value>   MONTH@>@;
@=%token <int_value>   DAY@>@;
@=%token <int_value>   HOUR@>@;
@=%token <int_value>   MINUTE@>@;
@=%token <int_value>   SECOND@>@;

@q *** (3) Predicates and Control Structures.@>
@*2 Predicates and Control Structures.
\initials{LDF 2006.11.14.}

\LOG
\initials{2006.11.14.}
Added this section with the token declarations for
|IF|, |ELSE|, |ELIF|, |FI|, |FOR|, |DO|,
|WHILE|, |AND|, |OR|, |XOR|, |NOT|,
|AND_NOT|, |OR_NOT|, and |XOR_NOT|.
\ENDLOG

@<Token and type declarations@>=

@=%token <int_value> IF@>@;
@=%token <int_value> ELSE@>@;
@=%token <int_value> ELIF@>@;
@=%token <int_value> FI@>@;

@=%token <int_value> FOR@>@;
@=%token <int_value> DO@>@;
@=%token <int_value> WHILE@>@;

@=%token <int_value> AND@>@;
@=%token <int_value> OR@>@;
@=%token <int_value> XOR@>@;
@=%token <int_value> NOT@>@;

@=%token <int_value> AND_NOT@>@;
@=%token <int_value> OR_NOT@>@;
@=%token <int_value> XOR_NOT@>@;

@q *** (3) Database tables (Field designators).@>
@ Database tables (Field designators).
\initials{LDF 2006.10.31.}

\LOG
\initials{2006.10.31.}
Added this section with token declarations for |AUTHOR|, |CONTRIBUTOR|,
|TITLE|, and |SUBJECT|.

\initials{LDF 2006.12.05.}
Added the token declaration for |CREATOR|.

\initials{LDF 2006.12.12.}
Added the token declaration for |MAIN_CANONICAL_TITLE|.

\initials{LDF 2006.12.12.}
Added token declarations for additional tables from the 
OAI database (dc\_test).

\initials{LDF 2006.12.12.}
Added token declarations for additional tables from the 
PICA database (PICA\_DB).
\ENDLOG

@<Token and type declarations@>=

@=%token <int_value> ACCESS_NUMBER@>@;
@=%token <int_value> AUTHOR@>@;

@=%token <int_value> BIBLIOGRAPHIC_TYPE@>@;

@=%token <int_value> CALL_NUMBER@>@;
@=%token <int_value> CLASSIFICATION@>@;
@=%token <int_value> COMPANY@>@;        
@=%token <int_value> CONTENT_SUMMARY@>@;
@=%token <int_value> CONTRIBUTOR@>@;
@=%token <int_value> CREATOR@>@;

@=%token <int_value> DATABASE_PROVIDER@>@;
@=%token <int_value> DESCRIPTION@>@;   

@=%token <int_value> EXEMPLAR_PRODUCTION_NUMBER@>@;
    
@=%token <int_value> IDENTIFIER@>@;        
@=%token <int_value> INSTITUTION@>@;        

@=%token <int_value> LANGUAGE@>@;        

@=%token <int_value> MAIN_CANONICAL_TITLE@>@;        

@=%token <int_value> PERMUTATION_PATTERN@>@;
@=%token <int_value> PERSON@>@;        
@=%token <int_value> PHYSICAL_DESCRIPTION@>@;
@=%token <int_value> PUBLISHER@>@;        

@=%token <int_value> RECORD@>@;        
@=%token <int_value> REMOTE_ACCESS@>@;
@=%token <int_value> RIGHTS@>@;        

@=%token <int_value> SOURCE@>@;
@=%token <int_value> SUBJECT@>@;      
@=%token <int_value> SUPERORDINATE_ENTITIES@>@;

@=%token <int_value> TITLE@>@;        
@=%token <int_value> TYPE@>@;        

@q *** (3) Database table columns (field qualifiers).@>
@ Database table columns (field qualifiers).
\initials{LDF 2006.12.13.}

\LOG
\initials{2006.12.13.}
Added this section.
\ENDLOG

@<Token and type declarations@>=

@q **** (4) Generic columns.@>
@ Generic columns.
\initials{LDF 2006.12.13.}

\LOG
\initials{2006.12.13.}
Added this section.
\ENDLOG

@<Token and type declarations@>=

@=%token <int_value> ID@>@;

@q **** (4) Names.@>
@ Names.
\initials{LDF 2006.12.07.}

\LOG
\initials{LDF 2006.12.07.}
Added this section with token declarations for |GIVEN_NAME|, 
|PREFIX|, and |SURNAME|.

\initials{LDF 2006.12.07.}
Added token declarations for |AUTHOR_GIVEN_NAME|,
|AUTHOR_PREFIX|, |AUTHOR_SURNAME|, |CONTRIBUTOR_GIVEN_NAME|,
|CONTRIBUTOR_PREFIX|, and |CONTRIBUTOR_SURNAME|.
\ENDLOG

@<Token and type declarations@>=

@=%token <int_value> GIVEN_NAME@>@;
@=%token <int_value> PREFIX@>@;
@=%token <int_value> SURNAME@>@;

@=%token <int_value> AUTHOR_GIVEN_NAME@>@;
@=%token <int_value> AUTHOR_PREFIX@>@;
@=%token <int_value> AUTHOR_SURNAME@>@;

@=%token <int_value> CONTRIBUTOR_GIVEN_NAME@>@;
@=%token <int_value> CONTRIBUTOR_PREFIX@>@;
@=%token <int_value> CONTRIBUTOR_SURNAME@>@;


@q **** (4) Columns of individual tables.@>
@*2 Columns of individual tables.
\initials{LDF 2006.12.14.}

\LOG
\initials{2006.12.14.}
Added this section.
\ENDLOG

@q ***** (5) Pica.@>
@*3 Pica.
\initials{LDF 2006.12.14.}

\LOG
\initials{2006.12.14.}
Added this section.
\ENDLOG

@q ****** (6) Records.@>
@*4 Records.
\initials{LDF 2006.12.14.}

|ID| in ``Generic'' section.
\initials{LDF 2006.12.14.}

\LOG
\initials{2006.12.14.}
Added this section.
\ENDLOG

@<Token and type declarations@>=

@=%token <int_value> ELN_ORIGINAL_ENTRY@>@;
@=%token <int_value> ELN_MOST_RECENT_CHANGE@>@;
@=%token <int_value> ELN_STATUS_CHANGE@>@;
@=%token <int_value> IDENTIFICATION_NUMBER@>@;
@=%token <int_value> DATE_ORIGINAL_ENTRY@>@;
@=%token <int_value> DATE_MOST_RECENT_CHANGE@>@;
@=%token <int_value> DATE_STATUS_CHANGE@>@;
@=%token <int_value> SOURCE_ID@>@;
@=%token <int_value> YEAR_APPEARANCE_BEGIN@>@;
@=%token <int_value> YEAR_APPEARANCE_END@>@;
@=%token <int_value> YEAR_APPEARANCE_RAK_WB@>@;
@=%token <int_value> YEAR_APPEARANCE_ORIGINAL@>@;

@q **** (4) @>

@q *** (3) Variables.@>
@ Variables.
\initials{LDF 2006.11.01.}

\LOG
\initials{2006.11.01.}
Added this section.
\ENDLOG

@<Token and type declarations@>=

@=%token <int_value> VARIABLE@>@;
@=%token <string_value> VARIABLE_TEXT_SEGMENT@>@;


@q *** (3) Data Types.@>
@ Data Types.
\initials{LDF 2006.11.02.}

\LOG
\initials{2006.11.02.}
Added this section with the token declaration of |QUERY_TYPE|.

\initials{LDF 2006.11.03.}
Added the token declaration of |NULL_TYPE|.

\initials{LDF 2006.11.16.}
Added the token declaration of |STRING_TYPE|.

\initials{LDF 2006.12.08.}
Added the token declaration of |DATASOURCE_TYPE|.

\initials{LDF 2006.12.15.}
Added the token declaration of |DATETIME_TYPE|.
\ENDLOG

@<Token and type declarations@>=

@=%token <pointer_value> NULL_TYPE@>@;

@=%token <pointer_value> DATASOURCE_TYPE@>@;
@=%token <pointer_value> DATETIME_TYPE@>@;

@=%token <pointer_value> QUERY_TYPE@>@;

@=%token <pointer_value> STRING_TYPE@>@;


@q *** (3) Commands.@>
@ Commands.
\initials{LDF 2006.11.13.}

\LOG
\initials{LDF 2006.11.13.}
Added this section with the token declarations of 
|SHOW| and |CLEAR|.

\initials{LDF 2006.11.13.}
Added the token declarations of |MESSAGE|, |ERRMESSAGE|, and |PAUSE|.

\initials{LDF 2006.11.16.}
Added the token declarations of |TEX|, |SQL|, |OAI|, and |PICA|.

\initials{LDF 2006.11.23.}
Added the token declaration of |OUTPUT|.
\ENDLOG

@<Token and type declarations@>=


@=%token <int_value> CLEAR@>@;
@=%token <int_value> ERRMESSAGE@>@;
@=%token <int_value> MESSAGE@>@;
@=%token <int_value> PAUSE@>@;
@=%token <int_value> SHOW@>@;

@=%token <int_value> TEX@>@;
@=%token <int_value> SQL@>@;
@=%token <int_value> OAI@>@;
@=%token <int_value> PICA@>@;

@=%token <int_value> OUTPUT@>@;



@q *** (3) @>

@q * (1) Parser rules.@>
@* Parser rules.
\initials{LDF 2006.10.20.}

@q ** (2) Program.@>
@*1 Program.
\initials{LDF 2006.10.31.}

@q *** (3) program: statement_list TERMINATE.@>
@*2  \program> $\longrightarrow$ \statement list> \.{TERMINATE}.
\initials{LDF 2006.10.31.}

@<Parser rules@>=

@=program: statement_list TERMINATE@>
{
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl << "Rule `statement_list: TERMINATE'." << endl;
    cerr <<  temp_strm.str();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");

    return 0;

};

@q ** (2) Statement list.@>
@*1 Statement list.
\initials{LDF 2006.10.31.}

@q *** (3) statement_list: statement_list /* empty  */.@>
@*2 \statement list> $\longrightarrow$ \.{EMPTY}.
\initials{LDF 2006.10.31.}

@<Parser rules@>=

@=statement_list: /* empty */@>
;

@q *** (3) statement_list: statement_list statement.@>
@*2 \statement list> $\longrightarrow$ \statement list> \statement>.
\initials{LDF 2006.10.31.}

@<Parser rules@>=

@=statement_list: statement_list statement@>
;

@q ** (2) Statement.@>
@*1 Statement.
\initials{LDF 2006.10.31.}


@q *** (3) statement: group_statement SEMI_COLON.@>
@*2 \statement> $\longrightarrow$ \group statement> \.{SEMI\_COLON}.
\initials{LDF 2006.10.31.}

\LOG
\initials{2006.10.31.}
Added this rule.

\initials{LDF 2006.11.13.}
Commented-out this rule.
\ENDLOG

@<Garbage@>=

@q =statement: group_statement SEMI_COLON@>
{
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl << "Rule `statement: group_statement SEMI_COLON'." 
              << endl;
    cerr <<  temp_strm.str();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");

};


@q *** (3) statement: declaration SEMI_COLON.@>
@*2 \statement> $\longrightarrow$ \declaration> \.{SEMI\_COLON}.
\initials{LDF 2006.11.01.}

\LOG
\initials{2006.11.01.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=statement: declaration SEMI_COLON@>
{
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `statement: declaration SEMI_COLON'." 
              << endl;

    cerr <<  temp_strm.str();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");

};

@q *** (3) statement: assignment SEMI_COLON.@>
@*2 \statement> $\longrightarrow$ \assignment> \.{SEMI\_COLON}.
\initials{LDF 2006.10.31.}

@<Parser rules@>=

@=statement: assignment SEMI_COLON@>
{
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `statement: assignment SEMI_COLON'." 
              << endl;

    cerr <<  temp_strm.str();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");

};

@q *** (3) statement: command SEMI_COLON.@>
@*2 \statement> $\longrightarrow$ \command> \.{SEMI\_COLON}.
\initials{LDF 2006.11.13.}

\LOG
\initials{2006.11.13.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=statement: command SEMI_COLON@>
{
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `statement: command SEMI_COLON'." 
              << endl;

    cerr <<  temp_strm.str();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");

};


@q ** (2) Group Statement.@>

@i grpstmnt.w @q @>

@q ** (2) Declarations.@>

@i declrtns.w @q @>

@q ** (2) Variables.@>

@i variabls.w @q @>   

@q ** (2) Assignment.@>

@i assign.w @q@>

@q ** (2) Commands.@>

@i commands.w @q @>

@q ** (2) Query expressions.@>

@i queryexp.w @q @>

@q ** (2) Datasource expressions.@>

@i dtsrcexp.w @q@>

@q ** (2) String expressions.@>

@i strings.w @q@>

@q ** (2) Datetime expressions.@>

@i dttmexp.w @q@>

@q * (1) Putting the parser together.@>
@* Putting the parser together.

@q ** (2) Filename sections.@>
@ Filename sections.  These sections contain the CVS ID strings for 
the individual parser files.
\initials{LDF 2006.10.31.}

\LOG
\initials{2006.10.31.}
Added this section.
\ENDLOG

@<Filename sections@>=
@<\filename{parser.w}@>@; 
@<\filename{declrtns.w}@>@;
@<\filename{grpstmnt.w}@>@;
@<\filename{variabls.w}@>@;
@<\filename{assign.w}@>@;
@<\filename{queryexp.w}@>@;
@<\filename{dtsrcexp.w}@>@;
@<\filename{commands.w}@>@;
@<\filename{strings.w}@>@;
@<\filename{dttmexp.w}@>@;


@q ** (2) @>

@ This is what's written to \filename{parser.yyy}.
\initials{LDF 2006.10.20.}
 
@(parser.yyy@>=
@=%{@>@;
@<Include files@>@;
@<Filename sections@>@;
@<Declare |yylex|@>@;
@<Declare |yyerror|@>@;
#define YYPARSE_PARAM parameter
#define YYLEX_PARAM parameter
stringstream temp_strm;
@=%}@>@;
@<|union| declaration for |YYSTYPE|@>@;
@<Bison declarations@>@;
@<Token and type declarations@>@;
@<Type declarations for non-terminal symbols@>@;
@=%%@>@;
@<Parser rules@>@;

@ This is what {\it isn't\/} compiled.
The file \filename{parser.c} isn't compiled, but including 
|@<\filename{parser.w}@>| here prevents \CWEAVE/ from issuing a 
warning.
\initials{LDF 2006.10.24.}
@c
@<Filename sections@>@;
#if 0 /* 1 */ 
@<Garbage@>@;
#endif 

@q * (1) Emacs-Lisp code for use in indirect buffers.  LDF 2006.10.11.@>

@q (progn (cweb-mode) )  @>

@q * (1) Local Variables for Emacs  @>

@q Local Variables: @>
@q mode:CWEB @>
@q End: @>
