/* * (1) Copyright and License. */

/* This file is part of the LDF Metadata Exchange Utilities,             */
/* a package for metadata exchange.                                      */

/* Copyright (C) 2007 Laurence D. Finston   */

/* The author is Laurence D. Finston.  */

/* The LDF Metadata Exchange Utilities are free software;                   */
/* you can redistribute them and/or modify                                  */
/* them under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation; either version 2 of the License, or        */
/* (at your option) any later version.                                      */

/* The LDF Metadata Exchange Utilities are distributed in the hope               */
/* that they will be useful, but WITHOUT ANY WARRANTY; without even              */
/* the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  */
/* See the GNU General Public License for more details.                          */

/* You should have received a copy of the GNU General Public License                   */
/* along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  */
/* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          */

/* The LDF Metadata Exchange Utilities are available for downloading from the  */
/* following FTP server:                                                       */
/* ftp:/*ftp.gwdg.de/pub/gnu2/iwfmdh/                                          */

/* Please send bug reports to lfinsto1@gwdg.de  */

/* The author can be contacted at:  */

/* Laurence D. Finston  */
/* Kreuzbergring 41     */
/* D-37075 Goettingen   */
/* Germany              */

/* lfinsto1@gwdg.de                */
/* s246794@stud.uni-goettingen.de  */


/*51:*/
#line 2228 "prsrfncs.web"

/*2:*/
#line 90 "prsrfncs.web"


#include "localldf.h"

#ifdef NON_WIN_LDF
#include "nonwin.h"
#else
#include "stdafx.h"
#endif

#include "parser.hxx"
#include "dttmtype.h"
#include "idtype.h"
#include "scnrtype.h"
#include "scanner.h"
#include "querytyp.h"
#include "dtsrctyp.h"



/*:2*/
#line 2229 "prsrfncs.web"

/*1:*/
#line 81 "prsrfncs.web"


static char id_string[]
= "$Id: prsrfncs.web,v 1.6 2007/02/13 20:39:45 lfinsto1 Exp $";



/*:1*/
#line 2230 "prsrfncs.web"

using namespace std;
using namespace Scan_Parse;
/*6:*/
#line 143 "prsrfncs.web"

void*
Scan_Parse::variable_func(void*v,
char*name)
{


#if 0 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif

stringstream temp_strm;

Scanner_Node scanner_node= static_cast<Scanner_Node> (v);

#ifdef DEBUG_OUTPUT
temp_strm<<"Entering `Scan_Parse::variable_func'."
<<endl
<<"`name' == "<<name
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



/*:6*//*7:*/
#line 179 "prsrfncs.web"


if(scanner_node==0)
{
temp_strm<<"ERROR!  In `Scan_Parse::variable_func':"
<<"`scanner_node' == 0.  Can't continue."
<<endl
<<"Exiting function unsuccessfully with return value 0."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");

return 0;

}



map<string,Id_Node> ::iterator iter= scanner_node->id_map.find(name);



/*:7*//*8:*/
#line 207 "prsrfncs.web"


if(iter==scanner_node->id_map.end())
{
temp_strm<<"ERROR!  In `Scan_Parse::variable_func':"
<<endl
<<"`"<<name<<"' not found in `scanner_node->id_map'."
<<endl
<<"Exiting function unsuccessfully with return value 0."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

scanner_node->float_vector.clear();

return 0;

}


/*:8*//*9:*/
#line 234 "prsrfncs.web"


else
{

Id_Node curr_id_node= 0;

#ifdef DEBUG_OUTPUT
temp_strm<<"In `Scan_Parse::variable_func':"
<<endl
<<"`"<<name<<"' found in `scanner_node->id_map'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



/*:9*//*10:*/
#line 259 "prsrfncs.web"


if(strchr(name,'')==0)
{
curr_id_node= iter->second;

}



/*:10*//*11:*/
#line 272 "prsrfncs.web"


else
{
#ifdef DEBUG_OUTPUT
temp_strm<<"`name' (`"<<name<<"') contains "
<<scanner_node->float_vector.size()
<<" subscript placeholder";

if(scanner_node->float_vector.size()> 1)
temp_strm<<"s";

temp_strm<<"."<<endl;
#endif
int i= 0;
for(vector<float> ::const_iterator subscript_iter
= scanner_node->float_vector.begin();
subscript_iter!=scanner_node->float_vector.end();
++subscript_iter)
{
#ifdef DEBUG_OUTPUT
temp_strm<<"Subscript "<<i++<<" == "<<*subscript_iter<<endl;
#endif

}

#ifdef DEBUG_OUTPUT
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

curr_id_node= scanner_node->lookup(name,true,iter->second->type);

}





/*:11*//*12:*/
#line 317 "prsrfncs.web"


YYSTYPE curr_value;
curr_value.pointer_value= static_cast<void*> (curr_id_node);

scanner_node->token_stack.push(Token_Type(curr_id_node->type,
curr_value));

#ifdef DEBUG_OUTPUT
temp_strm<<"Exiting `Scan_Parse::variable_func' successfully "
<<"with return value `curr_id_node' (cast to `void*')."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

scanner_node->float_vector.clear();

return static_cast<void*> (curr_id_node);

}





#undef DEBUG_OUTPUT

}



/*:12*//*14:*/
#line 381 "prsrfncs.web"


Id_Node
Scan_Parse::declare_variable_func(void*v,
const unsigned short type,
char*name)
{
#if 0 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif

stringstream temp_strm;

Scanner_Node scanner_node= static_cast<Scanner_Node> (v);


#ifdef DEBUG_OUTPUT
temp_strm<<"Entering `Scan_Parse::declare_variable_func'."
<<endl
<<"`type' == `"<<token_map[type]<<"'"
<<endl
<<"`name' == "<<name
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



/*:14*//*15:*/
#line 420 "prsrfncs.web"


if(scanner_node==0)
{
temp_strm<<"ERROR!  In `Scan_Parse::declare_variable_func':"
<<"`scanner_node' == 0.  Can't continue."
<<endl
<<"Exiting function unsuccessfully with return value 0."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");

return 0;

}


/*:15*//*16:*/
#line 446 "prsrfncs.web"


Id_Node curr_id_node= new Id_Type;

curr_id_node->name= name;

curr_id_node->type= type;

curr_id_node->scanner_node= scanner_node;

scanner_node->id_map[curr_id_node->name]= curr_id_node;

#ifdef DEBUG_OUTPUT
temp_strm<<"`scanner_node->id_map[curr_id_node->name]->name' == "
<<scanner_node->id_map[curr_id_node->name]->name
<<endl
<<"`scanner_node->id_map[curr_id_node->name]->type' == `"
<<token_map[scanner_node->id_map[curr_id_node->name]->type]
<<"'"
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"Exiting `Scan_Parse::declare_variable_func'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return curr_id_node;

#undef DEBUG_OUTPUT

}





/*:16*//*18:*/
#line 519 "prsrfncs.web"

void*
Scan_Parse::query_assignment_func_0(void*v,
void*object,
unsigned int assignment_type,
unsigned int arg_0,
unsigned int arg_1,
void*value,
bool negate)
{


#if 1 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif

stringstream temp_strm;

Scanner_Node scanner_node= static_cast<Scanner_Node> (v);


#ifdef DEBUG_OUTPUT
temp_strm<<"Entering `Scan_Parse::query_assignment_func_0'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



/*:18*//*19:*/
#line 559 "prsrfncs.web"


if(scanner_node==0)
{
temp_strm<<"ERROR!  In `Scan_Parse::query_assignment_func_0':"
<<"`scanner_node' == 0.  Can't continue."
<<endl
<<"Exiting function unsuccessfully with return value 0."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");

return 0;

}


/*:19*//*20:*/
#line 580 "prsrfncs.web"


if(object==0)
{
temp_strm<<"ERROR!  In `Scan_Parse::query_assignment_func_0':"
<<endl
<<"`object' == 0.  Can't perform assignment."
<<endl
<<"Exiting function unsuccessfully with return value 0."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

return 0;

}


/*:20*//*21:*/
#line 603 "prsrfncs.web"


Id_Node curr_id_node= static_cast<Id_Node> (object);

Query_Node curr_query_node= 0;

if(curr_id_node->value==0)
{
curr_query_node= new Query_Type;
curr_query_node->query_type= Query_Type::TOP_TYPE;
curr_query_node->id_node= curr_id_node;
curr_query_node->name= curr_id_node->name;
curr_query_node->scanner_node= scanner_node;
curr_id_node->value= static_cast<void*> (curr_query_node);

}

else
{
curr_query_node= static_cast<Query_Node> (curr_id_node->value);
}

#if 0 
#ifdef DEBUG_OUTPUT
temp_strm<<"arg_0 == "<<token_map[arg_0]
<<endl
<<"arg_1 == "<<token_map[arg_1]
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif
#endif


/*:21*//*22:*/
#line 649 "prsrfncs.web"




if(arg_0==LOCAL)
{



if(arg_1==DATABASE
&&find(curr_query_node->target_types.begin(),
curr_query_node->target_types.end(),
Query_Type::LOCAL_DATABASE_TARGET)
==curr_query_node->target_types.end())

curr_query_node->target_types.push_back(Query_Type::LOCAL_DATABASE_TARGET);



else if(arg_1==SERVER
&&find(curr_query_node->target_types.begin(),
curr_query_node->target_types.end(),
Query_Type::LOCAL_SERVER_TARGET)
==curr_query_node->target_types.end())


curr_query_node->target_types.push_back(Query_Type::LOCAL_SERVER_TARGET);



}



else if(arg_0==REMOTE)
{


if(arg_1==DATABASE
&&find(curr_query_node->target_types.begin(),
curr_query_node->target_types.end(),
Query_Type::REMOTE_DATABASE_TARGET)
==curr_query_node->target_types.end())


curr_query_node->target_types.push_back(Query_Type::REMOTE_DATABASE_TARGET);



else if(arg_1==SERVER
&&find(curr_query_node->target_types.begin(),
curr_query_node->target_types.end(),
Query_Type::REMOTE_SERVER_TARGET)
==curr_query_node->target_types.end())

curr_query_node->target_types.push_back(Query_Type::REMOTE_SERVER_TARGET);



}





/*:22*//*24:*/
#line 745 "prsrfncs.web"


if(arg_0==ACCESS_NUMBER
||arg_0==AUTHOR

||arg_0==BIBLIOGRAPHIC_TYPE


||arg_0==CALL_NUMBER
||arg_0==CLASSIFICATION
||arg_0==COMPANY
||arg_0==CONTENT_SUMMARY
||arg_0==CONTRIBUTOR
||arg_0==CREATOR

||arg_0==DATABASE_PROVIDER
||arg_0==DESCRIPTION

||arg_0==EXEMPLAR_PRODUCTION_NUMBER

||arg_0==IDENTIFIER
||arg_0==INSTITUTION

||arg_0==LANGUAGE

||arg_0==MAIN_CANONICAL_TITLE

||arg_0==PERMUTATION_PATTERN
||arg_0==PERSON
||arg_0==PHYSICAL_DESCRIPTION
||arg_0==PUBLISHER

||arg_0==RECORD
||arg_0==REMOTE_ACCESS
||arg_0==RIGHTS

||arg_0==SOURCE
||arg_0==SUBJECT
||arg_0==SUPERORDINATE_ENTITIES
||arg_0==TITLE
||arg_0==TYPE)
{
unsigned int curr_field_type;

if(arg_0==ACCESS_NUMBER)
curr_field_type= Query_Type::ACCESS_NUMBER_FIELD;
else if(arg_0==AUTHOR)
curr_field_type= Query_Type::AUTHOR_FIELD;

else if(arg_0==BIBLIOGRAPHIC_TYPE)
curr_field_type= Query_Type::BIBLIOGRAPHIC_TYPE_FIELD;

else if(arg_0==CALL_NUMBER)
curr_field_type= Query_Type::CALL_NUMBER_FIELD;
else if(arg_0==CLASSIFICATION)
curr_field_type= Query_Type::CLASSIFICATION_FIELD;
else if(arg_0==COMPANY)
curr_field_type= Query_Type::COMPANY_FIELD;
else if(arg_0==CONTENT_SUMMARY)
curr_field_type= Query_Type::CONTENT_SUMMARY_FIELD;
else if(arg_0==CONTRIBUTOR)
curr_field_type= Query_Type::CONTRIBUTOR_FIELD;
else if(arg_0==CREATOR)
curr_field_type= Query_Type::CREATOR_FIELD;

else if(arg_0==DATABASE_PROVIDER)
curr_field_type= Query_Type::DATABASE_PROVIDER_FIELD;
else if(arg_0==DESCRIPTION)
curr_field_type= Query_Type::DESCRIPTION_FIELD;

else if(arg_0==EXEMPLAR_PRODUCTION_NUMBER)
curr_field_type= Query_Type::EXEMPLAR_PRODUCTION_NUMBER_FIELD;

else if(arg_0==IDENTIFIER)
curr_field_type= Query_Type::IDENTIFIER_FIELD;
else if(arg_0==INSTITUTION)
curr_field_type= Query_Type::INSTITUTION_FIELD;

else if(arg_0==LANGUAGE)
curr_field_type= Query_Type::LANGUAGE_FIELD;
else if(arg_0==MAIN_CANONICAL_TITLE)
curr_field_type= Query_Type::MAIN_CANONICAL_TITLE_FIELD;

else if(arg_0==PERMUTATION_PATTERN)
curr_field_type= Query_Type::PERMUTATION_PATTERN_FIELD;
else if(arg_0==PERSON)
curr_field_type= Query_Type::PERSON_FIELD;
else if(arg_0==PHYSICAL_DESCRIPTION)
curr_field_type= Query_Type::PHYSICAL_DESCRIPTION_FIELD;
else if(arg_0==PUBLISHER)
curr_field_type= Query_Type::PUBLISHER_FIELD;

else if(arg_0==RECORD)
curr_field_type= Query_Type::RECORD_FIELD;
else if(arg_0==REMOTE_ACCESS)
curr_field_type= Query_Type::REMOTE_ACCESS_FIELD;
else if(arg_0==RIGHTS)
curr_field_type= Query_Type::RIGHTS_FIELD;

else if(arg_0==SOURCE)
curr_field_type= Query_Type::SOURCE_FIELD;
else if(arg_0==SUBJECT)
curr_field_type= Query_Type::SUBJECT_FIELD;
else if(arg_0==SUPERORDINATE_ENTITIES)
curr_field_type= Query_Type::SUPERORDINATE_ENTITIES_FIELD;

else if(arg_0==TITLE)
curr_field_type= Query_Type::TITLE_FIELD;
else if(arg_0==TYPE)
curr_field_type= Query_Type::TYPE_FIELD;

while(curr_query_node->query_type!=Query_Type::TOP_TYPE)
curr_query_node= curr_query_node->up;



if(curr_query_node->field_type==Query_Type::QUERY_TYPE_NULL_TYPE
&&curr_query_node->value==0)
{
curr_query_node->field_type= curr_field_type;
string*curr_string= new string;
*curr_string= static_cast<char*> (value);
curr_query_node->value= static_cast<void*> (curr_string);
curr_query_node->value_type= Query_Type::QUERY_TYPE_STRING_TYPE;
curr_query_node->negated= negate;
}



/*:24*//*25:*/
#line 880 "prsrfncs.web"


else
{



if(assignment_type==ASSIGN||assignment_type==PLUS_ASSIGN)
{
while(curr_query_node->and_node!=0)
curr_query_node= curr_query_node->and_node;

curr_query_node->and_node= new Query_Type;
curr_query_node->and_node->query_ctr= curr_query_node->query_ctr+1;
curr_query_node->and_node->id_node= curr_id_node;
curr_query_node->and_node->name= curr_id_node->name;

}




else if(assignment_type==OR_ASSIGN)
{
while(curr_query_node->or_node!=0)
curr_query_node= curr_query_node->or_node;

curr_query_node->or_node= new Query_Type;
curr_query_node->or_node->query_ctr= curr_query_node->query_ctr+1;
curr_query_node->or_node->id_node= curr_id_node;
curr_query_node->or_node->name= curr_id_node->name;

}



else if(assignment_type==XOR_ASSIGN)
{
while(curr_query_node->xor_node!=0)
curr_query_node= curr_query_node->xor_node;

curr_query_node->xor_node= new Query_Type;
curr_query_node->xor_node->query_ctr= curr_query_node->query_ctr+1;
curr_query_node->xor_node->id_node= curr_id_node;
curr_query_node->xor_node->name= curr_id_node->name;

}





if(curr_query_node->query_type==Query_Type::TOP_TYPE)
{



if(assignment_type==ASSIGN||assignment_type==PLUS_ASSIGN)
{
curr_query_node->and_node->up= curr_query_node;
}



else if(assignment_type==OR_ASSIGN)
{
curr_query_node->or_node->up= curr_query_node;
}




else if(assignment_type==XOR_ASSIGN)
{
curr_query_node->xor_node->up= curr_query_node;
}




}



else
{



if(assignment_type==ASSIGN||assignment_type==PLUS_ASSIGN)
{

curr_query_node->and_node->up= curr_query_node->up;
}



else if(assignment_type==OR_ASSIGN)
{

curr_query_node->or_node->up= curr_query_node->up;
}



else if(assignment_type==XOR_ASSIGN)
{

curr_query_node->xor_node->up= curr_query_node->up;
}



}



if(assignment_type==ASSIGN||assignment_type==PLUS_ASSIGN)
{
curr_query_node= curr_query_node->and_node;
curr_query_node->query_type= Query_Type::AND_TYPE;
curr_query_node->field_type= curr_field_type;

}



else if(assignment_type==OR_ASSIGN)
{
curr_query_node= curr_query_node->or_node;
curr_query_node->query_type= Query_Type::OR_TYPE;
curr_query_node->field_type= curr_field_type;

}



else if(assignment_type==XOR_ASSIGN)
{
curr_query_node= curr_query_node->xor_node;
curr_query_node->query_type= Query_Type::XOR_TYPE;
curr_query_node->field_type= curr_field_type;

}



string*curr_string= new string;
*curr_string= static_cast<char*> (value);
curr_query_node->value= static_cast<void*> (curr_string);
curr_query_node->value_type= Query_Type::QUERY_TYPE_STRING_TYPE;
curr_query_node->negated= negate;




}



}





#ifdef DEBUG_OUTPUT
temp_strm<<"Exiting `Scan_Parse::query_assignment_func_0' successfully "
<<endl
<<"with return value `curr_query_node', cast to `void*'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return static_cast<void*> (curr_query_node);

}





/*:25*//*26:*/
#line 1077 "prsrfncs.web"

int
Scan_Parse::query_assignment_func_1(Scanner_Node scanner_node,
Id_Node&curr_id_node,
void*&field_specifier,
int assignment_operator,
int negation_optional,
int match_term_optional,
void*&v,
int type)

{



stringstream temp_strm;

#if 1 
#define DEBUG_OUTPUT
#else
##undef DEBUG_OUTPUT
#endif

#ifdef DEBUG_OUTPUT
temp_strm<<endl
<<"Entering `Scan_Parse::query_assignment_func_1'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



Query_Node curr_query= 0;
Query_Node traverse_query= 0;
Query_Node temp_query= 0;



if(assignment_operator==ASSIGN
||assignment_operator==PLUS_ASSIGN
||assignment_operator==AND_ASSIGN)
{



if(curr_id_node&&curr_id_node->value)
{

curr_query= static_cast<Query_Node> (curr_id_node->value);

while(curr_query->and_node!=0)
curr_query= curr_query->and_node;

if(type==QUERY_TYPE)
curr_query->and_node= static_cast<Query_Node> (v);

else if(type==DATETIME_TYPE)
{
temp_query= new Query_Type;
temp_query->value_type= Query_Type::DATE_TIME_TYPE;
temp_query->value= v;
curr_query->and_node= temp_query;
}

curr_query->and_node->query_ctr= curr_query->query_ctr+1;



traverse_query= curr_query->or_node;
while(traverse_query->or_node)
traverse_query= traverse_query->or_node;

if(traverse_query)
curr_query->and_node->query_ctr+= traverse_query->query_ctr;



traverse_query= curr_query->xor_node;
while(traverse_query->xor_node)
traverse_query= traverse_query->xor_node;

if(traverse_query)
curr_query->and_node->query_ctr+= traverse_query->query_ctr;



curr_query->and_node->query_type= Query_Type::AND_TYPE;
curr_query->and_node->up= curr_query;
curr_query= curr_query->and_node;

curr_query->set_field_specifier(field_specifier,
true,
scanner_node);

curr_query->negated= (negation_optional);

}



else if(curr_id_node)
{
if(type==QUERY_TYPE)
curr_id_node->value= v;

else if(type==DATETIME_TYPE)
{
temp_query= new Query_Type;
temp_query->value_type= Query_Type::DATE_TIME_TYPE;
temp_query->value= v;
curr_id_node->value= static_cast<void*> (temp_query);
}

static_cast<Query_Node> (curr_id_node->value)->id_node
= curr_id_node;
static_cast<Query_Node> (curr_id_node->value)->name
= curr_id_node->name;
static_cast<Query_Node> (curr_id_node->value)->query_type= Query_Type::TOP_TYPE;
static_cast<Query_Node> (curr_id_node->value)->query_ctr= 0;
static_cast<Query_Node> (
curr_id_node->value)->set_field_specifier(
field_specifier,
true,
scanner_node);

static_cast<Query_Node> (curr_id_node->value)->negated= (negation_optional);


curr_query= static_cast<Query_Node> (curr_id_node->value);

}



else
{
if(type==QUERY_TYPE)
{
delete static_cast<Query_Node> (v);
}
else if(type==DATETIME_TYPE)
{
delete static_cast<Date_Time_Node> (v);
}

v= 0;

curr_query= 0;
}



}






else if(assignment_operator==OR_ASSIGN)
{



if(curr_id_node&&curr_id_node->value)
{

curr_query= static_cast<Query_Node> (curr_id_node->value);

while(curr_query->or_node!=0)
curr_query= curr_query->or_node;

if(type==QUERY_TYPE)
curr_query->or_node= static_cast<Query_Node> (v);

else if(type==DATETIME_TYPE)
{
temp_query= new Query_Type;
temp_query->value_type= Query_Type::DATE_TIME_TYPE;
temp_query->value= v;
curr_query->or_node= temp_query;
}

curr_query->or_node->query_type= Query_Type::OR_TYPE;
curr_query->or_node->query_ctr= curr_query->query_ctr+1;




traverse_query= curr_query->and_node;
while(traverse_query->and_node)
traverse_query= traverse_query->and_node;

if(traverse_query)
curr_query->or_node->query_ctr+= traverse_query->query_ctr;



traverse_query= curr_query->xor_node;
while(traverse_query->xor_node)
traverse_query= traverse_query->xor_node;

if(traverse_query)
curr_query->or_node->query_ctr+= traverse_query->query_ctr;



curr_query->or_node->up= curr_query;
curr_query= curr_query->or_node;

curr_query->set_field_specifier(field_specifier,
true,
scanner_node);

curr_query->negated= (negation_optional);

}



else if(curr_id_node)
{

if(type==QUERY_TYPE)
curr_id_node->value= v;
else if(type==DATETIME_TYPE)
{
temp_query= new Query_Type;
temp_query->value_type= Query_Type::DATE_TIME_TYPE;
temp_query->value= v;
curr_id_node->value= static_cast<void*> (temp_query);
}

static_cast<Query_Node> (curr_id_node->value)->id_node
= curr_id_node;
static_cast<Query_Node> (curr_id_node->value)->name
= curr_id_node->name;
static_cast<Query_Node> (curr_id_node->value)->query_type= Query_Type::TOP_TYPE;
static_cast<Query_Node> (
curr_id_node->value)->set_field_specifier(field_specifier,
true,
scanner_node);
static_cast<Query_Node> (curr_id_node->value)->query_ctr= 0;

static_cast<Query_Node> (curr_id_node->value)->negated= (negation_optional);

curr_query= static_cast<Query_Node> (curr_id_node->value);

}



else
{
if(type==QUERY_TYPE)
{
delete static_cast<Query_Node> (v);
}

else if(type==DATETIME_TYPE)
{
delete static_cast<Date_Time_Node> (v);
}

v= 0;

curr_query= 0;
return 1;
}



}





else if(assignment_operator==XOR_ASSIGN)
{



if(curr_id_node&&curr_id_node->value)
{

curr_query= static_cast<Query_Node> (curr_id_node->value);

while(curr_query->xor_node!=0)
curr_query= curr_query->xor_node;

if(type==QUERY_TYPE)
curr_query->xor_node= static_cast<Query_Node> (v);
else if(type==DATETIME_TYPE)
{
temp_query= new Query_Type;
temp_query->value_type= Query_Type::DATE_TIME_TYPE;
temp_query->value= v;
curr_query->xor_node= temp_query;
}

curr_query->xor_node->query_ctr= curr_query->query_ctr+1;




traverse_query= curr_query->and_node;
while(traverse_query->and_node)
traverse_query= traverse_query->and_node;

if(traverse_query)
curr_query->xor_node->query_ctr+= traverse_query->query_ctr;



traverse_query= curr_query->or_node;
while(traverse_query->or_node)
traverse_query= traverse_query->or_node;

if(traverse_query)
curr_query->xor_node->query_ctr+= traverse_query->query_ctr;



curr_query->xor_node->query_type= Query_Type::XOR_TYPE;
curr_query->xor_node->up= curr_query;
curr_query= curr_query->xor_node;

curr_query->set_field_specifier(field_specifier,
true,
scanner_node);

curr_query->negated= (negation_optional);

}



else if(curr_id_node)
{
if(type==QUERY_TYPE)
curr_id_node->value= v;
else if(type==DATETIME_TYPE)
{
temp_query= new Query_Type;
temp_query->value_type= Query_Type::DATE_TIME_TYPE;
temp_query->value= v;
curr_id_node->value= static_cast<void*> (temp_query);
}

static_cast<Query_Node> (curr_id_node->value)->id_node
= curr_id_node;
static_cast<Query_Node> (curr_id_node->value)->name
= curr_id_node->name;
static_cast<Query_Node> (curr_id_node->value)->query_type= Query_Type::TOP_TYPE;
static_cast<Query_Node> (curr_id_node->value)->query_ctr= 0;
static_cast<Query_Node> (
curr_id_node->value)->set_field_specifier(field_specifier,
true,
scanner_node);

static_cast<Query_Node> (curr_id_node->value)->negated= (negation_optional);

curr_query= static_cast<Query_Node> (curr_id_node->value);

}



else
{
if(type==QUERY_TYPE)
{
delete static_cast<Query_Node> (v);
}
else if(type==DATETIME_TYPE)
{
delete static_cast<Date_Time_Node> (v);
}

v= 0;

curr_query= 0;
return 1;
}



}




/*:26*//*27:*/
#line 1476 "prsrfncs.web"


else
{
curr_query= 0;
return 1;
}



/*:27*//*28:*/
#line 1494 "prsrfncs.web"


if(curr_query)
{

curr_query->match_value= match_term_optional;

}




/*:28*//*29:*/
#line 1507 "prsrfncs.web"


#ifdef DEBUG_OUTPUT
temp_strm<<endl
<<"Exiting `Scan_Parse::query_assignment_func_1' successfully "
<<"with return value 0."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return 0;




#undef DEBUG_OUTPUT

}




/*:29*//*30:*/
#line 1554 "prsrfncs.web"

int
Scan_Parse::datetime_assignment_func_0(void*v,
Date_Time_Node&curr_date_time_node,
int specifier,
int op,
void*val,
int type)
{


#if 1 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif

stringstream temp_strm;

Scanner_Node scanner_node= static_cast<Scanner_Node> (v);

#ifdef DEBUG_OUTPUT
temp_strm<<"Entering `Scan_Parse::datetime_assignment_func_0'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



#ifdef DEBUG_OUTPUT
temp_strm<<"`specifier' == "<<token_map[specifier]
<<endl
<<"`op' == "<<token_map[op]
<<endl
<<"`type' == "<<token_map[type]
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

#endif



/*:30*//*31:*/
#line 1609 "prsrfncs.web"


if(val==0)
{
temp_strm<<"ERROR!  In `Scan_Parse::datetime_assignment_func_0':"
<<endl
<<"`val' == 0'.  Can't assign."
<<endl
<<"Exiting function unsuccessfully with return value 1."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

return 1;

}



/*:31*//*32:*/
#line 1633 "prsrfncs.web"


if(curr_date_time_node==0)
{
curr_date_time_node= new Date_Time_Type;

}






/*:32*//*33:*/
#line 1647 "prsrfncs.web"


if(op==ASSIGN)
{



if(specifier==YEAR_RANGE_BEGIN)
{
if(curr_date_time_node->year_range_begin==0)
curr_date_time_node->year_range_begin= new short;

*curr_date_time_node->year_range_begin= *static_cast<short*> (val);


}




if(specifier==YEAR_RANGE_END)
{

if(curr_date_time_node->year_range_end==0)
curr_date_time_node->year_range_end= new short;

*curr_date_time_node->year_range_end= *static_cast<short*> (val);

}




if(specifier==YEAR)
{
if(curr_date_time_node->year==0)
curr_date_time_node->year= new short;

*curr_date_time_node->year= *static_cast<short*> (val);

}




else if(specifier==MONTH)
{
if(curr_date_time_node->month==0)
curr_date_time_node->month= new unsigned short;

*curr_date_time_node->month= *static_cast<unsigned short*> (val);


}



else if(specifier==DAY)
{
if(curr_date_time_node->day==0)
curr_date_time_node->day= new unsigned short;

*curr_date_time_node->day= *static_cast<unsigned short*> (val);

}




else if(specifier==HOUR)
{
if(curr_date_time_node->hour==0)
curr_date_time_node->hour= new unsigned short;

*curr_date_time_node->hour= *static_cast<unsigned short*> (val);

}




else if(specifier==MINUTE)
{

if(curr_date_time_node->minute==0)
curr_date_time_node->minute= new unsigned short;

*curr_date_time_node->minute= *static_cast<unsigned short*> (val);


}




else if(specifier==SECOND)
{
if(curr_date_time_node->second==0)
curr_date_time_node->second= new float;

if(type==FLOAT)
*curr_date_time_node->second= *static_cast<float*> (val);
else if(type==INTEGER)
*curr_date_time_node->second
= static_cast<float> (*static_cast<int*> (val));

}



}



/*:33*//*34:*/
#line 1762 "prsrfncs.web"



else if(op==PLUS_ASSIGN)
{



if(specifier==YEAR_RANGE_BEGIN)
{
if(curr_date_time_node->year_range_begin==0)
curr_date_time_node->year_range_begin= new short(0);

*curr_date_time_node->year_range_begin+= *static_cast<short*> (val);


}




if(specifier==YEAR_RANGE_END)
{

if(curr_date_time_node->year_range_end==0)
curr_date_time_node->year_range_end= new short(0);

*curr_date_time_node->year_range_end+= *static_cast<short*> (val);

}




if(specifier==YEAR)
{
if(curr_date_time_node->year==0)
curr_date_time_node->year= new short(0);

*curr_date_time_node->year+= *static_cast<short*> (val);

}




else if(specifier==MONTH)
{
if(curr_date_time_node->month==0)
curr_date_time_node->month= new unsigned short(0);

*curr_date_time_node->month+= *static_cast<unsigned short*> (val);


}



else if(specifier==DAY)
{
if(curr_date_time_node->day==0)
curr_date_time_node->day= new unsigned short(0);

*curr_date_time_node->day+= *static_cast<unsigned short*> (val);

}




else if(specifier==HOUR)
{
if(curr_date_time_node->hour==0)
curr_date_time_node->hour= new unsigned short(0);

*curr_date_time_node->hour+= *static_cast<unsigned short*> (val);

}




else if(specifier==MINUTE)
{

if(curr_date_time_node->minute==0)
curr_date_time_node->minute= new unsigned short(0);

*curr_date_time_node->minute+= *static_cast<unsigned short*> (val);


}




else if(specifier==SECOND)
{
if(curr_date_time_node->second==0)
curr_date_time_node->second= new float(0);


if(type==FLOAT)
*curr_date_time_node->second+= *static_cast<float*> (val);
else if(type==INTEGER)
*curr_date_time_node->second
+= static_cast<float> (*static_cast<int*> (val));

}



}



/*:34*//*35:*/
#line 1879 "prsrfncs.web"



else if(op==MINUS_ASSIGN)
{

}



/*:35*//*36:*/
#line 1890 "prsrfncs.web"



else if(op==TIMES_ASSIGN)
{

}



/*:36*//*37:*/
#line 1901 "prsrfncs.web"



else if(op==DIVIDE_ASSIGN)
{

}


/*:37*//*38:*/
#line 1913 "prsrfncs.web"


else
{
temp_strm<<"ERROR!  In `Scan_Parse::datetime_assignment_func_0':"
<<endl
<<"`op' has invalid value:  "<<token_map[op]
<<" ("<<op<<")"
<<endl
<<"Exiting function unsuccessfully with return value 1."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

return 1;

}




#ifdef DEBUG_OUTPUT
temp_strm<<"Exiting `Scan_Parse::datetime_assignment_func_0' "
<<"successfully with return value 0."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
getchar();
#endif

return 0;

}



/*:38*//*39:*/
#line 1978 "prsrfncs.web"

int
Scan_Parse::datetime_assignment_func_1(void*v,
Date_Time_Node&d,
int op,
void*&w)
{


#if 1 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif

stringstream temp_strm;

Scanner_Node scanner_node= static_cast<Scanner_Node> (v);

#ifdef DEBUG_OUTPUT
temp_strm<<"Entering `Scan_Parse::datetime_assignment_func_1'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif


/*:39*//*40:*/
#line 2010 "prsrfncs.web"


vector<pair<int,void*> > *vec
= static_cast<vector<pair<int,void*> > *> (w);



if(vec==0)
{
temp_strm<<"ERROR!  In `Scan_Parse::datetime_assignment_func_1':"
<<endl
<<"`datetime_element_list' == NULL.  "
<<"Exiting function unsuccessfully with return value 1."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

return 1;

}


/*:40*//*41:*/
#line 2037 "prsrfncs.web"


if(vec->size()==0)
{
temp_strm<<"ERROR!  In `Scan_Parse::datetime_assignment_func_1':"
<<endl
<<"`vec' is empty.  "
<<"Exiting function unsuccessfully with return value 1."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

delete vec;
vec= 0;

return 1;

}



/*:41*//*42:*/
#line 2063 "prsrfncs.web"


if(vec->size()> 0&&vec->at(0).first!=INTEGER
||vec->size()> 1&&vec->at(1).first!=INTEGER
||vec->size()> 2&&vec->at(2).first!=INTEGER
||vec->size()> 3&&vec->at(3).first!=INTEGER
||vec->size()> 4&&vec->at(4).first!=INTEGER)
{
temp_strm<<"ERROR!  In `Scan_Parse::datetime_assignment_func_1':"
<<endl
<<"Invalid value in `vec'."
<<endl
<<"Exiting function unsuccessfully with return value 1."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

for(vector<pair<int,void*> > ::iterator iter
= vec->begin();
iter!=vec->end();
++iter)
{
if(iter->first==INTEGER)
{
delete static_cast<int*> (iter->second);
}
else if(iter->first==FLOAT)
{
delete static_cast<float*> (iter->second);
}

iter->second= 0;

}

vec->clear();

delete vec;
vec= 0;

return 1;

}


/*:42*//*43:*/
#line 2115 "prsrfncs.web"


if(d==0)
d= new Date_Time_Type;

d->year= static_cast<short*> (vec->at(0).second);
vec->at(0).second= 0;



/*:43*//*44:*/
#line 2128 "prsrfncs.web"


if(vec->size()> 1)
{
d->month= static_cast<unsigned short*> (vec->at(1).second);
vec->at(1).second= 0;
}


/*:44*//*45:*/
#line 2140 "prsrfncs.web"


if(vec->size()> 2)
{
d->day= static_cast<unsigned short*> (vec->at(2).second);
vec->at(2).second= 0;
}



/*:45*//*46:*/
#line 2153 "prsrfncs.web"


if(vec->size()> 3)
{
d->hour= static_cast<unsigned short*> (vec->at(3).second);
vec->at(3).second= 0;
}


/*:46*//*47:*/
#line 2165 "prsrfncs.web"


if(vec->size()> 4)
{
d->minute= static_cast<unsigned short*> (vec->at(4).second);
vec->at(4).second= 0;
}



/*:47*//*48:*/
#line 2178 "prsrfncs.web"


if(vec->size()> 5)
{
if(vec->at(5).first==FLOAT)
d->second= static_cast<float*> (vec->at(5).second);
else
{

d->second= new float;
*d->second= static_cast<float> (*static_cast<int*> (vec->at(5).second));
delete static_cast<int*> (vec->at(5).second);
}

vec->at(5).second= 0;
}


/*:48*//*49:*/
#line 2197 "prsrfncs.web"


#ifdef DEBUG_OUTPUT
temp_strm<<"Exiting `Scan_Parse::datetime_assignment_func_1' "
<<"successfully with return value 0."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return 0;

}








/*:49*/
#line 2233 "prsrfncs.web"
















/*:51*/
