/* * (1) Copyright and License. */

/* This file is part of the LDF Metadata Exchange Utilities,             */
/* a package for metadata exchange.                                      */

/* Copyright (C) 2007 Laurence D. Finston   */

/* The author is Laurence D. Finston.  */

/* The LDF Metadata Exchange Utilities are free software;                   */
/* you can redistribute them and/or modify                                  */
/* them under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation; either version 2 of the License, or        */
/* (at your option) any later version.                                      */

/* The LDF Metadata Exchange Utilities are distributed in the hope               */
/* that they will be useful, but WITHOUT ANY WARRANTY; without even              */
/* the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  */
/* See the GNU General Public License for more details.                          */

/* You should have received a copy of the GNU General Public License                   */
/* along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  */
/* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          */

/* The LDF Metadata Exchange Utilities are available for downloading from the  */
/* following FTP server:                                                       */
/* ftp:/*ftp.gwdg.de/pub/gnu2/iwfmdh/                                          */

/* Please send bug reports to lfinsto1@gwdg.de  */

/* The author can be contacted at:  */

/* Laurence D. Finston  */
/* Kreuzbergring 41     */
/* D-37075 Goettingen   */
/* Germany              */

/* lfinsto1@gwdg.de                */
/* s246794@stud.uni-goettingen.de  */


/*35:*/
#line 2003 "qtgensql.web"

/*2:*/
#line 91 "qtgensql.web"


#include "localldf.h"

#ifdef NON_WIN_LDF
#include "nonwin.h"
#else
#include "stdafx.h"
#endif

#include "parser.hxx"
#include "dttmtype.h"
#include "idtype.h"
#include "scnrtype.h"
#include "scanner.h"
#include "querytyp.h"


/*:2*/
#line 2004 "qtgensql.web"

/*1:*/
#line 82 "qtgensql.web"


static char id_string[]
= "$Id: qtgensql.web,v 1.6 2007/02/13 20:40:08 lfinsto1 Exp $";



/*:1*/
#line 2005 "qtgensql.web"

using namespace std;
using namespace Scan_Parse;
/*4:*/
#line 131 "qtgensql.web"

int
Query_Type::generate_sql_string(Scanner_Node scanner_node,
int database_type,
stringstream*sql_strm,
stringstream*select_strm,
stringstream*from_strm,
stringstream*where_strm_0,
stringstream*where_strm_1,
bool*first_select,
bool*first_from,
bool*first_where,
bitset<QUERY_TYPE_BITSET_SIZE> *field_flags,
string*return_str)

{


#if 0 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif

stringstream temp_strm;
stringstream date_strm;

#ifdef DEBUG_OUTPUT
temp_strm<<"Entering `Query_Type::generate_sql_string'."
<<endl
<<"`query_ctr' == "<<query_ctr
<<endl
<<"`database_type' == "<<token_map[database_type]
<<endl
<<"`query_type' == "<<query_type_map[query_type]
<<endl
<<"`*first_select' == "<<*first_select
<<endl
<<"`*first_where' == "<<*first_where
<<endl
<<"`*first_from == "<<*first_from
<<endl
<<"`query_ctr' == "<<query_ctr
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
getchar();
#endif


/*:4*//*5:*/
#line 194 "qtgensql.web"


string match_str;

if(match_value==QUERY_TYPE_NULL_TYPE)
match_str= "=";

else if(match_value==CONTAINS_VALUE)
match_str= "contains";

else if(match_value==FREETEXT_VALUE)
match_str= "freetext";

else if(match_value==LIKE_VALUE)
match_str= "like";

else
{
temp_strm<<"WARNING!  In `Query_Type::generate_sql_string':"
<<endl
<<"`match_value' has invalid value:  "
<<match_value
<<endl
<<"Will use `=' as the match operator."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
}


/*:5*//*6:*/
#line 232 "qtgensql.web"


string query_type_str;


/*:6*//*7:*/
#line 240 "qtgensql.web"


string open_parenthesis_str;
string close_parenthesis_str;

if(and_node||or_node||xor_node)
{
open_parenthesis_str= "(";

close_parenthesis_str= ")";
}
else
{
open_parenthesis_str= "";
close_parenthesis_str= "";
}



if(query_type==AND_TYPE)
query_type_str= "and";



else if(query_type==OR_TYPE)
query_type_str= "or";



else if(query_type==XOR_TYPE)
{



if(database_type==OAI)
{
temp_strm<<"ERROR!  In `Query_Type::generate_sql_string':"
<<endl
<<"`query_type' == `XOR_TYPE' and `database_type' == `OAI'."
<<endl
<<"This combination of types is not allowed."
<<endl
<<"Exiting function unsuccessfully with return value 1."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

*return_str= "";
return 1;

}




query_type_str= "xor";

}





if(negated)
query_type_str+= " not";


/*:7*//*8:*/
#line 312 "qtgensql.web"





if(query_ctr==0)
*select_strm<<"select "<<endl;



#if 0 
cerr<<"`field_type' == "<<field_type_map[field_type]
<<endl;
#endif



/*:8*//*9:*/
#line 332 "qtgensql.web"


if(field_type==AUTHOR_SURNAME_FIELD&&database_type==PICA)
{



if(*first_select)
{
*select_strm<<"RAUT.record_id";
*first_select= false;
}



if((*field_flags
&AUTHOR_FLAG)
==NULL_BITSET)
{
*select_strm<<", AUT.author_id"
<<endl;
}



if((*field_flags
&AUTHOR_SURNAME_FLAG)
==NULL_BITSET)
{
*select_strm<<", AUT.author_surname"
<<endl;
}



if(*first_from)
*from_strm<<"from ";
else if((*field_flags
&AUTHOR_FLAG)
==NULL_BITSET)
{
*from_strm<<", ";
}

*first_from= false;

if((*field_flags
&AUTHOR_FLAG)
==NULL_BITSET)
{
*from_strm<<"Authors as AUT, Records_Authors as RAUT"
<<endl;
}

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"AUT.author_surname "<<match_str<<" '"
<<*static_cast<string*> (value)
<<"' ";

if((*field_flags
&AUTHOR_FLAG)
==NULL_BITSET)
{
*where_strm_1<<"and RAUT.author_id = AUT.author_id"
<<endl;
}

*field_flags|= AUTHOR_SURNAME_FLAG;
*field_flags|= AUTHOR_FLAG;


}



/*:9*//*10:*/
#line 418 "qtgensql.web"


else if(field_type==AUTHOR_GIVEN_NAME_FIELD&&database_type==PICA)
{



if(*first_select)
{
*select_strm<<"RAUT.record_id";
*first_select= false;
}



if((*field_flags
&AUTHOR_FLAG)
==NULL_BITSET)
{
*select_strm<<", AUT.author_id"
<<endl;
}



if((*field_flags
&AUTHOR_GIVEN_NAME_FLAG)
==NULL_BITSET)
{
*select_strm<<", AUT.author_given_name"
<<endl;
}



if(*first_from)
*from_strm<<"from ";
else if((*field_flags
&AUTHOR_FLAG)
==NULL_BITSET)
{
*from_strm<<", ";
}

*first_from= false;

if((*field_flags
&AUTHOR_FLAG)
==NULL_BITSET)
{
*from_strm<<"Authors as AUT, Records_Authors as RAUT"
<<endl;
}

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"AUT.author_given_name "<<match_str<<" '"
<<*static_cast<string*> (value)
<<"' ";

if((*field_flags
&AUTHOR_FLAG)
==NULL_BITSET)
{
*where_strm_1<<"and RAUT.author_id = AUT.author_id"
<<endl;
}

*field_flags|= AUTHOR_GIVEN_NAME_FLAG;
*field_flags|= AUTHOR_FLAG;

}



/*:10*//*11:*/
#line 503 "qtgensql.web"


else if(field_type==AUTHOR_PREFIX_FIELD&&database_type==PICA)
{



if(*first_select)
{
*select_strm<<"RAUT.record_id";
*first_select= false;
}



if((*field_flags
&AUTHOR_FLAG)
==NULL_BITSET)
{
*select_strm<<", AUT.author_id"
<<endl;
}



if((*field_flags
&AUTHOR_PREFIX_FLAG)
==NULL_BITSET)
{
*select_strm<<", AUT.author_prefix"
<<endl;
}



if(*first_from)
*from_strm<<"from ";
else if((*field_flags
&AUTHOR_FLAG)
==NULL_BITSET)
{
*from_strm<<", ";
}

*first_from= false;

if((*field_flags
&AUTHOR_FLAG)
==NULL_BITSET)
{
*from_strm<<"Authors as AUT, Records_Authors as RAUT"
<<endl;
}

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"AUT.author_prefix "<<match_str<<" '"
<<*static_cast<string*> (value)
<<"' ";

if((*field_flags
&AUTHOR_FLAG)
==NULL_BITSET)
{
*where_strm_1<<"and RAUT.author_id = AUT.author_id"
<<endl;
}

*field_flags|= AUTHOR_PREFIX_FLAG;
*field_flags|= AUTHOR_FLAG;


}



/*:11*//*12:*/
#line 589 "qtgensql.web"


if(field_type==CONTRIBUTOR_SURNAME_FIELD&&database_type==PICA)
{



if(*first_select)
{
*select_strm<<"RCNTRB.record_id";
*first_select= false;
}



if((*field_flags
&CONTRIBUTOR_FLAG)
==NULL_BITSET)
{
*select_strm<<", CNTRB.contributor_id"
<<endl;
}



if((*field_flags
&CONTRIBUTOR_SURNAME_FLAG)
==NULL_BITSET)
{
*select_strm<<", CNTRB.contributor_surname"
<<endl;
}



if(*first_from)
*from_strm<<"from ";
else if((*field_flags
&CONTRIBUTOR_FLAG)
==NULL_BITSET)
{
*from_strm<<", ";
}

*first_from= false;

if((*field_flags
&CONTRIBUTOR_FLAG)
==NULL_BITSET)
{
*from_strm<<"Contributors as CNTRB, Records_Contributors as RCNTRB"
<<endl;
}

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"CNTRB.contributor_surname "<<match_str<<" '"
<<*static_cast<string*> (value)
<<"' ";

if((*field_flags
&CONTRIBUTOR_FLAG)
==NULL_BITSET)
{
*where_strm_1<<"and RCNTRB.contributor_id = CNTRB.contributor_id"
<<endl;
}

*field_flags|= CONTRIBUTOR_SURNAME_FLAG;
*field_flags|= CONTRIBUTOR_FLAG;

}



/*:12*//*13:*/
#line 674 "qtgensql.web"


else if(field_type==CONTRIBUTOR_GIVEN_NAME_FIELD&&database_type==PICA)
{



if(*first_select)
{
*select_strm<<"RCNTRB.record_id";
*first_select= false;
}



if((*field_flags
&CONTRIBUTOR_FLAG)
==NULL_BITSET)
{
*select_strm<<", CNTRB.contributor_id"
<<endl;
}



if((*field_flags
&CONTRIBUTOR_GIVEN_NAME_FLAG)
==NULL_BITSET)
{
*select_strm<<", CNTRB.contributor_given_name"
<<endl;
}



if(*first_from)
*from_strm<<"from ";
else if((*field_flags
&CONTRIBUTOR_FLAG)
==NULL_BITSET)
{
*from_strm<<", ";
}

*first_from= false;

if((*field_flags
&CONTRIBUTOR_FLAG)
==NULL_BITSET)
{
*from_strm<<"Contributors as CNTRB, Records_Contributors as RCNTRB"
<<endl;
}


if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"CNTRB.contributor_given_name "<<match_str<<" '"
<<*static_cast<string*> (value)
<<"' ";

if((*field_flags
&CONTRIBUTOR_FLAG)
==NULL_BITSET)
{
*where_strm_1<<"and RCNTRB.contributor_id = CNTRB.contributor_id"
<<endl;
}

*field_flags|= CONTRIBUTOR_GIVEN_NAME_FLAG;
*field_flags|= CONTRIBUTOR_FLAG;

}



/*:13*//*14:*/
#line 760 "qtgensql.web"


else if(field_type==CONTRIBUTOR_PREFIX_FIELD&&database_type==PICA)
{



if(*first_select)
{
*select_strm<<"RCNTRB.record_id";
*first_select= false;
}



if((*field_flags
&CONTRIBUTOR_FLAG)
==NULL_BITSET)
{
*select_strm<<", CNTRB.contributor_id"
<<endl;
}



if((*field_flags
&CONTRIBUTOR_PREFIX_FLAG)
==NULL_BITSET)
{
*select_strm<<", CNTRB.contributor_prefix"
<<endl;
}



if(*first_from)
*from_strm<<"from ";
else if((*field_flags
&CONTRIBUTOR_FLAG)
==NULL_BITSET)
{
*from_strm<<", ";
}

*first_from= false;

if((*field_flags
&CONTRIBUTOR_FLAG)
==NULL_BITSET)
{
*from_strm<<"Contributors as CNTRB, Records_Contributors as RCNTRB"
<<endl;
}


if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"CNTRB.contributor_prefix "<<match_str<<" '"
<<*static_cast<string*> (value)
<<"' ";

if((*field_flags
&CONTRIBUTOR_FLAG)
==NULL_BITSET)
{
*where_strm_1<<"and RCNTRB.contributor_id = CNTRB.contributor_id"
<<endl;
}

*field_flags|= CONTRIBUTOR_PREFIX_FLAG;
*field_flags|= CONTRIBUTOR_FLAG;

}


/*:14*//*15:*/
#line 845 "qtgensql.web"


else if(field_type==CONTRIBUTOR_FIELD&&database_type==OAI)
{
if(*first_select)
{
*select_strm<<"RCN.record_id";
*first_select= false;
}

if((*field_flags&CONTRIBUTOR_FLAG)==NULL_BITSET)
*select_strm<<", CN.contributor_id, CN.dc_contributor"
<<endl;

if(*first_from)
*from_strm<<"from ";
else if((*field_flags&CONTRIBUTOR_FLAG)==NULL_BITSET)
*from_strm<<", ";

*first_from= false;

if((*field_flags&CONTRIBUTOR_FLAG)==NULL_BITSET)
*from_strm<<"Contributors as CN, Records_Contributors as RCN"
<<endl;

if(*first_where)
*where_strm_0<<"where ";
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"CN.dc_contributor "<<match_str<<" '"
<<*static_cast<string*> (value)
<<"' ";


if((*field_flags&CONTRIBUTOR_FLAG)==NULL_BITSET)
*where_strm_1<<"and RCN.contributor_id = CN.contributor_id"<<endl;

*field_flags|= CONTRIBUTOR_FLAG;

}


/*:15*//*16:*/
#line 895 "qtgensql.web"


else if(field_type==CREATOR_FIELD&&database_type==OAI)
{

if(*first_select)
{
*select_strm<<"RC.record_id";
*first_select= false;
}

if((*field_flags&CREATOR_FLAG)==NULL_BITSET)
*select_strm<<", C.creator_id, C.dc_creator"
<<endl;

if(*first_from)
*from_strm<<"from ";
else if((*field_flags&CREATOR_FLAG)==NULL_BITSET)
*from_strm<<", ";

*first_from= false;

if((*field_flags&CREATOR_FLAG)==NULL_BITSET)
*from_strm<<"Creators as C, Records_Creators as RC"
<<endl;

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"C.dc_creator "<<match_str<<" '"
<<*static_cast<string*> (value)
<<"' ";

if((*field_flags&CREATOR_FLAG)==NULL_BITSET)
*where_strm_1<<"and RC.creator_id = C.creator_id"<<endl;

*field_flags|= CREATOR_FLAG;




}



else if(field_type==TITLE_FIELD)
{


/*:16*//*17:*/
#line 958 "qtgensql.web"


if(database_type==OAI)
{

if(*first_select)
{
*select_strm<<"T.record_id";
*first_select= false;
}

if((*field_flags&TITLE_FLAG)==NULL_BITSET)
*select_strm<<", T.title_id, T.dc_title"
<<endl;

if(*first_from)
*from_strm<<"from ";
else if((*field_flags&TITLE_FLAG)==NULL_BITSET)
*from_strm<<", ";

*first_from= false;

if((*field_flags&TITLE_FLAG)==NULL_BITSET)
*from_strm<<"Titles as T, Records as REC"
<<endl;

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"T.dc_title "<<match_str<<" '"
<<*static_cast<string*> (value)
<<"' ";

if((*field_flags&TITLE_FLAG)==NULL_BITSET)
*where_strm_1<<"and T.record_id = REC.record_id"<<endl;

*field_flags|= TITLE_FLAG;

}



}



/*:17*//*18:*/
#line 1018 "qtgensql.web"


else if(field_type==MAIN_CANONICAL_TITLE_FIELD)
{


/*:18*//*19:*/
#line 1032 "qtgensql.web"


if(database_type==PICA)
{

if(*first_select)
{
*select_strm<<"RMT.record_id";
*first_select= false;
}

if((*field_flags&MAIN_CANONICAL_TITLE_FLAG)==NULL_BITSET)
*select_strm<<", MT.main_title_id, MT.main_canonical_title"
<<endl;

if(*first_from)
*from_strm<<"from ";
else if((*field_flags&MAIN_CANONICAL_TITLE_FLAG)==NULL_BITSET)
*from_strm<<", ";

*first_from= false;

if((*field_flags&MAIN_CANONICAL_TITLE_FLAG)==NULL_BITSET)
*from_strm<<"Main_Titles as MT, Records_Main_Titles as RMT"
<<endl;

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"MT.main_canonical_title "<<match_str<<" '"
<<*static_cast<string*> (value)
<<"' ";

if((*field_flags&MAIN_CANONICAL_TITLE_FLAG)==NULL_BITSET)
*where_strm_1<<"and RMT.main_title_id = MT.main_title_id"
<<endl;

*field_flags|= MAIN_CANONICAL_TITLE_FLAG;

}



}



/*:19*//*21:*/
#line 1104 "qtgensql.web"


else if(field_type==RECORD_ID_FIELD&&database_type==PICA)
{



if(*first_select)
{
*select_strm<<"REC.record_id"<<endl;
*first_select= false;
}




else if((*field_flags
&RECORD_ID_FLAG)
==NULL_BITSET)
{
*select_strm<<", REC.record_id"
<<endl;
}



if(*first_from)
*from_strm<<"from ";
else if((*field_flags
&RECORD_FLAG)
==NULL_BITSET)
{
*from_strm<<", ";
}

*first_from= false;

if((*field_flags
&RECORD_FLAG)
==NULL_BITSET)
{
*from_strm<<"Records as REC"
<<endl;
}

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"REC.record_id "<<match_str<<" "
<<*static_cast<int*> (value)
<<" ";

*field_flags|= RECORD_ID_FLAG;
*field_flags|= RECORD_FLAG;




}



/*:21*//*22:*/
#line 1180 "qtgensql.web"


else if(field_type==RECORD_ELN_ORIGINAL_ENTRY_FIELD
&&database_type==PICA)
{




if(*first_select)
{
*select_strm<<"REC.record_id";
*first_select= false;
}



if((*field_flags
&RECORD_ELN_ORIGINAL_ENTRY_FLAG)
==NULL_BITSET)
{
*select_strm<<", REC.eln_original_entry"
<<endl;
}



if(*first_from)
*from_strm<<"from ";
else if((*field_flags
&RECORD_FLAG)
==NULL_BITSET)
{
*from_strm<<", ";
}

*first_from= false;

if((*field_flags
&RECORD_FLAG)
==NULL_BITSET)
{
*from_strm<<"Records as REC"
<<endl;
}

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"REC.eln_original_entry "<<match_str<<" "
<<*static_cast<int*> (value)
<<" ";

*field_flags|= RECORD_ELN_ORIGINAL_ENTRY_FLAG;
*field_flags|= RECORD_FLAG;

}




/*:22*//*23:*/
#line 1255 "qtgensql.web"


else if(field_type==RECORD_ELN_MOST_RECENT_CHANGE_FIELD
&&database_type==PICA)
{



if(*first_select)
{
*select_strm<<"REC.record_id";
*first_select= false;
}



if((*field_flags
&RECORD_ELN_MOST_RECENT_CHANGE_FLAG)
==NULL_BITSET)
{
*select_strm<<", REC.eln_most_recent_change"
<<endl;
}



if(*first_from)
*from_strm<<"from ";
else if((*field_flags
&RECORD_FLAG)
==NULL_BITSET)
{
*from_strm<<", ";
}

*first_from= false;

if((*field_flags
&RECORD_FLAG)
==NULL_BITSET)
{
*from_strm<<"Records as REC"
<<endl;
}

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"REC.eln_most_recent_change "<<match_str<<" "
<<*static_cast<int*> (value)
<<" ";

*field_flags|= RECORD_ELN_MOST_RECENT_CHANGE_FLAG;
*field_flags|= RECORD_FLAG;

}




/*:23*//*24:*/
#line 1329 "qtgensql.web"


else if(field_type==RECORD_ELN_STATUS_CHANGE_FIELD
&&database_type==PICA)
{



if(*first_select)
{
*select_strm<<"REC.record_id";
*first_select= false;
}



if((*field_flags
&RECORD_ELN_STATUS_CHANGE_FLAG)
==NULL_BITSET)
{
*select_strm<<", REC.eln_status_change"
<<endl;
}



if(*first_from)
*from_strm<<"from ";
else if((*field_flags
&RECORD_FLAG)
==NULL_BITSET)
{
*from_strm<<", ";
}

*first_from= false;

if((*field_flags
&RECORD_FLAG)
==NULL_BITSET)
{
*from_strm<<"Records as REC"
<<endl;
}

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"REC.eln_status_change "<<match_str<<" "
<<*static_cast<int*> (value)
<<" ";

*field_flags|= RECORD_ELN_STATUS_CHANGE_FLAG;
*field_flags|= RECORD_FLAG;

}




/*:24*//*25:*/
#line 1403 "qtgensql.web"


else if(field_type==RECORD_IDENTIFICATION_NUMBER_FIELD
&&database_type==PICA)
{



if(*first_select)
{
*select_strm<<"REC.record_id";
*first_select= false;
}



if((*field_flags
&RECORD_IDENTIFICATION_NUMBER_FLAG)
==NULL_BITSET)
{
*select_strm<<", REC.identification_number"
<<endl;
}



if(*first_from)
*from_strm<<"from ";
else if((*field_flags
&RECORD_FLAG)
==NULL_BITSET)
{
*from_strm<<", ";
}

*first_from= false;

if((*field_flags
&RECORD_FLAG)
==NULL_BITSET)
{
*from_strm<<"Records as REC"
<<endl;
}

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"REC.identification_number "<<match_str<<" '"
<<*static_cast<string*> (value)
<<"' ";

*field_flags|= RECORD_IDENTIFICATION_NUMBER_FLAG;
*field_flags|= RECORD_FLAG;

}





/*:25*//*26:*/
#line 1478 "qtgensql.web"


else if(field_type==RECORD_DATE_STATUS_CHANGE_FIELD
&&database_type==PICA)
{



if(*first_select)
{
*select_strm<<"REC.record_id";
*first_select= false;
}



if((*field_flags
&RECORD_DATE_STATUS_CHANGE_FLAG)
==NULL_BITSET)
{
*select_strm<<", REC.date_status_change"
<<endl;
}



if(*first_from)
*from_strm<<"from ";
else if((*field_flags
&RECORD_FLAG)
==NULL_BITSET)
{
*from_strm<<", ";
}

*first_from= false;



if((*field_flags
&RECORD_FLAG)
==NULL_BITSET)
{
*from_strm<<"Records as REC"
<<endl;
}



if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;





Date_Time_Node d= static_cast<Date_Time_Node> (value);

date_strm.str("");


*where_strm_0<<"REC.date_status_change "<<match_str
<<" convert(datetime, '";




if(d->year)
*where_strm_0<<setfill('0')<<right<<setw(4)
<<*d->year;
else
*where_strm_0<<"0000";

*where_strm_0<<"-";



if(d->month)
*where_strm_0<<setfill('0')<<right<<setw(2)
<<*d->month;
else
*where_strm_0<<"00";

*where_strm_0<<"-";




if(d->day)
*where_strm_0<<setfill('0')<<right<<setw(2)
<<*d->day;
else
*where_strm_0<<"00";

*where_strm_0<<" ";



if(d->hour)
*where_strm_0<<setfill('0')<<right<<setw(2)
<<*d->hour;
else
*where_strm_0<<"00";

*where_strm_0<<":";



if(d->minute)
*where_strm_0<<setfill('0')<<right<<setw(2)
<<*d->minute;
else
*where_strm_0<<"00";

*where_strm_0<<":";




if(d->second)
{

if(*d->second<10)
*where_strm_0<<"0";

*where_strm_0<<fixed<<setprecision(3)
<<*d->second;

}

else
*where_strm_0<<"00.000";



*where_strm_0<<"', 121)";





*field_flags|= RECORD_DATE_STATUS_CHANGE_FLAG;
*field_flags|= RECORD_FLAG;





}








/*:26*//*27:*/
#line 1644 "qtgensql.web"


else if(field_type==SUBJECT_FIELD)
{


/*:27*//*28:*/
#line 1656 "qtgensql.web"


if(database_type==PICA)
{
if(*first_select)
{
*select_strm<<"RS.record_id";
*first_select= false;
}

if((*field_flags&SUBJECT_FLAG)==NULL_BITSET)
*select_strm<<", S.subject_id, S.subject"
<<endl;

if(*first_from)
*from_strm<<"from ";
else if((*field_flags&SUBJECT_FLAG)==NULL_BITSET)
*from_strm<<", ";

*first_from= false;

if((*field_flags&SUBJECT_FLAG)==NULL_BITSET)
*from_strm<<"Subjects as S, Records_Subjects as RS"
<<endl;

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"S.subject "<<match_str<<" '"
<<*static_cast<string*> (value)
<<"' ";

if((*field_flags&SUBJECT_FLAG)==NULL_BITSET)
*where_strm_1<<"and RS.subject_id = S.subject_id"
<<endl;

*field_flags|= SUBJECT_FLAG;

}


/*:28*//*29:*/
#line 1704 "qtgensql.web"


if(database_type==OAI)
{
if(*first_select)
{
*select_strm<<"RS.record_id";
*first_select= false;
}

if((*field_flags&SUBJECT_FLAG)==NULL_BITSET)
*select_strm<<", S.subject_id, S.dc_subject"
<<endl;

if(*first_from)
*from_strm<<"from ";
else if((*field_flags&SUBJECT_FLAG)==NULL_BITSET)
*from_strm<<", ";

*first_from= false;

if((*field_flags&SUBJECT_FLAG)==NULL_BITSET)
*from_strm<<"Subjects as S, Records_Subjects as RS"
<<endl;

if(*first_where)
*where_strm_0<<"where "<<endl;
else
{
*where_strm_0<<query_type_str<<" "<<open_parenthesis_str;
}

*first_where= false;

*where_strm_0<<"S.dc_subject "<<match_str<<" '"
<<*static_cast<string*> (value)
<<"' ";

if((*field_flags&SUBJECT_FLAG)==NULL_BITSET)
*where_strm_1<<"and RS.subject_id = S.subject_id"
<<endl;

*field_flags|= SUBJECT_FLAG;

}




}





temp_strm<<"`value_type' == "<<value_type_map[value_type]
<<endl;






temp_strm<<"`target_types' == ";

if(target_types.size()<=0)
temp_strm<<"QUERY_TYPE_NULL_TYPE";



else if(target_types.size()==1)
{
temp_strm<<target_type_map[target_types[0]];
}



else
{

int i= 0;

for(vector<unsigned short> ::iterator iter= target_types.begin();
iter!=target_types.end();
++iter)
{
if(i++> 0)
temp_strm<<endl<<"--"<<endl;

temp_strm<<target_type_map[*iter];

}

}



temp_strm<<endl;



if(value_type==QUERY_TYPE_STRING_TYPE)
{
temp_strm<<*static_cast<string*> (value)
<<endl;

if(value_type==QUERY_TYPE_STRING_TYPE)
;
#if 0 
*sql_strm<<*static_cast<string*> (value)<<" ";
#endif

}




if(up)
temp_strm<<"`up' == "<<up->query_ctr;
else
temp_strm<<"`up' == 0";

temp_strm<<endl;



if(and_node)
{
temp_strm<<"`and' == "<<and_node->query_ctr;
}
else
temp_strm<<"`and_node' == 0";

temp_strm<<endl;



if(or_node)
{
temp_strm<<"`or' == "<<or_node->query_ctr;

}
else
temp_strm<<"`or_node' == 0";

temp_strm<<endl;



if(or_node)
{

temp_strm<<"`xor' == "<<xor_node->query_ctr;
}

else
temp_strm<<"`xor_node' == 0";

temp_strm<<endl;



if(and_node)
{

temp_strm<<"`and_node' == "<<endl;

*where_strm_0<<endl;

and_node->generate_sql_string(scanner_node,
database_type,
sql_strm,
select_strm,
from_strm,
where_strm_0,
where_strm_1,
first_select,
first_from,
first_where,
field_flags,
return_str);
}



if(or_node)
{
temp_strm<<"`or_node' == "<<endl;

*where_strm_0<<endl;

or_node->generate_sql_string(scanner_node,
database_type,
sql_strm,
select_strm,
from_strm,
where_strm_0,
where_strm_1,
first_select,
first_from,
first_where,
field_flags,
return_str);

}



if(xor_node)
{
temp_strm<<"`xor_node' == "<<endl;

*where_strm_0<<endl;

xor_node->generate_sql_string(scanner_node,
database_type,
sql_strm,
select_strm,
from_strm,
where_strm_0,
where_strm_1,
first_select,
first_from,
first_where,
field_flags,
return_str);

}


/*:29*//*30:*/
#line 1935 "qtgensql.web"




if(query_ctr> 0)
*where_strm_0<<close_parenthesis_str;


/*:30*//*31:*/
#line 1946 "qtgensql.web"


if(query_ctr==0)
{
*sql_strm<<select_strm->str()
<<from_strm->str()
<<where_strm_0->str()
<<endl
<<where_strm_1->str();
}


/*:31*//*32:*/
#line 1961 "qtgensql.web"


if(query_ctr==0)
temp_strm<<endl
<<"`sql_strm->str()' == "
<<endl
<<sql_strm->str()
<<endl
<<"Enter <RETURN> to continue: ";


/*:32*//*33:*/
#line 1975 "qtgensql.web"


#ifdef DEBUG_OUTPUT

temp_strm<<"Exiting `Query_Type::generate_sql_string'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

*return_str= sql_strm->str();
return 0;

}



/*:33*/
#line 2008 "qtgensql.web"
















/*:35*/
