@q queryexp.w@>
@q Created by Laurence D. Finston (LDF) 2006.11.15.@>

@q $Id: queryexp.w,v 1.5 2007/02/13 20:40:23 lfinsto1 Exp $ @>

@q * (1) Copyright and License. @>

@q This file is part of the LDF Metadata Exchange Utilities,            @>
@q a package for metadata exchange.                                     @>
@q It contains code from the the IWF Metadata Harvester, a package for  @>
@q metadata harvesting.                                                 @> 

@q The following copyright notice applies to the contents of this file up to  @>      
@q and including January 31, 2007:                                            @> 

@q Copyright (C) 2006, 2007 IWF Wissen und Medien gGmbH  @>

@q The following copyright notice applies to all changes and additions to this file  @>      
@q starting on February 1, 2007:                                                     @> 

@q Copyright (C) 2007 Laurence D. Finston  @>

@q The state of this file as of January 31, 2007 is stored in the  	  @>    
@q revision of this file with the symbolic tag "LAST_IWF"          	  @>
@q in the CVS repository for the LDF Metadata Exchange Utilities:  	  @>
@q http://cvs.savannah.nongnu.org/viewcvs/iwf-mdh/?root=iwf-mdh    	  @>
@q If necessary, changes and additions after this date can be determined  @>
@q by comparing this revision with later ones using the GNU diffutils:    @>
@q http://www.gnu.org/software/diffutils/diffutils.html                   @>

@q The author is Laurence D. Finston.  @>

@q The LDF Metadata Exchange Utilities are free software;                  @>
@q you can redistribute them and/or modify                                 @>
@q them under the terms of the GNU General Public License as published by  @>
@q the Free Software Foundation; either version 2 of the License, or       @>
@q (at your option) any later version.                                     @>

@q The LDF Metadata Exchange Utilities are distributed in the hope               @>          
@q that they will be useful, but WITHOUT ANY WARRANTY; without even              @>
@q the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  @>
@q See the GNU General Public License for more details.                          @>

@q You should have received a copy of the GNU General Public License                   @>
@q along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  @>
@q Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          @>

@q The LDF Metadata Exchange Utilities are available for downloading from the @>
@q following FTP server:                                                      @>
@q ftp://ftp.gwdg.de/pub/gnu2/iwfmdh/                                         @>

@q "@@" stands for a single "at"-sign in the following email adresses.  @>

@q Please send bug reports to lfinsto1@@gwdg.de  @>

@q The author can be contacted at: @>

@q Laurence D. Finston @>
@q Kreuzbergring 41    @>
@q D-37075 Goettingen  @>
@q Germany             @>

@q lfinsto1@@gwdg.de               @>
@q s246794@@stud.uni-goettingen.de @>



@q ** (2) Query expressions.@>
@*1 Query expressions (\filename{queryexp.w}).
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this file.
\ENDLOG

@
@<\filename{queryexp.w}@>=
static char queryexp_id_string[] 
   = "$Id: queryexp.w,v 1.5 2007/02/13 20:40:23 lfinsto1 Exp $"; 

@q *** (3) query_primary.@>
@*2 {\bf query primary}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> query_primary@>

@q **** (4) query_primary: query_variable@>
@*3 \query primary> $\longrightarrow$ \query variable>.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=query_primary: query_variable@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `query_primary: query_variable'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    Id_Node curr_id_node = static_cast<Id_Node>(@=$1@>);

    if (curr_id_node && curr_id_node->value) 
    {
       Query_Node curr_query_node = new Query_Type;

       *curr_query_node = *static_cast<Query_Node>(curr_id_node->value);

       @=$$@> = static_cast<void*>(curr_query_node); 
    }
    else 
       @=$$@> = 0;


#ifdef DEBUG_OUTPUT 
    temp_strm << endl 
              << "Exiting rule `query_primary: query_variable'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 



};

@q **** (4) query_primary: OPEN_PARENTHESIS query_expression CLOSE_PARENTHESIS@>
@*3 \query primary> $\longrightarrow$ \.{(} \query expression> \.{)}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=query_primary: OPEN_PARENTHESIS query_expression CLOSE_PARENTHESIS@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `query_primary: OPEN_PARENTHESIS query_expression CLOSE_PARENTHESIS'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    Query_Node q = static_cast<Query_Node>(@=$2@>);

    @=$$@> = @=$2@>;

};

@q **** (4) query_primary: STRING@>
@*3 \query primary> $\longrightarrow$ \.{STRING}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=query_primary: STRING@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `query_primary: STRING'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    Query_Node curr_query_node = new Query_Type;
    curr_query_node->value_type = Query_Type::QUERY_TYPE_STRING_TYPE;
    curr_query_node->value = static_cast<void*>(new string);
    *static_cast<string*>(curr_query_node->value) = @=$1@>;

    @=$$@> = static_cast<void*>(curr_query_node);

};

@q **** (4) query_primary: INTEGER@>
@*3 \query primary> $\longrightarrow$ \.{INTEGER}.
\initials{LDF 2006.12.14.}

\LOG
\initials{LDF 2006.12.14.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=query_primary: INTEGER@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `query_primary: INTEGER'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    Query_Node curr_query_node = new Query_Type;
    curr_query_node->value_type = Query_Type::INT_TYPE;
    curr_query_node->value = static_cast<void*>(new int);
    *static_cast<int*>(curr_query_node->value) = @=$1@>;

    @=$$@> = static_cast<void*>(curr_query_node);

};

@q **** (4) query_primary: FLOAT@>
@*3 \query primary> $\longrightarrow$ \.{FLOAT}.
\initials{LDF 2006.12.14.}

\LOG
\initials{LDF 2006.12.14.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=query_primary: FLOAT@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `query_primary: FLOAT'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    Query_Node curr_query_node = new Query_Type;
    curr_query_node->value_type = Query_Type::FLOAT_TYPE;
    curr_query_node->value = static_cast<void*>(new float);
    *static_cast<float*>(curr_query_node->value) = @=$1@>;

    @=$$@> = static_cast<void*>(curr_query_node);

};



@q *** (3) query_secondary.@>
@*2 {\bf query secondary}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> query_secondary@>

@q **** (4) query_secondary: query_primary@>
@*3 \query secondary> $\longrightarrow$ \query primary>.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=query_secondary: query_primary@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `query_secondary: query_primary'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = @=$1@>;

};

@q **** (4) query_secondary: query_secondary and_or_and_not query_primary@>
@*3 \query secondary> $\longrightarrow$ \query secondary> \and or and not>
\query primary>.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=query_secondary: query_secondary and_or_and_not query_primary@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `query_secondary: query_secondary and_or_and_not query_primary'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    Query_Node secondary = static_cast<Query_Node>(@=$1@>);
    Query_Node primary   = static_cast<Query_Node>(@=$3@>);

    primary->up = secondary;
    primary->query_type = Query_Type::AND_TYPE;
   
    primary->negated = (@=$2@> == AND_NOT) ? true : false;
    
    while (secondary->and_node != 0)
       secondary = secondary->and_node;

    secondary->and_node = primary;
    primary->query_ctr = secondary->query_ctr + 1;

    @=$$@> = @=$1@>;

};

@q *** (3) query_tertiary.@>
@*2 {\bf query tertiary}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> query_tertiary@>

@q **** (4) query_tertiary: query_secondary@>
@*3 \query tertiary> $\longrightarrow$ \query secondary>.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=query_tertiary: query_secondary@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `query_tertiary: query_secondary'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = @=$1@>;

};

@q **** (4) query_tertiary: query_tertiary xor_or_xor_not query_secondary@>
@*3 \query tertiary> $\longrightarrow$ \query tertiary> \xor or xor not> 
\query secondary>.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=query_tertiary: query_tertiary xor_or_xor_not query_secondary@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `query_tertiary: query_tertiary xor_or_xor_not query_secondary'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    Query_Node tertiary  = static_cast<Query_Node>(@=$1@>);
    Query_Node secondary = static_cast<Query_Node>(@=$3@>);


    secondary->up = tertiary;
    secondary->query_type = Query_Type::XOR_TYPE;
 
    secondary->negated = (@=$2@> == XOR_NOT) ? true : false;


    while (tertiary->xor_node != 0)
       tertiary = tertiary->xor_node;

    tertiary->xor_node = secondary;
    secondary->query_ctr = tertiary->query_ctr + 1;


    @=$$@> = @=$1@>;

};


@q *** (3) query_expression.@>
@*2 {\bf query expression}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> query_expression@>

@q **** (4) query_expression: query_tertiary@>
@*3 \query expression> $\longrightarrow$ \query tertiary>.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=query_expression: query_tertiary@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `query_expression: query_tertiary'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = @=$1@>;

};

@q **** (4) query_expression: query_expression or_or_or_not query_tertiary@>
@*3 \query expression> $\longrightarrow$ \query expression> \or or or not> 
\query tertiary>.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=query_expression: query_expression or_or_or_not query_tertiary@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `query_expression: query_expression or_or_or_not query_tertiary'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    Query_Node expression = static_cast<Query_Node>(@=$1@>);
    Query_Node tertiary   = static_cast<Query_Node>(@=$3@>);

    tertiary->up = expression;
    tertiary->query_type = Query_Type::OR_TYPE;
    
    while (expression->or_node != 0)
       expression = expression->or_node;

    tertiary->negated = (@=$2@> == OR_NOT) ? true : false;

    expression->or_node = tertiary;
    tertiary->query_ctr = expression->query_ctr + 1;

    @=$$@> = @=$1@>;

};

@q **** (4) @>

@q *** (3) Boolean operators.@>
@*2 Boolean operators.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this section with the type declarations of 
|and_or_and_not|, |or_or_or_not|, and |xor_or_xor_not|.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <int_value> and_or_and_not@>
@=%type <int_value> or_or_or_not@>
@=%type <int_value> xor_or_xor_not@>


@q **** (4) and_or_and_not: AND@>
@*3 \and or and not> $\longrightarrow$ \.{AND}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=and_or_and_not: AND@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `and_or_and_not: AND'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = AND;

};

@q **** (4) and_or_and_not: AND_NOT@>
@*3 \and or and not> $\longrightarrow$ \.{AND\_NOT}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=and_or_and_not: AND_NOT@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `and_or_and_not: AND_NOT'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = AND_NOT;

};

@q **** (4) or_or_or_not: OR@>
@*3 \or or or not> $\longrightarrow$ \.{OR}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=or_or_or_not: OR@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `or_or_or_not: OR'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = OR;

};

@q **** (4) or_or_or_not: OR_NOT@>
@*3 \or or or not> $\longrightarrow$ \.{OR\_NOT}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=or_or_or_not: OR_NOT@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `or_or_or_not: OR_NOT'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = OR_NOT;

};

@q **** (4) xor_or_xor_not: XOR@>
@*3 \xor or xor not> $\longrightarrow$ \.{XOR}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=xor_or_xor_not: XOR@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `xor_or_xor_not: XOR'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = XOR;

};

@q **** (4) xor_or_xor_not: XOR_NOT@>
@*3 \xor or xor not> $\longrightarrow$ \.{XOR\_NOT}.
\initials{LDF 2006.11.15.}

\LOG
\initials{LDF 2006.11.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=xor_or_xor_not: XOR_NOT@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    temp_strm << endl 
              << "Rule `xor_or_xor_not: XOR_NOT'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");   
#endif 

    @=$$@> = XOR_NOT;

};

@q ** (2) @>


@q * (1) Emacs-Lisp code for use in indirect buffers.  LDF 2006.10.11.@>

@q (progn (outline-mode) (abbrev-mode t) (ignore '(                          @>
@q )) (setq outline-regexp (concat (char-to-string 64) "q [*\f]+")) (ignore'(@>
@q )) (make-variable-buffer-local 'outline-regexp))                          @>

@q * (1) Local Variables for Emacs  @>

@q Local Variables: @>
@q mode:Outline @>
@q abbrev-mode:t @>
@q eval:(setq outline-regexp (concat (char-to-string 64) "q [*\f]+")) @>
@q End: @>
