/* * (1) Copyright and License. */

/* This file is part of the LDF Metadata Exchange Utilities,             */
/* a package for metadata exchange.                                      */

/* Copyright (C) 2007 Laurence D. Finston   */

/* The author is Laurence D. Finston.  */

/* The LDF Metadata Exchange Utilities are free software;                   */
/* you can redistribute them and/or modify                                  */
/* them under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation; either version 2 of the License, or        */
/* (at your option) any later version.                                      */

/* The LDF Metadata Exchange Utilities are distributed in the hope               */
/* that they will be useful, but WITHOUT ANY WARRANTY; without even              */
/* the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  */
/* See the GNU General Public License for more details.                          */

/* You should have received a copy of the GNU General Public License                   */
/* along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  */
/* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          */

/* The LDF Metadata Exchange Utilities are available for downloading from the  */
/* following FTP server:                                                       */
/* ftp:/*ftp.gwdg.de/pub/gnu2/iwfmdh/                                          */

/* Please send bug reports to lfinsto1@gwdg.de  */

/* The author can be contacted at:  */

/* Laurence D. Finston  */
/* Kreuzbergring 41     */
/* D-37075 Goettingen   */
/* Germany              */

/* lfinsto1@gwdg.de                */
/* s246794@stud.uni-goettingen.de  */


/*74:*/
#line 3003 "querytyp.web"

/*2:*/
#line 96 "querytyp.web"


#include "localldf.h"

#ifdef NON_WIN_LDF
#include "nonwin.h"
#else
#include "stdafx.h"
#endif

#include "parser.hxx"
#include "dttmtype.h"
#include "idtype.h"
#include "scnrtype.h"
#include "scanner.h"



/*:2*/
#line 3004 "querytyp.web"

/*1:*/
#line 87 "querytyp.web"


static char id_string[]
= "$Id: querytyp.web,v 1.7 2007/02/13 20:40:50 lfinsto1 Exp $";



/*:1*/
#line 3005 "querytyp.web"

using namespace std;
using namespace Scan_Parse;
/*29:*/
#line 710 "querytyp.web"


#define QUERY_TYPE_BITSET_SIZE 96


/*:29*/
#line 3008 "querytyp.web"

/*4:*/
#line 132 "querytyp.web"


class Scanner_Type;
typedef Scanner_Type*Scanner_Node;

class Query_Type;
typedef Query_Type*Query_Node;

class Id_Type;
typedef Id_Type*Id_Node;


/*:4*/
#line 3009 "querytyp.web"

/*5:*/
#line 184 "querytyp.web"


class
Query_Type;

typedef Query_Type*Query_Node;

class
Query_Type
{

/*7:*/
#line 285 "querytyp.web"


friend
int
yyparse(void*);

friend
void*
Scan_Parse::variable_func(void*v,
char*name);

friend
Id_Node
Scan_Parse::declare_variable_func(void*v,
const unsigned short type,
char*name);

friend
void*
Scan_Parse::query_assignment_func_0(void*v,
void*object,
unsigned int assignment_type,
unsigned int arg_0,
unsigned int arg_1,
void*value,
bool negate);
friend
int
Scan_Parse::query_assignment_func_1(Scanner_Node scanner_node,
Id_Node&curr_id_node,
void*&field_specifier,
int assignment_operator,
int negation_optional,
int match_term_optional,
void*&v,
int type);




friend
int
Scan_Parse::start_local_database_query_func(void*v);

friend
int
Scan_Parse::end_query_func(void*v);

friend
int
Scan_Parse::datetime_assignment_func_0(void*v,
Date_Time_Node&curr_date_time_node,
int specifier,
int op,
void*val,
int type);


friend
int
Scan_Parse::datetime_assignment_func_1(void*v,
Date_Time_Node&d,
int op,
void*&vec);



/*:7*/
#line 195 "querytyp.web"


private:

unsigned short query_type;
unsigned short field_type;
unsigned short value_type;
vector<unsigned short> target_types;

static map<unsigned short,string> query_type_map;
static map<unsigned short,string> field_type_map;
static map<unsigned short,string> value_type_map;
static map<unsigned short,string> target_type_map;
static map<unsigned short,string> match_value_map;

Id_Node id_node;

bool negated;

string name;

void*value;

Query_Node up;
Query_Node and_node;
Query_Node or_node;
Query_Node xor_node;

unsigned short match_value;

/*:5*//*6:*/
#line 226 "querytyp.web"


Scanner_Node scanner_node;

unsigned short query_ctr;

public:

/*9:*/
#line 364 "querytyp.web"


static const unsigned short QUERY_TYPE_NULL_TYPE;

/*:9*//*11:*/
#line 386 "querytyp.web"


static const unsigned short TOP_TYPE;
static const unsigned short AND_TYPE;
static const unsigned short OR_TYPE;
static const unsigned short XOR_TYPE;

/*:11*//*14:*/
#line 448 "querytyp.web"


static const unsigned short ACCESS_NUMBER_FIELD;
static const unsigned short AUTHOR_FIELD;

static const unsigned short BIBLIOGRAPHIC_TYPE_FIELD;

static const unsigned short CALL_NUMBER_FIELD;
static const unsigned short CLASSIFICATION_FIELD;
static const unsigned short COMPANY_FIELD;
static const unsigned short CONTENT_SUMMARY_FIELD;
static const unsigned short CONTRIBUTOR_FIELD;
static const unsigned short CREATOR_FIELD;

static const unsigned short DATABASE_PROVIDER_FIELD;
static const unsigned short DESCRIPTION_FIELD;

static const unsigned short EXEMPLAR_PRODUCTION_NUMBER_FIELD;

static const unsigned short IDENTIFIER_FIELD;
static const unsigned short INSTITUTION_FIELD;

static const unsigned short LANGUAGE_FIELD;

static const unsigned short MAIN_CANONICAL_TITLE_FIELD;

static const unsigned short PERMUTATION_PATTERN_FIELD;
static const unsigned short PHYSICAL_DESCRIPTION_FIELD;
static const unsigned short PERSON_FIELD;
static const unsigned short PUBLISHER_FIELD;

static const unsigned short RECORD_FIELD;
static const unsigned short REMOTE_ACCESS_FIELD;
static const unsigned short RIGHTS_FIELD;

static const unsigned short SOURCE_FIELD;
static const unsigned short SUBJECT_FIELD;
static const unsigned short SUPERORDINATE_ENTITIES_FIELD;

static const unsigned short TITLE_FIELD;
static const unsigned short TYPE_FIELD;


/*:14*//*16:*/
#line 500 "querytyp.web"


static const unsigned short AUTHOR_SURNAME_FIELD;
static const unsigned short AUTHOR_GIVEN_NAME_FIELD;
static const unsigned short AUTHOR_PREFIX_FIELD;



/*:16*//*17:*/
#line 511 "querytyp.web"


static const unsigned short CONTRIBUTOR_SURNAME_FIELD;
static const unsigned short CONTRIBUTOR_GIVEN_NAME_FIELD;
static const unsigned short CONTRIBUTOR_PREFIX_FIELD;


/*:17*//*18:*/
#line 521 "querytyp.web"


static const unsigned short RECORD_ID_FIELD;
static const unsigned short RECORD_ELN_ORIGINAL_ENTRY_FIELD;
static const unsigned short RECORD_ELN_MOST_RECENT_CHANGE_FIELD;
static const unsigned short RECORD_ELN_STATUS_CHANGE_FIELD;
static const unsigned short RECORD_IDENTIFICATION_NUMBER_FIELD;
static const unsigned short RECORD_DATE_ORIGINAL_ENTRY_FIELD;
static const unsigned short RECORD_DATE_MOST_RECENT_CHANGE_FIELD;
static const unsigned short RECORD_DATE_STATUS_CHANGE_FIELD;
static const unsigned short RECORD_SOURCE_ID_FIELD;
static const unsigned short RECORD_YEAR_APPEARANCE_BEGIN_FIELD;
static const unsigned short RECORD_YEAR_APPEARANCE_END_FIELD;
static const unsigned short RECORD_YEAR_APPEARANCE_RAK_WB_FIELD;
static const unsigned short RECORD_YEAR_APPEARANCE_ORIGINAL_FIELD;




/*:18*//*25:*/
#line 654 "querytyp.web"


static const unsigned short INT_TYPE;
static const unsigned short FLOAT_TYPE;
static const unsigned short QUERY_TYPE_STRING_TYPE;
static const unsigned short DATE_TIME_TYPE;

/*:25*//*27:*/
#line 683 "querytyp.web"


static const unsigned short LOCAL_DATABASE_TARGET;
static const unsigned short LOCAL_SERVER_TARGET;
static const unsigned short REMOTE_DATABASE_TARGET;
static const unsigned short REMOTE_SERVER_TARGET;

/*:27*//*34:*/
#line 948 "querytyp.web"


static const unsigned short CONTAINS_VALUE;
static const unsigned short FREETEXT_VALUE;
static const unsigned short LIKE_VALUE;


/*:34*/
#line 234 "querytyp.web"

/*30:*/
#line 716 "querytyp.web"


static bitset<QUERY_TYPE_BITSET_SIZE> NULL_BITSET;




/*:30*//*31:*/
#line 726 "querytyp.web"




static bitset<QUERY_TYPE_BITSET_SIZE> ACCESS_NUMBER_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> AUTHOR_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> AUTHOR_SURNAME_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> AUTHOR_GIVEN_NAME_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> AUTHOR_PREFIX_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> BIBLIOGRAPHIC_TYPE_FLAG;




static bitset<QUERY_TYPE_BITSET_SIZE> CALL_NUMBER_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> CLASSIFICATION_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> COMPANY_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> CONTENT_SUMMARY_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> CONTRIBUTOR_SURNAME_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> CONTRIBUTOR_GIVEN_NAME_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> CONTRIBUTOR_PREFIX_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> CREATOR_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> CONTRIBUTOR_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> DATABASE_PROVIDER_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> DESCRIPTION_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> EXEMPLAR_PRODUCTION_NUMBER_FLAG;




static bitset<QUERY_TYPE_BITSET_SIZE> IDENTIFIER_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> INSTITUTION_FLAG;




static bitset<QUERY_TYPE_BITSET_SIZE> LANGUAGE_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> MAIN_CANONICAL_TITLE_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> PERMUTATION_PATTERN_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> PERSON_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> PHYSICAL_DESCRIPTION_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> PUBLISHER_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_ID_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_ELN_ORIGINAL_ENTRY_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_ELN_MOST_RECENT_CHANGE_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_ELN_STATUS_CHANGE_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_IDENTIFICATION_NUMBER_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_DATE_ORIGINAL_ENTRY_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_DATE_MOST_RECENT_CHANGE_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_DATE_STATUS_CHANGE_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_SOURCE_ID_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_YEAR_APPEARANCE_BEGIN_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_YEAR_APPEARANCE_END_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_YEAR_APPEARANCE_RAK_WB_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_YEAR_APPEARANCE_ORIGINAL_FLAG;


static bitset<QUERY_TYPE_BITSET_SIZE> REMOTE_ACCESS_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RIGHTS_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> SOURCE_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> SUBJECT_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> SUPERORDINATE_ENTITIES_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> TITLE_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> TYPE_FLAG;







/*:31*/
#line 235 "querytyp.web"


/*38:*/
#line 984 "querytyp.web"


Query_Type(void);

/*:38*//*40:*/
#line 1030 "querytyp.web"

int
set(unsigned short qquery_type,
unsigned short ffield_type= 0,
unsigned short vvalue_type= 0,
unsigned short ttarget_type= 0,
bool nnegated= false,
void*vvalue= 0,
Query_Node uup= 0,
Query_Node aand_node= 0,
Query_Node oor_node= 0,
Query_Node xxor_node= 0,
Scanner_Node sscanner_node= 0);

/*:40*//*42:*/
#line 1107 "querytyp.web"

~Query_Type(void);


/*:42*//*47:*/
#line 1289 "querytyp.web"

Query_Node
operator= (const Query_Type&q);


/*:47*//*51:*/
#line 1556 "querytyp.web"

static
int
initialize_type_maps(void);


/*:51*//*53:*/
#line 1735 "querytyp.web"


static
int
initialize_flags(void);


/*:53*//*57:*/
#line 1999 "querytyp.web"

int
set_field_specifier(void*v,
bool traverse= false,
Scanner_Node sscanner_node= 0);


/*:57*//*62:*/
#line 2300 "querytyp.web"


string
generate_tex_string(Scanner_Node scanner_node,
stringstream*tex_strm);



/*:62*//*66:*/
#line 2597 "querytyp.web"

int
generate_sql_string(Scanner_Node scanner_node,
int database_type,
stringstream*sql_strm,
stringstream*select_strm,
stringstream*from_strm,
stringstream*where_strm_0,
stringstream*where_strm_1,
bool*first_select,
bool*first_from,
bool*first_where,
bitset<QUERY_TYPE_BITSET_SIZE> *field_flags,
string*return_str);


/*:66*//*67:*/
#line 2641 "querytyp.web"

int
show(string s= "`Query_Type':\n",
Scanner_Node sscanner_node= 0);


/*:67*/
#line 237 "querytyp.web"


};


/*:6*/
#line 3010 "querytyp.web"

/*10:*/
#line 369 "querytyp.web"


const unsigned short Query_Type::QUERY_TYPE_NULL_TYPE= 0;



/*:10*//*12:*/
#line 394 "querytyp.web"


const unsigned short Query_Type::TOP_TYPE= 1;
const unsigned short Query_Type::AND_TYPE= 2;
const unsigned short Query_Type::OR_TYPE= 3;
const unsigned short Query_Type::XOR_TYPE= 4;


/*:12*//*19:*/
#line 543 "querytyp.web"




/*:19*//*20:*/
#line 550 "querytyp.web"


const unsigned short Query_Type::ACCESS_NUMBER_FIELD= 1;
const unsigned short Query_Type::AUTHOR_FIELD= 2;

const unsigned short Query_Type::BIBLIOGRAPHIC_TYPE_FIELD= 3;

const unsigned short Query_Type::CALL_NUMBER_FIELD= 4;

const unsigned short Query_Type::CLASSIFICATION_FIELD= 5;
const unsigned short Query_Type::COMPANY_FIELD= 6;
const unsigned short Query_Type::CONTENT_SUMMARY_FIELD= 7;
const unsigned short Query_Type::CONTRIBUTOR_FIELD= 8;
const unsigned short Query_Type::CREATOR_FIELD= 9;

const unsigned short Query_Type::DATABASE_PROVIDER_FIELD= 10;
const unsigned short Query_Type::DESCRIPTION_FIELD= 11;

const unsigned short Query_Type::EXEMPLAR_PRODUCTION_NUMBER_FIELD= 12;

const unsigned short Query_Type::IDENTIFIER_FIELD= 13;

const unsigned short Query_Type::INSTITUTION_FIELD= 14;

const unsigned short Query_Type::LANGUAGE_FIELD= 15;

const unsigned short Query_Type::MAIN_CANONICAL_TITLE_FIELD= 16;

const unsigned short Query_Type::PERMUTATION_PATTERN_FIELD= 17;
const unsigned short Query_Type::PERSON_FIELD= 18;
const unsigned short Query_Type::PHYSICAL_DESCRIPTION_FIELD= 19;
const unsigned short Query_Type::PUBLISHER_FIELD= 20;

const unsigned short Query_Type::RECORD_FIELD= 21;
const unsigned short Query_Type::REMOTE_ACCESS_FIELD= 22;
const unsigned short Query_Type::RIGHTS_FIELD= 23;

const unsigned short Query_Type::SOURCE_FIELD= 24;
const unsigned short Query_Type::SUPERORDINATE_ENTITIES_FIELD= 25;

const unsigned short Query_Type::TITLE_FIELD= 26;

const unsigned short Query_Type::SUBJECT_FIELD= 27;

const unsigned short Query_Type::TYPE_FIELD= 28;



/*:20*//*22:*/
#line 606 "querytyp.web"


const unsigned short Query_Type::AUTHOR_SURNAME_FIELD= 200;
const unsigned short Query_Type::AUTHOR_GIVEN_NAME_FIELD= 201;
const unsigned short Query_Type::AUTHOR_PREFIX_FIELD= 202;




/*:22*//*23:*/
#line 618 "querytyp.web"


const unsigned short Query_Type::CONTRIBUTOR_SURNAME_FIELD= 203;
const unsigned short Query_Type::CONTRIBUTOR_GIVEN_NAME_FIELD= 204;
const unsigned short Query_Type::CONTRIBUTOR_PREFIX_FIELD= 205;



/*:23*//*24:*/
#line 629 "querytyp.web"


const unsigned short Query_Type::RECORD_ID_FIELD= 500;
const unsigned short Query_Type::RECORD_ELN_ORIGINAL_ENTRY_FIELD= 501;
const unsigned short Query_Type::RECORD_ELN_MOST_RECENT_CHANGE_FIELD= 502;
const unsigned short Query_Type::RECORD_ELN_STATUS_CHANGE_FIELD= 503;
const unsigned short Query_Type::RECORD_IDENTIFICATION_NUMBER_FIELD= 504;
const unsigned short Query_Type::RECORD_DATE_ORIGINAL_ENTRY_FIELD= 505;
const unsigned short Query_Type::RECORD_DATE_MOST_RECENT_CHANGE_FIELD= 506;
const unsigned short Query_Type::RECORD_DATE_STATUS_CHANGE_FIELD= 507;
const unsigned short Query_Type::RECORD_SOURCE_ID_FIELD= 508;
const unsigned short Query_Type::RECORD_YEAR_APPEARANCE_BEGIN_FIELD= 509;
const unsigned short Query_Type::RECORD_YEAR_APPEARANCE_END_FIELD= 510;
const unsigned short Query_Type::RECORD_YEAR_APPEARANCE_RAK_WB_FIELD= 501;
const unsigned short Query_Type::RECORD_YEAR_APPEARANCE_ORIGINAL_FIELD= 512;


/*:24*//*26:*/
#line 662 "querytyp.web"


const unsigned short Query_Type::INT_TYPE= 1;
const unsigned short Query_Type::FLOAT_TYPE= 2;
const unsigned short Query_Type::QUERY_TYPE_STRING_TYPE= 3;
const unsigned short Query_Type::DATE_TIME_TYPE= 4;



/*:26*//*28:*/
#line 691 "querytyp.web"


const unsigned short Query_Type::LOCAL_DATABASE_TARGET= 1;
const unsigned short Query_Type::LOCAL_SERVER_TARGET= 2;
const unsigned short Query_Type::REMOTE_DATABASE_TARGET= 3;
const unsigned short Query_Type::REMOTE_SERVER_TARGET= 4;



/*:28*//*35:*/
#line 956 "querytyp.web"


const unsigned short Query_Type::CONTAINS_VALUE= 1;
const unsigned short Query_Type::FREETEXT_VALUE= 2;
const unsigned short Query_Type::LIKE_VALUE= 3;


/*:35*/
#line 3011 "querytyp.web"

/*32:*/
#line 834 "querytyp.web"


bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::NULL_BITSET;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::ACCESS_NUMBER_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::AUTHOR_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::BIBLIOGRAPHIC_TYPE_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::CALL_NUMBER_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::CLASSIFICATION_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::COMPANY_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::CONTENT_SUMMARY_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::CREATOR_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::CONTRIBUTOR_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::DATABASE_PROVIDER_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::DESCRIPTION_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::EXEMPLAR_PRODUCTION_NUMBER_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::IDENTIFIER_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::INSTITUTION_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::LANGUAGE_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::MAIN_CANONICAL_TITLE_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::PERMUTATION_PATTERN_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::PERSON_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::PHYSICAL_DESCRIPTION_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::PUBLISHER_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_ID_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_ELN_ORIGINAL_ENTRY_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_ELN_MOST_RECENT_CHANGE_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_ELN_STATUS_CHANGE_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_IDENTIFICATION_NUMBER_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_DATE_ORIGINAL_ENTRY_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_DATE_MOST_RECENT_CHANGE_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_DATE_STATUS_CHANGE_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_SOURCE_ID_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_YEAR_APPEARANCE_BEGIN_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_YEAR_APPEARANCE_END_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_YEAR_APPEARANCE_RAK_WB_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RECORD_YEAR_APPEARANCE_ORIGINAL_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::REMOTE_ACCESS_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::RIGHTS_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::SOURCE_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::SUBJECT_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::SUPERORDINATE_ENTITIES_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::TITLE_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::TYPE_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::AUTHOR_SURNAME_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::AUTHOR_GIVEN_NAME_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::AUTHOR_PREFIX_FLAG;

bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::CONTRIBUTOR_SURNAME_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::CONTRIBUTOR_GIVEN_NAME_FLAG;
bitset<QUERY_TYPE_BITSET_SIZE> Query_Type::CONTRIBUTOR_PREFIX_FLAG;


/*:32*//*33:*/
#line 925 "querytyp.web"


map<unsigned short,string> Query_Type::query_type_map;
map<unsigned short,string> Query_Type::field_type_map;
map<unsigned short,string> Query_Type::value_type_map;
map<unsigned short,string> Query_Type::target_type_map;
map<unsigned short,string> Query_Type::match_value_map;



/*:33*/
#line 3012 "querytyp.web"

/*39:*/
#line 989 "querytyp.web"


Query_Type::Query_Type(void)
{

query_type= QUERY_TYPE_NULL_TYPE;
field_type= QUERY_TYPE_NULL_TYPE;
value_type= QUERY_TYPE_NULL_TYPE;

negated= false;

id_node= 0;

value= 0;
up= 0;
and_node= 0;
or_node= 0;
xor_node= 0;
query_ctr= 0;

match_value= QUERY_TYPE_NULL_TYPE;

scanner_node= 0;

return;

}


/*:39*//*41:*/
#line 1045 "querytyp.web"

int
Query_Type::set(unsigned short qquery_type,
unsigned short ffield_type,
unsigned short vvalue_type,
unsigned short target_type,
bool nnegated,
void*vvalue,
Query_Node uup,
Query_Node aand_node,
Query_Node oor_node,
Query_Node xxor_node,
Scanner_Node sscanner_node)
{


match_value= QUERY_TYPE_NULL_TYPE;

return 0;

}


/*:41*//*43:*/
#line 1112 "querytyp.web"

Query_Type::~Query_Type(void)
{



#if 0 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif

stringstream temp_strm;

#ifdef DEBUG_OUTPUT
temp_strm<<"Entering `Query_Type' destructor."<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");
#endif


/*:43*//*44:*/
#line 1148 "querytyp.web"


up= 0;

if(value!=0)
{



if(field_type==ACCESS_NUMBER_FIELD
||field_type==AUTHOR_FIELD

||field_type==BIBLIOGRAPHIC_TYPE_FIELD

||field_type==CALL_NUMBER_FIELD
||field_type==CLASSIFICATION_FIELD
||field_type==COMPANY_FIELD
||field_type==CONTENT_SUMMARY_FIELD
||field_type==CONTRIBUTOR_FIELD
||field_type==CREATOR_FIELD

||field_type==DATABASE_PROVIDER_FIELD
||field_type==DESCRIPTION_FIELD

||field_type==EXEMPLAR_PRODUCTION_NUMBER_FIELD

||field_type==IDENTIFIER_FIELD
||field_type==INSTITUTION_FIELD

||field_type==LANGUAGE_FIELD

||field_type==MAIN_CANONICAL_TITLE_FIELD

||field_type==PERMUTATION_PATTERN_FIELD
||field_type==PERSON_FIELD
||field_type==PHYSICAL_DESCRIPTION_FIELD
||field_type==PUBLISHER_FIELD

||field_type==RECORD_FIELD
||field_type==REMOTE_ACCESS_FIELD
||field_type==RIGHTS_FIELD

||field_type==SOURCE_FIELD
||field_type==SUBJECT_FIELD
||field_type==SUPERORDINATE_ENTITIES_FIELD

||field_type==TITLE_FIELD
||field_type==TYPE_FIELD

||field_type==AUTHOR_SURNAME_FIELD
||field_type==AUTHOR_GIVEN_NAME_FIELD
||field_type==AUTHOR_PREFIX_FIELD

||field_type==CONTRIBUTOR_SURNAME_FIELD
||field_type==CONTRIBUTOR_GIVEN_NAME_FIELD
||field_type==CONTRIBUTOR_PREFIX_FIELD

||field_type==RECORD_IDENTIFICATION_NUMBER_FIELD)

{

delete static_cast<string*> (value);
}



else if(field_type==RECORD_ID_FIELD
||field_type==RECORD_ELN_ORIGINAL_ENTRY_FIELD
||field_type==RECORD_ELN_MOST_RECENT_CHANGE_FIELD
||field_type==RECORD_ELN_STATUS_CHANGE_FIELD
||field_type==RECORD_SOURCE_ID_FIELD
||field_type==RECORD_YEAR_APPEARANCE_BEGIN_FIELD
||field_type==RECORD_YEAR_APPEARANCE_END_FIELD
||field_type==RECORD_YEAR_APPEARANCE_RAK_WB_FIELD
||field_type==RECORD_YEAR_APPEARANCE_ORIGINAL_FIELD)
{
delete static_cast<int*> (value);
}




else if(field_type==RECORD_DATE_ORIGINAL_ENTRY_FIELD
||field_type==RECORD_DATE_MOST_RECENT_CHANGE_FIELD
||field_type==RECORD_DATE_STATUS_CHANGE_FIELD)
{
delete static_cast<Date_Time_Node> (value);
}



}

value= 0;


delete and_node;
and_node= 0;

delete or_node;
or_node= 0;

delete xor_node;
xor_node= 0;



/*:44*//*45:*/
#line 1256 "querytyp.web"


#ifdef DEBUG_OUTPUT
temp_strm<<"Exiting `Query_Type' destructor."<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");
#endif


/*:45*//*46:*/
#line 1270 "querytyp.web"


scanner_node= 0;

return;

}




/*:46*//*48:*/
#line 1295 "querytyp.web"

Query_Node
Query_Type::operator= (const Query_Type&q)
{


#if 0 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif


stringstream temp_strm;

scanner_node= q.scanner_node;

query_ctr= q.query_ctr;

#ifdef DEBUG_OUTPUT
temp_strm<<"Entering `Query_Type::operator=(const Query_Type)'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

#endif

if(this==&q)
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `Query_Type::operator=(const Query_Type)':"
<<endl
<<"Self-assignment.  Returning `this'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

#endif
return this;

}


/*:48*//*49:*/
#line 1352 "querytyp.web"


name= q.name;



if(value!=0&&value_type!=q.value_type)
{



if(value_type==Query_Type::QUERY_TYPE_STRING_TYPE)
{
delete static_cast<string*> (value);
}

else if(value_type==Query_Type::INT_TYPE)
{
delete static_cast<int*> (value);
}

else if(value_type==Query_Type::FLOAT_TYPE)
{
delete static_cast<float*> (value);
}

else if(value_type==Query_Type::DATE_TIME_TYPE)
{
delete static_cast<Date_Time_Node> (value);
}

value= 0;

}




query_type= q.query_type;
field_type= q.field_type;
value_type= q.value_type;
negated= q.negated;

target_types.clear();

for(vector<unsigned short> ::const_iterator iter= q.target_types.begin();
iter!=q.target_types.end();
++iter)
target_types.push_back(*iter);





if(q.value!=0
&&
value_type==QUERY_TYPE_STRING_TYPE)

{
if(value==0)
value= static_cast<void*> (new string);
*static_cast<string*> (value)= *static_cast<string*> (q.value);

}



else if(q.value!=0
&&
value_type==INT_TYPE)
{
if(value==0)
value= static_cast<void*> (new int);
*static_cast<int*> (value)= *static_cast<int*> (q.value);

}



else if(q.value!=0
&&
value_type==FLOAT_TYPE)
{
if(value==0)
value= static_cast<void*> (new float);
*static_cast<float*> (value)= *static_cast<float*> (q.value);

}



else if(q.value!=0
&&
value_type==DATE_TIME_TYPE)
{
if(value==0)
value= static_cast<void*> (new Date_Time_Type);
*static_cast<Date_Time_Node> (value)
= *static_cast<Date_Time_Node> (q.value);

}



else
{
value_type= QUERY_TYPE_NULL_TYPE;
value= 0;
}





scanner_node= q.scanner_node;



delete and_node;
and_node= 0;

delete or_node;
or_node= 0;

delete xor_node;
xor_node= 0;

if(q.and_node)
{
and_node= new Query_Type;
*and_node= *q.and_node;
and_node->up= this;
}

if(q.or_node)
{
or_node= new Query_Type;
*or_node= *q.or_node;
or_node->up= this;
}

if(q.xor_node)
{
xor_node= new Query_Type;
*xor_node= *q.xor_node;
xor_node->up= this;
}




#ifdef DEBUG_OUTPUT
temp_strm<<"Exiting `Query_Type::operator=(const Query_Type)'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

#endif


/*:49*//*50:*/
#line 1517 "querytyp.web"


match_value= q.match_value;

return this;

}


/*:50*//*52:*/
#line 1563 "querytyp.web"

int
Query_Type::initialize_type_maps(void)
{



query_type_map[QUERY_TYPE_NULL_TYPE]= "QUERY_TYPE_NULL_TYPE";
query_type_map[TOP_TYPE]= "TOP_TYPE";
query_type_map[AND_TYPE]= "AND_TYPE";
query_type_map[OR_TYPE]= "OR_TYPE";
query_type_map[XOR_TYPE]= "XOR_TYPE";





field_type_map[QUERY_TYPE_NULL_TYPE]= "QUERY_TYPE_NULL_TYPE";



field_type_map[ACCESS_NUMBER_FIELD]= "ACCESS_NUMBER_FIELD";




field_type_map[AUTHOR_FIELD]= "AUTHOR_FIELD";

field_type_map[AUTHOR_SURNAME_FIELD]= "AUTHOR_SURNAME_FIELD";
field_type_map[AUTHOR_GIVEN_NAME_FIELD]= "AUTHOR_GIVEN_NAME_FIELD";
field_type_map[AUTHOR_PREFIX_FIELD]= "AUTHOR_PREFIX_FIELD";




field_type_map[BIBLIOGRAPHIC_TYPE_FIELD]= "BIBLIOGRAPHIC_TYPE_FIELD";



field_type_map[CALL_NUMBER_FIELD]= "CALL_NUMBER_FIELD";
field_type_map[CLASSIFICATION_FIELD]= "CLASSIFICATION_FIELD";
field_type_map[COMPANY_FIELD]= "COMPANY_FIELD";
field_type_map[CONTENT_SUMMARY_FIELD]= "CONTENT_SUMMARY_FIELD";



field_type_map[CONTRIBUTOR_FIELD]= "CONTRIBUTOR_FIELD";

field_type_map[CONTRIBUTOR_SURNAME_FIELD]= "CONTRIBUTOR_SURNAME_FIELD";
field_type_map[CONTRIBUTOR_GIVEN_NAME_FIELD]= "CONTRIBUTOR_GIVEN_NAME_FIELD";
field_type_map[CONTRIBUTOR_PREFIX_FIELD]= "CONTRIBUTOR_PREFIX_FIELD";




field_type_map[CREATOR_FIELD]= "CREATOR_FIELD";



field_type_map[DATABASE_PROVIDER_FIELD]= "DATABASE_PROVIDER_FIELD";
field_type_map[DESCRIPTION_FIELD]= "DESCRIPTION_FIELD";



field_type_map[EXEMPLAR_PRODUCTION_NUMBER_FIELD]= "EXEMPLAR_PRODUCTION_NUMBER_FIELD";



field_type_map[IDENTIFIER_FIELD]= "IDENTIFIER_FIELD";

field_type_map[INSTITUTION_FIELD]= "INSTITUTION_FIELD";



field_type_map[LANGUAGE_FIELD]= "LANGUAGE_FIELD";



field_type_map[MAIN_CANONICAL_TITLE_FIELD]= "MAIN_CANONICAL_TITLE_FIELD";



field_type_map[PERMUTATION_PATTERN_FIELD]= "PERMUTATION_PATTERN_FIELD";
field_type_map[PERSON_FIELD]= "PERSON_FIELD";
field_type_map[PHYSICAL_DESCRIPTION_FIELD]= "PHYSICAL_DESCRIPTION_FIELD";
field_type_map[PUBLISHER_FIELD]= "PUBLISHER_FIELD";





field_type_map[RECORD_FIELD]= "RECORD_FIELD";

field_type_map[RECORD_IDENTIFICATION_NUMBER_FIELD]
= "RECORD_IDENTIFICATION_NUMBER_FIELD";

field_type_map[RECORD_DATE_MOST_RECENT_CHANGE_FIELD]
= "RECORD_DATE_MOST_RECENT_CHANGE_FIELD";

field_type_map[RECORD_DATE_ORIGINAL_ENTRY_FIELD]
= "RECORD_DATE_ORIGINAL_ENTRY_FIELD";

field_type_map[RECORD_DATE_STATUS_CHANGE_FIELD]
= "RECORD_DATE_STATUS_CHANGE_FIELD";

field_type_map[RECORD_ELN_STATUS_CHANGE_FIELD]
= "RECORD_ELN_STATUS_CHANGE_FIELD";



field_type_map[REMOTE_ACCESS_FIELD]= "REMOTE_ACCESS_FIELD";



field_type_map[RIGHTS_FIELD]= "RIGHTS_FIELD";





field_type_map[SOURCE_FIELD]= "SOURCE_FIELD";
field_type_map[SUBJECT_FIELD]= "SUBJECT_FIELD";
field_type_map[SUPERORDINATE_ENTITIES_FIELD]= "SUPERORDINATE_ENTITIES_FIELD";



field_type_map[TITLE_FIELD]= "TITLE_FIELD";

field_type_map[TYPE_FIELD]= "TYPE_FIELD";





value_type_map[QUERY_TYPE_NULL_TYPE]= "QUERY_TYPE_NULL_TYPE";
value_type_map[INT_TYPE]= "INT_TYPE";
value_type_map[FLOAT_TYPE]= "FLOAT_TYPE";
value_type_map[QUERY_TYPE_STRING_TYPE]= "QUERY_TYPE_STRING_TYPE";
value_type_map[DATE_TIME_TYPE]= "DATE_TIME_TYPE";



target_type_map[LOCAL_DATABASE_TARGET]= "LOCAL_DATABASE_TARGET";
target_type_map[LOCAL_SERVER_TARGET]= "LOCAL_SERVER_TARGET";
target_type_map[REMOTE_DATABASE_TARGET]= "REMOTE_DATABASE_TARGET";
target_type_map[REMOTE_SERVER_TARGET]= "REMOTE_SERVER_TARGET";



match_value_map[QUERY_TYPE_NULL_TYPE]= "QUERY_TYPE_NULL_TYPE";
match_value_map[CONTAINS_VALUE]= "CONTAINS_VALUE";
match_value_map[FREETEXT_VALUE]= "FREETEXT_VALUE";
match_value_map[LIKE_VALUE]= "LIKE_VALUE";



return 0;

}



/*:52*//*54:*/
#line 1743 "querytyp.web"


int
Query_Type::initialize_flags(void)
{


int shift_value= 0;


/*:54*//*55:*/
#line 1754 "querytyp.web"





ACCESS_NUMBER_FLAG= 1;
ACCESS_NUMBER_FLAG<<= shift_value++;




AUTHOR_FLAG= 1;
AUTHOR_FLAG<<= shift_value++;

AUTHOR_SURNAME_FLAG= 1;
AUTHOR_SURNAME_FLAG<<= shift_value++;

AUTHOR_GIVEN_NAME_FLAG= 1;
AUTHOR_GIVEN_NAME_FLAG<<= shift_value++;

AUTHOR_PREFIX_FLAG= 1;
AUTHOR_PREFIX_FLAG<<= shift_value++;





BIBLIOGRAPHIC_TYPE_FLAG= 1;
BIBLIOGRAPHIC_TYPE_FLAG<<= shift_value++;



CALL_NUMBER_FLAG= 1;
CALL_NUMBER_FLAG<<= shift_value++;

CLASSIFICATION_FLAG= 1;
CLASSIFICATION_FLAG<<= shift_value++;

COMPANY_FLAG= 1;
COMPANY_FLAG<<= shift_value++;

CONTENT_SUMMARY_FLAG= 1;
CONTENT_SUMMARY_FLAG<<= shift_value++;



CONTRIBUTOR_FLAG= 1;
CONTRIBUTOR_FLAG<<= shift_value++;

CONTRIBUTOR_SURNAME_FLAG= 1;
CONTRIBUTOR_SURNAME_FLAG<<= shift_value++;

CONTRIBUTOR_GIVEN_NAME_FLAG= 1;
CONTRIBUTOR_GIVEN_NAME_FLAG<<= shift_value++;


CONTRIBUTOR_PREFIX_FLAG= 1;
CONTRIBUTOR_PREFIX_FLAG<<= shift_value++;




CREATOR_FLAG= 1;
CREATOR_FLAG<<= shift_value++;




DATABASE_PROVIDER_FLAG= 1;
DATABASE_PROVIDER_FLAG<<= shift_value++;

DESCRIPTION_FLAG= 1;
DESCRIPTION_FLAG<<= shift_value++;



EXEMPLAR_PRODUCTION_NUMBER_FLAG= 1;
EXEMPLAR_PRODUCTION_NUMBER_FLAG<<= shift_value++;



IDENTIFIER_FLAG= 1;
IDENTIFIER_FLAG<<= shift_value++;

INSTITUTION_FLAG= 1;
INSTITUTION_FLAG<<= shift_value++;



LANGUAGE_FLAG= 1;
LANGUAGE_FLAG<<= shift_value++;



MAIN_CANONICAL_TITLE_FLAG= 1;
MAIN_CANONICAL_TITLE_FLAG<<= shift_value++;



PERMUTATION_PATTERN_FLAG= 1;
PERMUTATION_PATTERN_FLAG<<= shift_value++;

PERSON_FLAG= 1;
PERSON_FLAG<<= shift_value++;

PHYSICAL_DESCRIPTION_FLAG= 1;
PHYSICAL_DESCRIPTION_FLAG<<= shift_value++;

PUBLISHER_FLAG= 1;
PUBLISHER_FLAG<<= shift_value++;





RECORD_FLAG= 1;
RECORD_FLAG<<= shift_value++;

RECORD_ID_FLAG= 1;
RECORD_ID_FLAG<<= shift_value++;

RECORD_ELN_ORIGINAL_ENTRY_FLAG= 1;
RECORD_ELN_ORIGINAL_ENTRY_FLAG<<= shift_value++;

RECORD_ELN_MOST_RECENT_CHANGE_FLAG= 1;
RECORD_ELN_MOST_RECENT_CHANGE_FLAG<<= shift_value++;

RECORD_ELN_STATUS_CHANGE_FLAG= 1;
RECORD_ELN_STATUS_CHANGE_FLAG<<= shift_value++;

RECORD_IDENTIFICATION_NUMBER_FLAG= 1;
RECORD_IDENTIFICATION_NUMBER_FLAG<<= shift_value++;

RECORD_DATE_ORIGINAL_ENTRY_FLAG= 1;
RECORD_DATE_ORIGINAL_ENTRY_FLAG<<= shift_value++;

RECORD_DATE_MOST_RECENT_CHANGE_FLAG= 1;
RECORD_DATE_MOST_RECENT_CHANGE_FLAG<<= shift_value++;

RECORD_DATE_STATUS_CHANGE_FLAG= 1;
RECORD_DATE_STATUS_CHANGE_FLAG<<= shift_value++;

RECORD_SOURCE_ID_FLAG= 1;
RECORD_SOURCE_ID_FLAG<<= shift_value++;

RECORD_YEAR_APPEARANCE_BEGIN_FLAG= 1;
RECORD_YEAR_APPEARANCE_BEGIN_FLAG<<= shift_value++;

RECORD_YEAR_APPEARANCE_END_FLAG= 1;
RECORD_YEAR_APPEARANCE_END_FLAG<<= shift_value++;

RECORD_YEAR_APPEARANCE_RAK_WB_FLAG= 1;
RECORD_YEAR_APPEARANCE_RAK_WB_FLAG<<= shift_value++;

RECORD_YEAR_APPEARANCE_ORIGINAL_FLAG= 1;
RECORD_YEAR_APPEARANCE_ORIGINAL_FLAG<<= shift_value++;



REMOTE_ACCESS_FLAG= 1;
REMOTE_ACCESS_FLAG<<= shift_value++;



RIGHTS_FLAG= 1;
RIGHTS_FLAG<<= shift_value++;



SOURCE_FLAG= 1;
SOURCE_FLAG<<= shift_value++;

SUBJECT_FLAG= 1;
SUBJECT_FLAG<<= shift_value++;

SUPERORDINATE_ENTITIES_FLAG= 1;
SUPERORDINATE_ENTITIES_FLAG<<= shift_value++;



TITLE_FLAG= 1;
TITLE_FLAG<<= shift_value++;

TYPE_FLAG= 1;
TYPE_FLAG<<= shift_value++;


/*:55*//*56:*/
#line 1944 "querytyp.web"


if(shift_value> QUERY_TYPE_BITSET_SIZE)
{
cerr<<"ERROR!  In `Query_Type::initialize_flags':"
<<endl
<<"`shift_value' > `QUERY_TYPE_BITSET_SIZE'."
<<endl
<<"Increase the size of `QUERY_TYPE_BITSET_SIZE'."
<<endl
<<"Exiting function with return value 1."
<<endl
<<"Type <RETURN> to continue: ";

getchar();

return 1;

}



return 0;



}




/*:56*//*58:*/
#line 2007 "querytyp.web"

int
Query_Type::set_field_specifier(void*v,
bool traverse,
Scanner_Node sscanner_node)


{



#if 0 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif

stringstream temp_strm;

deque<int> *field_specifier= static_cast<deque<int> *> (v);

unsigned int table= (*field_specifier)[0];
unsigned int column;





if(table==ACCESS_NUMBER)
field_type= ACCESS_NUMBER_FIELD;



else if(table==AUTHOR)
{


if(field_specifier->size()==1)
field_type= AUTHOR_FIELD;



else
{
column= (*field_specifier)[1];

if(column==SURNAME)
field_type= AUTHOR_SURNAME_FIELD;

else if(column==GIVEN_NAME)
field_type= AUTHOR_GIVEN_NAME_FIELD;

else if(column==PREFIX)
field_type= AUTHOR_PREFIX_FIELD;

}



}



else if(table==BIBLIOGRAPHIC_TYPE)
field_type= BIBLIOGRAPHIC_TYPE_FIELD;

else if(table==CALL_NUMBER)
field_type= CALL_NUMBER_FIELD;

else if(table==CLASSIFICATION)
field_type= CLASSIFICATION_FIELD;

else if(table==COMPANY)
field_type= COMPANY_FIELD;

else if(table==CONTENT_SUMMARY)
field_type= CONTENT_SUMMARY_FIELD;

else if(table==CONTRIBUTOR)
{


if(field_specifier->size()==1)
field_type= CONTRIBUTOR_FIELD;



else
{
column= (*field_specifier)[1];

if(column==SURNAME)
field_type= CONTRIBUTOR_SURNAME_FIELD;

else if(column==GIVEN_NAME)
field_type= CONTRIBUTOR_GIVEN_NAME_FIELD;

else if(column==PREFIX)
field_type= CONTRIBUTOR_PREFIX_FIELD;

}



}

else if(table==CREATOR)
field_type= CREATOR_FIELD;

else if(table==DATABASE_PROVIDER)
field_type= DATABASE_PROVIDER_FIELD;

else if(table==DESCRIPTION)
field_type= DESCRIPTION_FIELD;

else if(table==EXEMPLAR_PRODUCTION_NUMBER)
field_type= EXEMPLAR_PRODUCTION_NUMBER_FIELD;

else if(table==IDENTIFIER)
field_type= IDENTIFIER_FIELD;

else if(table==INSTITUTION)
field_type= INSTITUTION_FIELD;

else if(table==LANGUAGE)
field_type= LANGUAGE_FIELD;

else if(table==MAIN_CANONICAL_TITLE)
field_type= MAIN_CANONICAL_TITLE_FIELD;

else if(table==PERMUTATION_PATTERN)
field_type= PERMUTATION_PATTERN_FIELD;

else if(table==PERSON)
field_type= PERSON_FIELD;

else if(table==PHYSICAL_DESCRIPTION)
field_type= PHYSICAL_DESCRIPTION_FIELD;

else if(table==PUBLISHER)
field_type= PUBLISHER_FIELD;


/*:58*//*59:*/
#line 2157 "querytyp.web"


else if(table==RECORD)
{


if(field_specifier->size()==1)
field_type= RECORD_FIELD;



else
{
column= (*field_specifier)[1];

if(column==ID)
field_type= RECORD_ID_FIELD;

else if(column==ELN_ORIGINAL_ENTRY)
field_type= RECORD_ELN_ORIGINAL_ENTRY_FIELD;

else if(column==ELN_MOST_RECENT_CHANGE)
field_type= RECORD_ELN_MOST_RECENT_CHANGE_FIELD;

else if(column==ELN_STATUS_CHANGE)
field_type= RECORD_ELN_STATUS_CHANGE_FIELD;

else if(column==IDENTIFICATION_NUMBER)
field_type= RECORD_IDENTIFICATION_NUMBER_FIELD;

else if(column==DATE_ORIGINAL_ENTRY)
field_type= RECORD_DATE_ORIGINAL_ENTRY_FIELD;

else if(column==DATE_MOST_RECENT_CHANGE)
field_type= RECORD_DATE_MOST_RECENT_CHANGE_FIELD;

else if(column==DATE_STATUS_CHANGE)
field_type= RECORD_DATE_STATUS_CHANGE_FIELD;

else if(column==SOURCE_ID)
field_type= RECORD_SOURCE_ID_FIELD;

else if(column==YEAR_APPEARANCE_BEGIN)
field_type= RECORD_YEAR_APPEARANCE_BEGIN_FIELD;

else if(column==YEAR_APPEARANCE_END)
field_type= RECORD_YEAR_APPEARANCE_END_FIELD;

else if(column==YEAR_APPEARANCE_RAK_WB)
field_type= RECORD_YEAR_APPEARANCE_RAK_WB_FIELD;

else if(column==YEAR_APPEARANCE_ORIGINAL)
field_type= RECORD_YEAR_APPEARANCE_ORIGINAL_FIELD;

}



}



/*:59*//*60:*/
#line 2220 "querytyp.web"


else if(table==REMOTE_ACCESS)
field_type= REMOTE_ACCESS_FIELD;

else if(table==RIGHTS)
field_type= RIGHTS_FIELD;

else if(table==SOURCE)
field_type= SOURCE_FIELD;

else if(table==SUBJECT)
field_type= SUBJECT_FIELD;

else if(table==SUPERORDINATE_ENTITIES)
field_type= SUPERORDINATE_ENTITIES_FIELD;

else if(table==TITLE)
field_type= TITLE_FIELD;

else if(table==TYPE)
field_type= TYPE_FIELD;

else if(table==CONTRIBUTOR_SURNAME)
field_type= CONTRIBUTOR_SURNAME_FIELD;

else if(table==CONTRIBUTOR_GIVEN_NAME)
field_type= CONTRIBUTOR_GIVEN_NAME_FIELD;

else if(table==CONTRIBUTOR_PREFIX)
field_type= CONTRIBUTOR_PREFIX_FIELD;

else
field_type= QUERY_TYPE_NULL_TYPE;




if(traverse)
{
if(and_node)
and_node->set_field_specifier(v,true,scanner_node);

if(or_node)
or_node->set_field_specifier(v,true,scanner_node);

if(xor_node)
xor_node->set_field_specifier(v,true,scanner_node);
}



return 0;

#undef DEBUG_OUTPUT

}





/*:60*//*63:*/
#line 2309 "querytyp.web"

string
Query_Type::generate_tex_string(Scanner_Node scanner_node,
stringstream*tex_strm)

{


#if 0 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif

stringstream temp_strm;

#ifdef DEBUG_OUTPUT
temp_strm<<"Entering `Query_Type::generate_tex_string'."
<<endl
<<"`query_ctr' == "<<query_ctr
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif


/*:63*//*64:*/
#line 2341 "querytyp.web"





if(query_ctr==0)
*tex_strm<<"\\setbox\\namebox=\\hbox{"<<name<<"}"
<<endl;



*tex_strm<<"\\setbox\\querytypebox=\\hbox{"
<<query_type_map[query_type]<<"}"
<<endl;



*tex_strm<<"\\setbox\\fieldtypebox=\\hbox{"
<<field_type_map[field_type]<<"}"
<<endl;



*tex_strm<<"\\setbox\\valuetypebox=\\hbox{"
<<value_type_map[value_type]<<"}"
<<endl;



*tex_strm<<"\\setbox\\targettypesbox=\\hbox{";



if(target_types.size()<=0)
*tex_strm<<"QUERY_TYPE_NULL_TYPE";



else if(target_types.size()==1)
{
*tex_strm<<target_type_map[target_types[0]];
}



else
{
*tex_strm<<"\\vbox{";

int i= 0;

for(vector<unsigned short> ::iterator iter= target_types.begin();
iter!=target_types.end();
++iter)
{
if(i++> 0)
*tex_strm<<"%"<<endl;

*tex_strm<<"\\hbox{"
<<target_type_map[*iter]<<"}";

}

*tex_strm<<"}";

}




*tex_strm<<"}"
<<endl;



if(value_type==QUERY_TYPE_STRING_TYPE)
{
*tex_strm<<"\\setbox\\valuebox=\\hbox{"<<*static_cast<string*> (value)
<<"}"
<<endl;
}

else if(value_type==INT_TYPE)
{
*tex_strm<<"\\setbox\\valuebox=\\hbox{"<<*static_cast<int*> (value)
<<"}"
<<endl;
}

else if(value_type==FLOAT_TYPE)
{
*tex_strm<<"\\setbox\\valuebox=\\hbox{"<<*static_cast<float*> (value)
<<"}"
<<endl;
}

else if(value_type==DATE_TIME_TYPE)
{
*tex_strm<<"\\setbox\\valuebox=\\hbox{"
<<"Date\\_Time"

#if 0
*static_cast<Date_Time_Node> (value)
#endif

<<"}"
<<endl;


}






*tex_strm<<"\\upctr=";

if(up)
*tex_strm<<up->query_ctr;
else
*tex_strm<<"0";

*tex_strm<<endl;



*tex_strm<<"\\andctr=";

if(and_node)
*tex_strm<<and_node->query_ctr;
else
*tex_strm<<"0";

*tex_strm<<endl;



*tex_strm<<"\\orctr=";

if(or_node)
*tex_strm<<or_node->query_ctr;
else
*tex_strm<<"0";

*tex_strm<<endl;



*tex_strm<<"\\xorctr=";

if(or_node)
*tex_strm<<xor_node->query_ctr;
else
*tex_strm<<"0";

*tex_strm<<endl;



*tex_strm<<"%"
<<endl
<<"\\chart{"<<query_ctr<<"}{"<<negated<<"}"
<<endl
<<"%"
<<endl;



if(and_node)
{
*tex_strm<<"\\vskip\\queryskip\n%\n";

*tex_strm<<"\\vskip\\ht\\targettypesbox\n"
<<"\\vskip\\dp\\targettypesbox\n"
<<"%\n";

and_node->generate_tex_string(scanner_node,
tex_strm);
}



if(or_node)
{
*tex_strm<<"\\vskip\\queryskip\n%\n";
*tex_strm<<"\\vskip\\ht\\targettypesbox\n"
<<"\\vskip\\dp\\targettypesbox\n"
<<"%\n";

or_node->generate_tex_string(scanner_node,
tex_strm);
}



if(xor_node)
{
*tex_strm<<"\\vskip\\queryskip\n%\n";
*tex_strm<<"\\vskip\\ht\\targettypesbox\n"
<<"\\vskip\\dp\\targettypesbox\n"
<<"%\n";



xor_node->generate_tex_string(scanner_node,
tex_strm);
}



/*:64*//*65:*/
#line 2555 "querytyp.web"


#ifdef DEBUG_OUTPUT

temp_strm<<"Exiting `Query_Type::generate_tex_string'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node!=0)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif


return tex_strm->str();


}




/*:65*//*68:*/
#line 2648 "querytyp.web"

int
Query_Type::show(string s,
Scanner_Node sscanner_node)

{

stringstream temp_strm;

if(scanner_node==0&&sscanner_node!=0)
scanner_node= sscanner_node;





/*:68*//*69:*/
#line 2679 "querytyp.web"




temp_strm<<"`name' == "<<name
<<endl
<<"`query_type' == "<<query_type_map[query_type]
<<endl
<<"`field_type' == "<<field_type_map[field_type]
<<endl
<<"`value_type' == "<<value_type_map[value_type]
<<endl
<<"`match_value' == "<<match_value_map[match_value]
<<endl;

int i= 0;

for(vector<unsigned short> ::iterator iter= target_types.begin();
iter!=target_types.end();
++iter)
temp_strm<<"`target_types["<<i++<<"]' == "<<target_type_map[*iter]
<<endl;




if(value!=0)
{



if(field_type==ACCESS_NUMBER_FIELD)
temp_strm<<"Access_Number == "<<*static_cast<string*> (value)<<endl;

else if(field_type==AUTHOR_FIELD)
temp_strm<<"Author == "<<*static_cast<string*> (value)<<endl;



else if(field_type==BIBLIOGRAPHIC_TYPE_FIELD)
temp_strm<<"Bibliographic_Type == "<<*static_cast<string*> (value)<<endl;



else if(field_type==CALL_NUMBER_FIELD)
temp_strm<<"Call_Number == "<<*static_cast<string*> (value)<<endl;

else if(field_type==CLASSIFICATION_FIELD)
temp_strm<<"Classification == "<<*static_cast<string*> (value)<<endl;


else if(field_type==COMPANY_FIELD)
temp_strm<<"Company == "<<*static_cast<string*> (value)<<endl;

else if(field_type==CONTENT_SUMMARY_FIELD)
temp_strm<<"Content_Summary == "<<*static_cast<string*> (value)<<endl;

else if(field_type==CONTRIBUTOR_FIELD)
temp_strm<<"Contributor == "<<*static_cast<string*> (value)<<endl;

else if(field_type==CREATOR_FIELD)
temp_strm<<"Creator == "<<*static_cast<string*> (value)<<endl;



else if(field_type==DATABASE_PROVIDER_FIELD)
temp_strm<<"Database_Provider == "<<*static_cast<string*> (value)<<endl;

else if(field_type==DESCRIPTION_FIELD)
temp_strm<<"Description == "<<*static_cast<string*> (value)<<endl;



else if(field_type==EXEMPLAR_PRODUCTION_NUMBER_FIELD)
temp_strm<<"Exemplar_Production_Number == "<<*static_cast<string*> (value)<<endl;



else if(field_type==IDENTIFIER_FIELD)
temp_strm<<"Identifier == "<<*static_cast<string*> (value)<<endl;

else if(field_type==INSTITUTION_FIELD)
temp_strm<<"Institution == "<<*static_cast<string*> (value)<<endl;



else if(field_type==LANGUAGE_FIELD)
temp_strm<<"Language == "<<*static_cast<string*> (value)<<endl;



else if(field_type==MAIN_CANONICAL_TITLE_FIELD)
temp_strm<<"Main_Canonical_Title_ == "
<<*static_cast<string*> (value)<<endl;



else if(field_type==PERMUTATION_PATTERN_FIELD)
temp_strm<<"Permutation_Pattern == "<<*static_cast<string*> (value)<<endl;

else if(field_type==PERSON_FIELD)
temp_strm<<"Person == "<<*static_cast<string*> (value)<<endl;

else if(field_type==PHYSICAL_DESCRIPTION_FIELD)
temp_strm<<"Physical_Description == "<<*static_cast<string*> (value)<<endl;

else if(field_type==PUBLISHER_FIELD)
temp_strm<<"Publisher == "<<*static_cast<string*> (value)<<endl;





else if(field_type==RECORD_FIELD)
temp_strm<<"Record == "<<*static_cast<string*> (value)<<endl;

else if(field_type==RECORD_ID_FIELD)
temp_strm<<"Record ID == "<<*static_cast<int*> (value)<<endl;

else if(field_type==RECORD_ELN_ORIGINAL_ENTRY_FIELD)
temp_strm<<"Record_Eln_Original_Entry_Field == "
<<*static_cast<int*> (value)<<endl;

else if(field_type==RECORD_ELN_MOST_RECENT_CHANGE_FIELD)
temp_strm<<"Record_Eln_Most_Recent_Change_Field == "
<<*static_cast<int*> (value)<<endl;

else if(field_type==RECORD_ELN_STATUS_CHANGE_FIELD)
temp_strm<<"Record_Eln_Status_Change_Field == "
<<*static_cast<int*> (value)<<endl;

else if(field_type==RECORD_IDENTIFICATION_NUMBER_FIELD)
temp_strm<<"Record_Identification_Number_Field == "
<<*static_cast<string*> (value)<<endl;

else if(field_type==RECORD_SOURCE_ID_FIELD)
temp_strm<<"Record_Source_Id_Field == "
<<*static_cast<int*> (value)<<endl;

else if(field_type==RECORD_YEAR_APPEARANCE_BEGIN_FIELD)
temp_strm<<"Record_Year_Appearance_Begin_Field == "
<<*static_cast<int*> (value)<<endl;

else if(field_type==RECORD_YEAR_APPEARANCE_END_FIELD)
temp_strm<<"Record_Year_Appearance_End_Field == "
<<*static_cast<int*> (value)<<endl;

else if(field_type==RECORD_YEAR_APPEARANCE_RAK_WB_FIELD)
temp_strm<<"Record_Year_Appearance_Rak_Wb_Field == "
<<*static_cast<int*> (value)<<endl;

else if(field_type==RECORD_YEAR_APPEARANCE_ORIGINAL_FIELD)
temp_strm<<"Record_Year_Appearance_Original_Field == "
<<*static_cast<int*> (value)<<endl;

else if(field_type==RECORD_DATE_STATUS_CHANGE_FIELD)
temp_strm<<"Record_Date_Status_Change_Field:"
<<endl
<<*static_cast<Date_Time_Node> (value)
<<endl;

else if(field_type==RECORD_DATE_ORIGINAL_ENTRY_FIELD)
temp_strm<<"Record_Date_Original_Entry_Field:"
<<endl
<<*static_cast<Date_Time_Node> (value)
<<endl;

else if(field_type==RECORD_DATE_MOST_RECENT_CHANGE_FIELD)
temp_strm<<"Record_Date_Most_Recent_Change_Field == "
<<endl
<<*static_cast<Date_Time_Node> (value)
<<endl;


else if(field_type==REMOTE_ACCESS_FIELD)
temp_strm<<"Remote_Access == "<<*static_cast<string*> (value)
<<endl;

else if(field_type==RIGHTS_FIELD)
temp_strm<<"Rights == "<<*static_cast<string*> (value)<<endl;



else if(field_type==SOURCE_FIELD)
temp_strm<<"Source == "<<*static_cast<string*> (value)<<endl;

else if(field_type==SUBJECT_FIELD)
temp_strm<<"Subject == "<<*static_cast<string*> (value)<<endl;

else if(field_type==SUPERORDINATE_ENTITIES_FIELD)
temp_strm<<"Superordinate_Entities == "<<*static_cast<string*> (value)<<endl;



else if(field_type==TITLE_FIELD)
temp_strm<<"Title == "<<*static_cast<string*> (value)<<endl;

else if(field_type==TYPE_FIELD)
temp_strm<<"Type == "<<*static_cast<string*> (value)<<endl;



else
temp_strm<<"Can't show this field yet."
<<endl;



}



else
{
temp_strm<<"`value'  == 0."<<endl;
}




if(up&&up->value&&up->value_type==QUERY_TYPE_STRING_TYPE)
{
temp_strm<<"`up->value' == "<<*static_cast<string*> (up->value)<<endl;
}





/*:69*//*70:*/
#line 2911 "querytyp.web"



cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");


if(scanner_node!=0&&scanner_node->log_strm.is_open())
scanner_node->log_strm<<temp_strm;


/*:70*//*71:*/
#line 2932 "querytyp.web"


if(and_node!=0)
{
temp_strm<<"*** `and_node' ****"<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");

if(scanner_node!=0&&scanner_node->log_strm.is_open())
scanner_node->log_strm<<temp_strm;


and_node->show("`and_node':",sscanner_node);
}


if(or_node!=0)
{
temp_strm<<"*** `or_node' ****"<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");

if(scanner_node!=0&&scanner_node->log_strm.is_open())
scanner_node->log_strm<<temp_strm;

or_node->show("`or_node':",sscanner_node);
}

if(xor_node!=0)
{
temp_strm<<"*** `xor_node' ****"<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");

if(scanner_node!=0&&scanner_node->log_strm.is_open())
scanner_node->log_strm<<temp_strm;

xor_node->show("`xor_node':",sscanner_node);
}

temp_strm<<"*******"<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
temp_strm.str("");


/*:71*//*72:*/
#line 2990 "querytyp.web"


return 0;

}


/*:72*/
#line 3013 "querytyp.web"




/*:74*/
