/* * (1) Copyright and License. */

/* This file is part of the LDF Metadata Exchange Utilities,             */
/* a package for metadata exchange.                                      */

/* Copyright (C) 2007 Laurence D. Finston   */

/* The author is Laurence D. Finston.  */

/* The LDF Metadata Exchange Utilities are free software;                   */
/* you can redistribute them and/or modify                                  */
/* them under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation; either version 2 of the License, or        */
/* (at your option) any later version.                                      */

/* The LDF Metadata Exchange Utilities are distributed in the hope               */
/* that they will be useful, but WITHOUT ANY WARRANTY; without even              */
/* the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  */
/* See the GNU General Public License for more details.                          */

/* You should have received a copy of the GNU General Public License                   */
/* along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  */
/* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          */

/* The LDF Metadata Exchange Utilities are available for downloading from the  */
/* following FTP server:                                                       */
/* ftp:/*ftp.gwdg.de/pub/gnu2/iwfmdh/                                          */

/* Please send bug reports to lfinsto1@gwdg.de  */

/* The author can be contacted at:  */

/* Laurence D. Finston  */
/* Kreuzbergring 41     */
/* D-37075 Goettingen   */
/* Germany              */

/* lfinsto1@gwdg.de                */
/* s246794@stud.uni-goettingen.de  */


/*75:*/
#line 3018 "querytyp.web"


#ifndef QUERYTYP_KNOWN
#define QUERYTYP_KNOWN 1

/*29:*/
#line 710 "querytyp.web"


#define QUERY_TYPE_BITSET_SIZE 96


/*:29*/
#line 3023 "querytyp.web"

/*3:*/
#line 116 "querytyp.web"


#ifdef WIN_LDF
#pragma once
#endif



/*:3*/
#line 3024 "querytyp.web"

using namespace std;
/*4:*/
#line 132 "querytyp.web"


class Scanner_Type;
typedef Scanner_Type*Scanner_Node;

class Query_Type;
typedef Query_Type*Query_Node;

class Id_Type;
typedef Id_Type*Id_Node;


/*:4*/
#line 3026 "querytyp.web"

/*5:*/
#line 184 "querytyp.web"


class
Query_Type;

typedef Query_Type*Query_Node;

class
Query_Type
{

/*7:*/
#line 285 "querytyp.web"


friend
int
yyparse(void*);

friend
void*
Scan_Parse::variable_func(void*v,
char*name);

friend
Id_Node
Scan_Parse::declare_variable_func(void*v,
const unsigned short type,
char*name);

friend
void*
Scan_Parse::query_assignment_func_0(void*v,
void*object,
unsigned int assignment_type,
unsigned int arg_0,
unsigned int arg_1,
void*value,
bool negate);
friend
int
Scan_Parse::query_assignment_func_1(Scanner_Node scanner_node,
Id_Node&curr_id_node,
void*&field_specifier,
int assignment_operator,
int negation_optional,
int match_term_optional,
void*&v,
int type);




friend
int
Scan_Parse::start_local_database_query_func(void*v);

friend
int
Scan_Parse::end_query_func(void*v);

friend
int
Scan_Parse::datetime_assignment_func_0(void*v,
Date_Time_Node&curr_date_time_node,
int specifier,
int op,
void*val,
int type);


friend
int
Scan_Parse::datetime_assignment_func_1(void*v,
Date_Time_Node&d,
int op,
void*&vec);



/*:7*/
#line 195 "querytyp.web"


private:

unsigned short query_type;
unsigned short field_type;
unsigned short value_type;
vector<unsigned short> target_types;

static map<unsigned short,string> query_type_map;
static map<unsigned short,string> field_type_map;
static map<unsigned short,string> value_type_map;
static map<unsigned short,string> target_type_map;
static map<unsigned short,string> match_value_map;

Id_Node id_node;

bool negated;

string name;

void*value;

Query_Node up;
Query_Node and_node;
Query_Node or_node;
Query_Node xor_node;

unsigned short match_value;

/*:5*//*6:*/
#line 226 "querytyp.web"


Scanner_Node scanner_node;

unsigned short query_ctr;

public:

/*9:*/
#line 364 "querytyp.web"


static const unsigned short QUERY_TYPE_NULL_TYPE;

/*:9*//*11:*/
#line 386 "querytyp.web"


static const unsigned short TOP_TYPE;
static const unsigned short AND_TYPE;
static const unsigned short OR_TYPE;
static const unsigned short XOR_TYPE;

/*:11*//*14:*/
#line 448 "querytyp.web"


static const unsigned short ACCESS_NUMBER_FIELD;
static const unsigned short AUTHOR_FIELD;

static const unsigned short BIBLIOGRAPHIC_TYPE_FIELD;

static const unsigned short CALL_NUMBER_FIELD;
static const unsigned short CLASSIFICATION_FIELD;
static const unsigned short COMPANY_FIELD;
static const unsigned short CONTENT_SUMMARY_FIELD;
static const unsigned short CONTRIBUTOR_FIELD;
static const unsigned short CREATOR_FIELD;

static const unsigned short DATABASE_PROVIDER_FIELD;
static const unsigned short DESCRIPTION_FIELD;

static const unsigned short EXEMPLAR_PRODUCTION_NUMBER_FIELD;

static const unsigned short IDENTIFIER_FIELD;
static const unsigned short INSTITUTION_FIELD;

static const unsigned short LANGUAGE_FIELD;

static const unsigned short MAIN_CANONICAL_TITLE_FIELD;

static const unsigned short PERMUTATION_PATTERN_FIELD;
static const unsigned short PHYSICAL_DESCRIPTION_FIELD;
static const unsigned short PERSON_FIELD;
static const unsigned short PUBLISHER_FIELD;

static const unsigned short RECORD_FIELD;
static const unsigned short REMOTE_ACCESS_FIELD;
static const unsigned short RIGHTS_FIELD;

static const unsigned short SOURCE_FIELD;
static const unsigned short SUBJECT_FIELD;
static const unsigned short SUPERORDINATE_ENTITIES_FIELD;

static const unsigned short TITLE_FIELD;
static const unsigned short TYPE_FIELD;


/*:14*//*16:*/
#line 500 "querytyp.web"


static const unsigned short AUTHOR_SURNAME_FIELD;
static const unsigned short AUTHOR_GIVEN_NAME_FIELD;
static const unsigned short AUTHOR_PREFIX_FIELD;



/*:16*//*17:*/
#line 511 "querytyp.web"


static const unsigned short CONTRIBUTOR_SURNAME_FIELD;
static const unsigned short CONTRIBUTOR_GIVEN_NAME_FIELD;
static const unsigned short CONTRIBUTOR_PREFIX_FIELD;


/*:17*//*18:*/
#line 521 "querytyp.web"


static const unsigned short RECORD_ID_FIELD;
static const unsigned short RECORD_ELN_ORIGINAL_ENTRY_FIELD;
static const unsigned short RECORD_ELN_MOST_RECENT_CHANGE_FIELD;
static const unsigned short RECORD_ELN_STATUS_CHANGE_FIELD;
static const unsigned short RECORD_IDENTIFICATION_NUMBER_FIELD;
static const unsigned short RECORD_DATE_ORIGINAL_ENTRY_FIELD;
static const unsigned short RECORD_DATE_MOST_RECENT_CHANGE_FIELD;
static const unsigned short RECORD_DATE_STATUS_CHANGE_FIELD;
static const unsigned short RECORD_SOURCE_ID_FIELD;
static const unsigned short RECORD_YEAR_APPEARANCE_BEGIN_FIELD;
static const unsigned short RECORD_YEAR_APPEARANCE_END_FIELD;
static const unsigned short RECORD_YEAR_APPEARANCE_RAK_WB_FIELD;
static const unsigned short RECORD_YEAR_APPEARANCE_ORIGINAL_FIELD;




/*:18*//*25:*/
#line 654 "querytyp.web"


static const unsigned short INT_TYPE;
static const unsigned short FLOAT_TYPE;
static const unsigned short QUERY_TYPE_STRING_TYPE;
static const unsigned short DATE_TIME_TYPE;

/*:25*//*27:*/
#line 683 "querytyp.web"


static const unsigned short LOCAL_DATABASE_TARGET;
static const unsigned short LOCAL_SERVER_TARGET;
static const unsigned short REMOTE_DATABASE_TARGET;
static const unsigned short REMOTE_SERVER_TARGET;

/*:27*//*34:*/
#line 948 "querytyp.web"


static const unsigned short CONTAINS_VALUE;
static const unsigned short FREETEXT_VALUE;
static const unsigned short LIKE_VALUE;


/*:34*/
#line 234 "querytyp.web"

/*30:*/
#line 716 "querytyp.web"


static bitset<QUERY_TYPE_BITSET_SIZE> NULL_BITSET;




/*:30*//*31:*/
#line 726 "querytyp.web"




static bitset<QUERY_TYPE_BITSET_SIZE> ACCESS_NUMBER_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> AUTHOR_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> AUTHOR_SURNAME_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> AUTHOR_GIVEN_NAME_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> AUTHOR_PREFIX_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> BIBLIOGRAPHIC_TYPE_FLAG;




static bitset<QUERY_TYPE_BITSET_SIZE> CALL_NUMBER_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> CLASSIFICATION_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> COMPANY_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> CONTENT_SUMMARY_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> CONTRIBUTOR_SURNAME_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> CONTRIBUTOR_GIVEN_NAME_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> CONTRIBUTOR_PREFIX_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> CREATOR_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> CONTRIBUTOR_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> DATABASE_PROVIDER_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> DESCRIPTION_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> EXEMPLAR_PRODUCTION_NUMBER_FLAG;




static bitset<QUERY_TYPE_BITSET_SIZE> IDENTIFIER_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> INSTITUTION_FLAG;




static bitset<QUERY_TYPE_BITSET_SIZE> LANGUAGE_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> MAIN_CANONICAL_TITLE_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> PERMUTATION_PATTERN_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> PERSON_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> PHYSICAL_DESCRIPTION_FLAG;

static bitset<QUERY_TYPE_BITSET_SIZE> PUBLISHER_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_ID_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_ELN_ORIGINAL_ENTRY_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_ELN_MOST_RECENT_CHANGE_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_ELN_STATUS_CHANGE_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_IDENTIFICATION_NUMBER_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_DATE_ORIGINAL_ENTRY_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_DATE_MOST_RECENT_CHANGE_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_DATE_STATUS_CHANGE_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_SOURCE_ID_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_YEAR_APPEARANCE_BEGIN_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_YEAR_APPEARANCE_END_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_YEAR_APPEARANCE_RAK_WB_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RECORD_YEAR_APPEARANCE_ORIGINAL_FLAG;


static bitset<QUERY_TYPE_BITSET_SIZE> REMOTE_ACCESS_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> RIGHTS_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> SOURCE_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> SUBJECT_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> SUPERORDINATE_ENTITIES_FLAG;



static bitset<QUERY_TYPE_BITSET_SIZE> TITLE_FLAG;
static bitset<QUERY_TYPE_BITSET_SIZE> TYPE_FLAG;







/*:31*/
#line 235 "querytyp.web"


/*38:*/
#line 984 "querytyp.web"


Query_Type(void);

/*:38*//*40:*/
#line 1030 "querytyp.web"

int
set(unsigned short qquery_type,
unsigned short ffield_type= 0,
unsigned short vvalue_type= 0,
unsigned short ttarget_type= 0,
bool nnegated= false,
void*vvalue= 0,
Query_Node uup= 0,
Query_Node aand_node= 0,
Query_Node oor_node= 0,
Query_Node xxor_node= 0,
Scanner_Node sscanner_node= 0);

/*:40*//*42:*/
#line 1107 "querytyp.web"

~Query_Type(void);


/*:42*//*47:*/
#line 1289 "querytyp.web"

Query_Node
operator= (const Query_Type&q);


/*:47*//*51:*/
#line 1556 "querytyp.web"

static
int
initialize_type_maps(void);


/*:51*//*53:*/
#line 1735 "querytyp.web"


static
int
initialize_flags(void);


/*:53*//*57:*/
#line 1999 "querytyp.web"

int
set_field_specifier(void*v,
bool traverse= false,
Scanner_Node sscanner_node= 0);


/*:57*//*62:*/
#line 2300 "querytyp.web"


string
generate_tex_string(Scanner_Node scanner_node,
stringstream*tex_strm);



/*:62*//*66:*/
#line 2597 "querytyp.web"

int
generate_sql_string(Scanner_Node scanner_node,
int database_type,
stringstream*sql_strm,
stringstream*select_strm,
stringstream*from_strm,
stringstream*where_strm_0,
stringstream*where_strm_1,
bool*first_select,
bool*first_from,
bool*first_where,
bitset<QUERY_TYPE_BITSET_SIZE> *field_flags,
string*return_str);


/*:66*//*67:*/
#line 2641 "querytyp.web"

int
show(string s= "`Query_Type':\n",
Scanner_Node sscanner_node= 0);


/*:67*/
#line 237 "querytyp.web"


};


/*:6*/
#line 3027 "querytyp.web"


#endif 

















/*:75*/
