/* * (1) Copyright and License. */

/* This file is part of the LDF Metadata Exchange Utilities,             */
/* a package for metadata exchange.                                      */

/* Copyright (C) 2007 Laurence D. Finston   */

/* The author is Laurence D. Finston.  */

/* The LDF Metadata Exchange Utilities are free software;                   */
/* you can redistribute them and/or modify                                  */
/* them under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation; either version 2 of the License, or        */
/* (at your option) any later version.                                      */

/* The LDF Metadata Exchange Utilities are distributed in the hope               */
/* that they will be useful, but WITHOUT ANY WARRANTY; without even              */
/* the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  */
/* See the GNU General Public License for more details.                          */

/* You should have received a copy of the GNU General Public License                   */
/* along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  */
/* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          */

/* The LDF Metadata Exchange Utilities are available for downloading from the  */
/* following FTP server:                                                       */
/* ftp:/*ftp.gwdg.de/pub/gnu2/iwfmdh/                                          */

/* Please send bug reports to lfinsto1@gwdg.de  */

/* The author can be contacted at:  */

/* Laurence D. Finston  */
/* Kreuzbergring 41     */
/* D-37075 Goettingen   */
/* Germany              */

/* lfinsto1@gwdg.de                */
/* s246794@stud.uni-goettingen.de  */


/*113:*/
#line 4223 "scanner.web"

/*2:*/
#line 87 "scanner.web"


#include "localldf.h"

#ifdef NON_WIN_LDF
#include "nonwin.h"
#else
#include "stdafx.h"
#endif

#include "parser.hxx"
#include "dttmtype.h"
#include "idtype.h"
#include "scnrtype.h"



/*:2*/
#line 4224 "scanner.web"

/*1:*/
#line 81 "scanner.web"


static char id_string[]
= "$Id: scanner.web,v 1.6 2007/02/13 20:41:04 lfinsto1 Exp $";

/*:1*/
#line 4225 "scanner.web"

using namespace std;
/*4:*/
#line 121 "scanner.web"


class Scanner_Type;
typedef Scanner_Type*Scanner_Node;

class Query_Type;
typedef Query_Type*Query_Node;

class Id_Type;
typedef Id_Type*Id_Node;

class Date_Time_Type;
typedef Date_Time_Type*Date_Time_Node;



/*:4*/
#line 4227 "scanner.web"

/*7:*/
#line 165 "scanner.web"

namespace Scan_Parse
{
extern const unsigned int NULL_STATE= 0;
extern const unsigned int COLLECTING_ID= 1;
extern const unsigned int COLLECTING_STRING= 2;
extern const unsigned int COLLECTING_INTEGER= 3;
extern const unsigned int COLLECTING_FLOAT= 4;

/*13:*/
#line 240 "scanner.web"


struct
Keyword_Type
{
string name;
int value;
string value_name;
};


/*:13*/
#line 174 "scanner.web"

/*15:*/
#line 263 "scanner.web"


map<string,Keyword_Type*> keyword_map;


/*:15*/
#line 175 "scanner.web"

/*18:*/
#line 288 "scanner.web"


map<unsigned int,string> token_map;


/*:18*/
#line 176 "scanner.web"

/*20:*/
#line 321 "scanner.web"

int
initialize_maps(void);


/*:20*//*43:*/
#line 1791 "scanner.web"

int
show_keyword_map(Scanner_Type*scanner_node);

/*:43*//*47:*/
#line 1874 "scanner.web"

void*
variable_func(void*v,
char*name);



/*:47*//*48:*/
#line 1895 "scanner.web"

Id_Node
declare_variable_func(void*v,const unsigned short type,char*name);


/*:48*//*50:*/
#line 1920 "scanner.web"


void*
query_assignment_func_0(void*v,
void*object,
unsigned int assignment_type,
unsigned int arg_0,
unsigned int arg_1,
void*value,
bool negate);




/*:50*//*51:*/
#line 1944 "scanner.web"


int
query_assignment_func_1(Scanner_Node scanner_node,
Id_Node&curr_id_node,
void*&field_specifier,
int assignment_operator,
int negation_optional,
int match_term_optional,
void*&v,
int type);


/*:51*//*52:*/
#line 1967 "scanner.web"


int
datetime_assignment_func_0(void*v,
Date_Time_Node&curr_date_time_node,
int specifier,
int op,
void*val,
int type);



/*:52*//*53:*/
#line 1989 "scanner.web"


int
datetime_assignment_func_1(void*v,
Date_Time_Node&d,
int op,
void*&vec);



/*:53*//*55:*/
#line 2021 "scanner.web"

int
start_local_database_query_func(void*);


/*:55*//*56:*/
#line 2039 "scanner.web"

int
end_query_func(void*);


/*:56*/
#line 177 "scanner.web"


}


/*:7*/
#line 4228 "scanner.web"

/*21:*/
#line 327 "scanner.web"

int
Scan_Parse::initialize_maps(void)
{
Keyword_Type*curr_keyword;


/*:21*//*22:*/
#line 337 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "AT_SYMBOL";
curr_keyword->value= AT_SYMBOL;
curr_keyword->value_name= "AT_SYMBOL";
keyword_map["@"]= curr_keyword;
token_map[AT_SYMBOL]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "COMMA";
curr_keyword->value= COMMA;
curr_keyword->value_name= "COMMA";
keyword_map[","]= curr_keyword;
token_map[COMMA]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "PERCENT";
curr_keyword->value= PERCENT;
curr_keyword->value_name= "PERCENT";
keyword_map[","]= curr_keyword;
token_map[PERCENT]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "COLON";
curr_keyword->value= COLON;
curr_keyword->value_name= "COLON";
keyword_map[":"]= curr_keyword;
token_map[COLON]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "PERIOD";
curr_keyword->value= PERIOD;
curr_keyword->value_name= "PERIOD";
keyword_map["."]= curr_keyword;
token_map[PERIOD]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "HYPHEN";
curr_keyword->value= HYPHEN;
curr_keyword->value_name= "HYPHEN";
keyword_map["-"]= curr_keyword;
token_map[HYPHEN]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "SEMI_COLON";
curr_keyword->value= SEMI_COLON;
curr_keyword->value_name= "SEMI_COLON";
keyword_map[";"]= curr_keyword;
token_map[SEMI_COLON]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "OPEN_PARENTHESIS";
curr_keyword->value= OPEN_PARENTHESIS;
curr_keyword->value_name= "OPEN_PARENTHESIS";
keyword_map["("]= curr_keyword;
token_map[OPEN_PARENTHESIS]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "CLOSE_PARENTHESIS";
curr_keyword->value= CLOSE_PARENTHESIS;
curr_keyword->value_name= "CLOSE_PARENTHESIS";
keyword_map[")"]= curr_keyword;
token_map[CLOSE_PARENTHESIS]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "OPEN_BRACKET";
curr_keyword->value= OPEN_BRACKET;
curr_keyword->value_name= "OPEN_BRACKET";
keyword_map["["]= curr_keyword;
token_map[OPEN_BRACKET]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "CLOSE_BRACKET";
curr_keyword->value= CLOSE_BRACKET;
curr_keyword->value_name= "CLOSE_BRACKET";

keyword_map["]"]= curr_keyword;
token_map[CLOSE_BRACKET]= curr_keyword->value_name;


/*:22*//*23:*/
#line 456 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "ASSIGN";
curr_keyword->value= ASSIGN;
curr_keyword->value_name= "ASSIGN";
keyword_map["="]= curr_keyword;
token_map[ASSIGN]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "PLUS_ASSIGN";
curr_keyword->value= PLUS_ASSIGN;
curr_keyword->value_name= "PLUS_ASSIGN";
keyword_map["+="]= curr_keyword;
token_map[PLUS_ASSIGN]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "MINUS_ASSIGN";
curr_keyword->value= MINUS_ASSIGN;
curr_keyword->value_name= "MINUS_ASSIGN";
keyword_map["-="]= curr_keyword;
token_map[MINUS_ASSIGN]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "TIMES_ASSIGN";
curr_keyword->value= TIMES_ASSIGN;
curr_keyword->value_name= "TIMES_ASSIGN";
keyword_map["*="]= curr_keyword;
token_map[TIMES_ASSIGN]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "DIVIDE_ASSIGN";
curr_keyword->value= DIVIDE_ASSIGN;
curr_keyword->value_name= "DIVIDE_ASSIGN";
keyword_map["/="]= curr_keyword;
token_map[DIVIDE_ASSIGN]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "AND_ASSIGN";
curr_keyword->value= AND_ASSIGN;
curr_keyword->value_name= "AND_ASSIGN";
keyword_map["&="]= curr_keyword;
token_map[AND_ASSIGN]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "OR_ASSIGN";
curr_keyword->value= OR_ASSIGN;
curr_keyword->value_name= "OR_ASSIGN";
keyword_map["|="]= curr_keyword;
token_map[OR_ASSIGN]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "XOR_ASSIGN";
curr_keyword->value= XOR_ASSIGN;
curr_keyword->value_name= "XOR_ASSIGN";
keyword_map["^="]= curr_keyword;
token_map[XOR_ASSIGN]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "NOT_ASSIGN";
curr_keyword->value= NOT_ASSIGN;
curr_keyword->value_name= "NOT_ASSIGN";
keyword_map["!="]= curr_keyword;
token_map[NOT_ASSIGN]= curr_keyword->value_name;





/*:23*//*24:*/
#line 554 "scanner.web"





curr_keyword= new Keyword_Type;
curr_keyword->name= "PLUS";
curr_keyword->value= PLUS;
curr_keyword->value_name= "PLUS";
keyword_map["+"]= curr_keyword;
token_map[PLUS]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "MINUS";
curr_keyword->value= MINUS;
curr_keyword->value_name= "MINUS";
keyword_map["-"]= curr_keyword;
token_map[MINUS]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "TIMES";
curr_keyword->value= TIMES;
curr_keyword->value_name= "TIMES";
keyword_map["*"]= curr_keyword;
token_map[TIMES]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "DIVIDE";
curr_keyword->value= DIVIDE;
curr_keyword->value_name= "DIVIDE";
keyword_map["/"]= curr_keyword;
token_map[DIVIDE]= curr_keyword->value_name;


/*:24*//*25:*/
#line 599 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "STRING";
curr_keyword->value= STRING;
curr_keyword->value_name= "STRING";
keyword_map["STRING"]= curr_keyword;
token_map[STRING]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "INTEGER";
curr_keyword->value= INTEGER;
curr_keyword->value_name= "INTEGER";
keyword_map["INTEGER"]= curr_keyword;
token_map[INTEGER]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "FLOAT";
curr_keyword->value= FLOAT;
curr_keyword->value_name= "FLOAT";
keyword_map["FLOAT"]= curr_keyword;
token_map[FLOAT]= curr_keyword->value_name;


/*:25*//*26:*/
#line 632 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "start";
curr_keyword->value= START;
curr_keyword->value_name= "START";
keyword_map["start"]= curr_keyword;
token_map[START]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "end";
curr_keyword->value= END;
curr_keyword->value_name= "END";
keyword_map["end"]= curr_keyword;
token_map[END]= curr_keyword->value_name;


/*:26*//*27:*/
#line 661 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "query";
curr_keyword->value= QUERY_DECLARATOR;
curr_keyword->value_name= "QUERY_DECLARATOR";
keyword_map["query"]= curr_keyword;
token_map[QUERY_DECLARATOR]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "local";
curr_keyword->value= LOCAL;
curr_keyword->value_name= "LOCAL";
keyword_map["local"]= curr_keyword;
token_map[LOCAL]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "remote";
curr_keyword->value= REMOTE;
curr_keyword->value_name= "REMOTE";
keyword_map["remote"]= curr_keyword;
token_map[REMOTE]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "database";
curr_keyword->value= DATABASE;
curr_keyword->value_name= "DATABASE";
keyword_map["database"]= curr_keyword;
token_map[DATABASE]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "server";
curr_keyword->value= SERVER;
curr_keyword->value_name= "SERVER";
keyword_map["server"]= curr_keyword;
token_map[SERVER]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "string";
curr_keyword->value= STRING_DECLARATOR;
curr_keyword->value_name= "STRING_DECLARATOR";
keyword_map["string"]= curr_keyword;
token_map[STRING_DECLARATOR]= curr_keyword->value_name;


/*:27*//*28:*/
#line 733 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "contains";
curr_keyword->value= CONTAINS;
curr_keyword->value_name= "CONTAINS";
keyword_map["contains"]= curr_keyword;
token_map[CONTAINS]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "freetext";
curr_keyword->value= FREETEXT;
curr_keyword->value_name= "FREETEXT";
keyword_map["freetext"]= curr_keyword;
token_map[FREETEXT]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "like";
curr_keyword->value= LIKE;
curr_keyword->value_name= "LIKE";
keyword_map["like"]= curr_keyword;
token_map[LIKE]= curr_keyword->value_name;






/*:28*//*29:*/
#line 776 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "datasource";
curr_keyword->value= DATASOURCE_DECLARATOR;
curr_keyword->value_name= "DATASOURCE_DECLARATOR";
keyword_map["datasource"]= curr_keyword;
token_map[DATASOURCE_DECLARATOR]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "dbt";
curr_keyword->value= DBT;
curr_keyword->value_name= "DBT";
keyword_map["dbt"]= curr_keyword;
token_map[DBT]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "gbv_gvk";
curr_keyword->value= GBV_GVK;
curr_keyword->value_name= "GBV_GVK";
keyword_map["gbv_gvk"]= curr_keyword;
token_map[GBV_GVK]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "timms";
curr_keyword->value= TIMMS;
curr_keyword->value_name= "TIMMS";
keyword_map["timms"]= curr_keyword;
token_map[TIMMS]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "file";
curr_keyword->value= DATASOURCE_FILE;
curr_keyword->value_name= "DATASOURCE_FILE";
keyword_map["file"]= curr_keyword;
token_map[DATASOURCE_FILE]= curr_keyword->value_name;





/*:29*//*30:*/
#line 837 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "datetime";
curr_keyword->value= DATETIME_DECLARATOR;
curr_keyword->value_name= "DATETIME_DECLARATOR";
keyword_map["datetime"]= curr_keyword;
token_map[DATETIME_DECLARATOR]= curr_keyword->value_name;



/*:30*//*31:*/
#line 862 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "year_range_begin";
curr_keyword->value= YEAR_RANGE_BEGIN;
curr_keyword->value_name= "YEAR_RANGE_BEGIN";
keyword_map["year_range_begin"]= curr_keyword;
token_map[YEAR_RANGE_BEGIN]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "year_range_end";
curr_keyword->value= YEAR_RANGE_END;
curr_keyword->value_name= "YEAR_RANGE_END";
keyword_map["year_range_end"]= curr_keyword;
token_map[YEAR_RANGE_END]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "year";
curr_keyword->value= YEAR;
curr_keyword->value_name= "YEAR";
keyword_map["year"]= curr_keyword;
token_map[YEAR]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "month";
curr_keyword->value= MONTH;
curr_keyword->value_name= "MONTH";
keyword_map["month"]= curr_keyword;
token_map[MONTH]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "day";
curr_keyword->value= DAY;
curr_keyword->value_name= "DAY";
keyword_map["day"]= curr_keyword;
token_map[DAY]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "hour";
curr_keyword->value= HOUR;
curr_keyword->value_name= "HOUR";
keyword_map["hour"]= curr_keyword;
token_map[HOUR]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "minute";
curr_keyword->value= MINUTE;
curr_keyword->value_name= "MINUTE";
keyword_map["minute"]= curr_keyword;
token_map[MINUTE]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "second";
curr_keyword->value= SECOND;
curr_keyword->value_name= "SECOND";
keyword_map["second"]= curr_keyword;
token_map[SECOND]= curr_keyword->value_name;


/*:31*//*32:*/
#line 950 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "if";
curr_keyword->value= IF;
curr_keyword->value_name= "IF";
keyword_map["if"]= curr_keyword;
token_map[IF]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "else";
curr_keyword->value= ELSE;
curr_keyword->value_name= "ELSE";
keyword_map["else"]= curr_keyword;
token_map[ELSE]= curr_keyword->value_name;





curr_keyword= new Keyword_Type;
curr_keyword->name= "elif";
curr_keyword->value= ELIF;
curr_keyword->value_name= "ELIF";
keyword_map["elif"]= curr_keyword;
token_map[ELIF]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "fi";
curr_keyword->value= FI;
curr_keyword->value_name= "FI";
keyword_map["fi"]= curr_keyword;
token_map[FI]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "for";
curr_keyword->value= FOR;
curr_keyword->value_name= "FOR";
keyword_map["for"]= curr_keyword;
token_map[FOR]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "do";
curr_keyword->value= DO;
curr_keyword->value_name= "DO";
keyword_map["do"]= curr_keyword;
token_map[DO]= curr_keyword->value_name;





curr_keyword= new Keyword_Type;
curr_keyword->name= "while";
curr_keyword->value= WHILE;
curr_keyword->value_name= "WHILE";
keyword_map["while"]= curr_keyword;
token_map[WHILE]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "and";
curr_keyword->value= AND;
curr_keyword->value_name= "AND";
keyword_map["and"]= curr_keyword;
keyword_map["&"]= curr_keyword;
token_map[AND]= curr_keyword->value_name;





curr_keyword= new Keyword_Type;
curr_keyword->name= "or";
curr_keyword->value= OR;
curr_keyword->value_name= "OR";
keyword_map["or"]= curr_keyword;
keyword_map["|"]= curr_keyword;
token_map[OR]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "xor";
curr_keyword->value= XOR;
curr_keyword->value_name= "XOR";
keyword_map["xor"]= curr_keyword;
keyword_map["^"]= curr_keyword;
token_map[XOR]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "not";
curr_keyword->value= NOT;
curr_keyword->value_name= "NOT";
keyword_map["!"]= curr_keyword;
token_map[NOT]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "AND_NOT";
curr_keyword->value= AND_NOT;
curr_keyword->value_name= "AND_NOT";
keyword_map["&!"]= curr_keyword;
token_map[AND_NOT]= curr_keyword->value_name;





curr_keyword= new Keyword_Type;
curr_keyword->name= "OR_NOT";
curr_keyword->value= OR_NOT;
curr_keyword->value_name= "OR_NOT";
keyword_map["|!"]= curr_keyword;
token_map[OR_NOT]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "XOR_NOT";
curr_keyword->value= XOR_NOT;
curr_keyword->value_name= "XOR_NOT";
keyword_map["^!"]= curr_keyword;
token_map[XOR_NOT]= curr_keyword->value_name;





/*:32*//*33:*/
#line 1120 "scanner.web"





curr_keyword= new Keyword_Type;
curr_keyword->name= "access_number";
curr_keyword->value= ACCESS_NUMBER;
curr_keyword->value_name= "ACCESS_NUMBER";
keyword_map["access_number"]= curr_keyword;
token_map[ACCESS_NUMBER]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "author";
curr_keyword->value= AUTHOR;
curr_keyword->value_name= "AUTHOR";
keyword_map["author"]= curr_keyword;
token_map[AUTHOR]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "bibliographic_type";
curr_keyword->value= BIBLIOGRAPHIC_TYPE;
curr_keyword->value_name= "BIBLIOGRAPHIC_TYPE";
keyword_map["bibliographic_type"]= curr_keyword;
token_map[BIBLIOGRAPHIC_TYPE]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "call_number";
curr_keyword->value= CALL_NUMBER;
curr_keyword->value_name= "CALL_NUMBER";
keyword_map["call_number"]= curr_keyword;
token_map[CALL_NUMBER]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "classification";
curr_keyword->value= CLASSIFICATION;
curr_keyword->value_name= "CLASSIFICATION";
keyword_map["classification"]= curr_keyword;
token_map[CLASSIFICATION]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "company";
curr_keyword->value= COMPANY;
curr_keyword->value_name= "COMPANY";
keyword_map["company"]= curr_keyword;
token_map[COMPANY]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "content_summary";
curr_keyword->value= CONTENT_SUMMARY;
curr_keyword->value_name= "CONTENT_SUMMARY";
keyword_map["content_summary"]= curr_keyword;
token_map[CONTENT_SUMMARY]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "contributor";
curr_keyword->value= CONTRIBUTOR;
curr_keyword->value_name= "CONTRIBUTOR";
keyword_map["contributor"]= curr_keyword;
token_map[CONTRIBUTOR]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "creator";
curr_keyword->value= CREATOR;
curr_keyword->value_name= "CREATOR";
keyword_map["creator"]= curr_keyword;
token_map[CREATOR]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "database_provider";
curr_keyword->value= DATABASE_PROVIDER;
curr_keyword->value_name= "DATABASE_PROVIDER";
keyword_map["database_provider"]= curr_keyword;
token_map[DATABASE_PROVIDER]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "description";
curr_keyword->value= DESCRIPTION;
curr_keyword->value_name= "DESCRIPTION";
keyword_map["description"]= curr_keyword;
token_map[DESCRIPTION]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "exemplar_production_number";
curr_keyword->value= EXEMPLAR_PRODUCTION_NUMBER;
curr_keyword->value_name= "EXEMPLAR_PRODUCTION_NUMBER";
keyword_map["exemplar_production_number"]= curr_keyword;
token_map[EXEMPLAR_PRODUCTION_NUMBER]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "identifier";
curr_keyword->value= IDENTIFIER;
curr_keyword->value_name= "IDENTIFIER";
keyword_map["identifier"]= curr_keyword;
token_map[IDENTIFIER]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "institution";
curr_keyword->value= INSTITUTION;
curr_keyword->value_name= "INSTITUTION";
keyword_map["institution"]= curr_keyword;
token_map[INSTITUTION]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "language";
curr_keyword->value= LANGUAGE;
curr_keyword->value_name= "LANGUAGE";
keyword_map["language"]= curr_keyword;
token_map[LANGUAGE]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "main_canonical_title";
curr_keyword->value= MAIN_CANONICAL_TITLE;
curr_keyword->value_name= "MAIN_CANONICAL_TITLE";
keyword_map["main_canonical_title"]= curr_keyword;
token_map[MAIN_CANONICAL_TITLE]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "permutation_pattern";
curr_keyword->value= PERMUTATION_PATTERN;
curr_keyword->value_name= "PERMUTATION_PATTERN";
keyword_map["permutation_pattern"]= curr_keyword;
token_map[PERMUTATION_PATTERN]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "person";
curr_keyword->value= PERSON;
curr_keyword->value_name= "PERSON";
keyword_map["person"]= curr_keyword;
token_map[PERSON]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "physical_description";
curr_keyword->value= PHYSICAL_DESCRIPTION;
curr_keyword->value_name= "PHYSICAL_DESCRIPTION";
keyword_map["physical_description"]= curr_keyword;
token_map[PHYSICAL_DESCRIPTION]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "publisher";
curr_keyword->value= PUBLISHER;
curr_keyword->value_name= "PUBLISHER";
keyword_map["publisher"]= curr_keyword;
token_map[PUBLISHER]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "record";
curr_keyword->value= RECORD;
curr_keyword->value_name= "RECORD";
keyword_map["record"]= curr_keyword;
token_map[RECORD]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "remote_access";
curr_keyword->value= REMOTE_ACCESS;
curr_keyword->value_name= "REMOTE_ACCESS";
keyword_map["remote_access"]= curr_keyword;
token_map[REMOTE_ACCESS]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "rights";
curr_keyword->value= RIGHTS;
curr_keyword->value_name= "RIGHTS";
keyword_map["rights"]= curr_keyword;
token_map[RIGHTS]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "source";
curr_keyword->value= SOURCE;
curr_keyword->value_name= "SOURCE";
keyword_map["source"]= curr_keyword;
token_map[SOURCE]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "subject";
curr_keyword->value= SUBJECT;
curr_keyword->value_name= "SUBJECT";
keyword_map["subject"]= curr_keyword;
token_map[SUBJECT]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "superordinate_entities";
curr_keyword->value= SUPERORDINATE_ENTITIES;
curr_keyword->value_name= "SUPERORDINATE_ENTITIES";
keyword_map["superordinate_entities"]= curr_keyword;
token_map[SUPERORDINATE_ENTITIES]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "title";
curr_keyword->value= TITLE;
curr_keyword->value_name= "TITLE";
keyword_map["title"]= curr_keyword;
token_map[TITLE]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "type";
curr_keyword->value= TYPE;
curr_keyword->value_name= "TYPE";
keyword_map["type"]= curr_keyword;
token_map[TYPE]= curr_keyword->value_name;


/*:33*//*35:*/
#line 1395 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "id";
curr_keyword->value= ID;
curr_keyword->value_name= "ID";
keyword_map["id"]= curr_keyword;
token_map[ID]= curr_keyword->value_name;


/*:35*//*36:*/
#line 1416 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "given_name";
curr_keyword->value= GIVEN_NAME;
curr_keyword->value_name= "GIVEN_NAME";
keyword_map["given_name"]= curr_keyword;
token_map[GIVEN_NAME]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "prefix";
curr_keyword->value= PREFIX;
curr_keyword->value_name= "PREFIX";
keyword_map["prefix"]= curr_keyword;
token_map[PREFIX]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "surname";
curr_keyword->value= SURNAME;
curr_keyword->value_name= "SURNAME";
keyword_map["surname"]= curr_keyword;
token_map[SURNAME]= curr_keyword->value_name;




/*:36*//*37:*/
#line 1456 "scanner.web"


curr_keyword= new Keyword_Type;
curr_keyword->name= "eln_original_entry";
curr_keyword->value= ELN_ORIGINAL_ENTRY;
curr_keyword->value_name= "ELN_ORIGINAL_ENTRY";
keyword_map["eln_original_entry"]= curr_keyword;
token_map[ELN_ORIGINAL_ENTRY]= curr_keyword->value_name;

curr_keyword= new Keyword_Type;
curr_keyword->name= "eln_most_recent_change";
curr_keyword->value= ELN_MOST_RECENT_CHANGE;
curr_keyword->value_name= "ELN_MOST_RECENT_CHANGE";
keyword_map["eln_most_recent_change"]= curr_keyword;
token_map[ELN_MOST_RECENT_CHANGE]= curr_keyword->value_name;

curr_keyword= new Keyword_Type;
curr_keyword->name= "eln_status_change";
curr_keyword->value= ELN_STATUS_CHANGE;
curr_keyword->value_name= "ELN_STATUS_CHANGE";
keyword_map["eln_status_change"]= curr_keyword;
token_map[ELN_STATUS_CHANGE]= curr_keyword->value_name;


curr_keyword= new Keyword_Type;
curr_keyword->name= "identification_number";
curr_keyword->value= IDENTIFICATION_NUMBER;
curr_keyword->value_name= "IDENTIFICATION_NUMBER";
keyword_map["identification_number"]= curr_keyword;
token_map[IDENTIFICATION_NUMBER]= curr_keyword->value_name;

curr_keyword= new Keyword_Type;
curr_keyword->name= "date_original_entry";
curr_keyword->value= DATE_ORIGINAL_ENTRY;
curr_keyword->value_name= "DATE_ORIGINAL_ENTRY";
keyword_map["date_original_entry"]= curr_keyword;
token_map[DATE_ORIGINAL_ENTRY]= curr_keyword->value_name;

curr_keyword= new Keyword_Type;
curr_keyword->name= "date_most_recent_change";
curr_keyword->value= DATE_MOST_RECENT_CHANGE;
curr_keyword->value_name= "DATE_MOST_RECENT_CHANGE";
keyword_map["date_most_recent_change"]= curr_keyword;
token_map[DATE_MOST_RECENT_CHANGE]= curr_keyword->value_name;


curr_keyword= new Keyword_Type;
curr_keyword->name= "date_status_change";
curr_keyword->value= DATE_STATUS_CHANGE;
curr_keyword->value_name= "DATE_STATUS_CHANGE";
keyword_map["date_status_change"]= curr_keyword;
token_map[DATE_STATUS_CHANGE]= curr_keyword->value_name;

curr_keyword= new Keyword_Type;
curr_keyword->name= "source_id";
curr_keyword->value= SOURCE_ID;
curr_keyword->value_name= "SOURCE_ID";
keyword_map["source_id"]= curr_keyword;
token_map[SOURCE_ID]= curr_keyword->value_name;

curr_keyword= new Keyword_Type;
curr_keyword->name= "year_appearance_begin";
curr_keyword->value= YEAR_APPEARANCE_BEGIN;
curr_keyword->value_name= "YEAR_APPEARANCE_BEGIN";
keyword_map["year_appearance_begin"]= curr_keyword;
token_map[YEAR_APPEARANCE_BEGIN]= curr_keyword->value_name;

curr_keyword= new Keyword_Type;
curr_keyword->name= "year_appearance_end";
curr_keyword->value= YEAR_APPEARANCE_END;
curr_keyword->value_name= "YEAR_APPEARANCE_END";
keyword_map["year_appearance_end"]= curr_keyword;
token_map[YEAR_APPEARANCE_END]= curr_keyword->value_name;

curr_keyword= new Keyword_Type;
curr_keyword->name= "year_appearance_rak_wb";
curr_keyword->value= YEAR_APPEARANCE_RAK_WB;
curr_keyword->value_name= "YEAR_APPEARANCE_RAK_WB";
keyword_map["year_appearance_rak_wb"]= curr_keyword;
token_map[YEAR_APPEARANCE_RAK_WB]= curr_keyword->value_name;


curr_keyword= new Keyword_Type;
curr_keyword->name= "year_appearance_original";
curr_keyword->value= YEAR_APPEARANCE_ORIGINAL;
curr_keyword->value_name= "YEAR_APPEARANCE_ORIGINAL";
keyword_map["year_appearance_original"]= curr_keyword;
token_map[YEAR_APPEARANCE_ORIGINAL]= curr_keyword->value_name;








/*:37*//*38:*/
#line 1555 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "VARIABLE";
curr_keyword->value= VARIABLE;
curr_keyword->value_name= "VARIABLE";
keyword_map["VARIABLE"]= curr_keyword;
token_map[VARIABLE]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "VARIABLE_TEXT_SEGMENT";
curr_keyword->value= VARIABLE_TEXT_SEGMENT;
curr_keyword->value_name= "VARIABLE_TEXT_SEGMENT";
keyword_map["VARIABLE_TEXT_SEGMENT"]= curr_keyword;
token_map[VARIABLE_TEXT_SEGMENT]= curr_keyword->value_name;


/*:38*//*39:*/
#line 1588 "scanner.web"





curr_keyword= new Keyword_Type;
curr_keyword->name= "NULL_TYPE";
curr_keyword->value= NULL_TYPE;
curr_keyword->value_name= "NULL_TYPE";
keyword_map["NULL_TYPE"]= curr_keyword;
token_map[NULL_TYPE]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "DATASOURCE_TYPE";
curr_keyword->value= DATASOURCE_TYPE;
curr_keyword->value_name= "DATASOURCE_TYPE";
keyword_map["DATASOURCE_TYPE"]= curr_keyword;
token_map[DATASOURCE_TYPE]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "DATETIME_TYPE";
curr_keyword->value= DATETIME_TYPE;
curr_keyword->value_name= "DATETIME_TYPE";
keyword_map["DATETIME_TYPE"]= curr_keyword;
token_map[DATETIME_TYPE]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "QUERY_TYPE";
curr_keyword->value= QUERY_TYPE;
curr_keyword->value_name= "QUERY_TYPE";
keyword_map["QUERY_TYPE"]= curr_keyword;
token_map[QUERY_TYPE]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "STRING_TYPE";
curr_keyword->value= STRING_TYPE;
curr_keyword->value_name= "STRING_TYPE";
keyword_map["STRING_TYPE"]= curr_keyword;
token_map[STRING_TYPE]= curr_keyword->value_name;





/*:39*//*40:*/
#line 1665 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "clear";
curr_keyword->value= CLEAR;
curr_keyword->value_name= "CLEAR";
keyword_map["clear"]= curr_keyword;
token_map[CLEAR]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "errmessage";
curr_keyword->value= ERRMESSAGE;
curr_keyword->value_name= "ERRMESSAGE";
keyword_map["errmessage"]= curr_keyword;
token_map[ERRMESSAGE]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "message";
curr_keyword->value= MESSAGE;
curr_keyword->value_name= "MESSAGE";
keyword_map["message"]= curr_keyword;
token_map[MESSAGE]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "pause";
curr_keyword->value= PAUSE;
curr_keyword->value_name= "PAUSE";
keyword_map["pause"]= curr_keyword;
token_map[PAUSE]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "show";
curr_keyword->value= SHOW;
curr_keyword->value_name= "SHOW";
keyword_map["show"]= curr_keyword;
token_map[SHOW]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "tex";
curr_keyword->value= TEX;
curr_keyword->value_name= "TEX";
keyword_map["tex"]= curr_keyword;
token_map[TEX]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "sql";
curr_keyword->value= SQL;
curr_keyword->value_name= "SQL";
keyword_map["sql"]= curr_keyword;
token_map[SQL]= curr_keyword->value_name;





curr_keyword= new Keyword_Type;
curr_keyword->name= "oai";
curr_keyword->value= OAI;
curr_keyword->value_name= "OAI";
keyword_map["oai"]= curr_keyword;
token_map[OAI]= curr_keyword->value_name;



curr_keyword= new Keyword_Type;
curr_keyword->name= "pica";
curr_keyword->value= PICA;
curr_keyword->value_name= "PICA";
keyword_map["pica"]= curr_keyword;
token_map[PICA]= curr_keyword->value_name;




curr_keyword= new Keyword_Type;
curr_keyword->name= "output";
curr_keyword->value= OUTPUT;
curr_keyword->value_name= "OUTPUT";
keyword_map["output"]= curr_keyword;
token_map[OUTPUT]= curr_keyword->value_name;



/*:40*//*41:*/
#line 1767 "scanner.web"




curr_keyword= new Keyword_Type;
curr_keyword->name= "terminate";
curr_keyword->value= TERMINATE;
curr_keyword->value_name= "TERMINATE";
keyword_map["terminate"]= curr_keyword;
token_map[TERMINATE]= curr_keyword->value_name;





return 0;

}


/*:41*//*44:*/
#line 1796 "scanner.web"

int
Scan_Parse::show_keyword_map(Scanner_Type*scanner_node)
{

stringstream temp_strm;

temp_strm<<"Showing `keyword_map':"<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();

if(scanner_node)
scanner_node->log_strm<<temp_strm.str();

temp_strm.str("");

for(map<string,Keyword_Type*> ::const_iterator iter
= keyword_map.begin();
iter!=keyword_map.end();
++iter)
{
temp_strm<<"name:  "<<iter->second->name
<<", value:  "
<<token_map[iter->second->value]
<<" ("
<<iter->second->value
<<") "
<<", constant name:  "
<<iter->second->value_name<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(scanner_node)
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");

}

return 0;

}



/*:44*/
#line 4229 "scanner.web"

/*58:*/
#line 2062 "scanner.web"

int
yylex(YYSTYPE*value,
void*parameter)
{


#if 0 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif

using namespace Scan_Parse;

stringstream temp_strm;

stack<unsigned short> state_stack;
unsigned short state= NULL_STATE;

Scanner_Type*scanner_node= static_cast<Scanner_Type*> (parameter);


/*:58*//*59:*/
#line 2097 "scanner.web"



if(scanner_node->token_stack.size()> 0)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `scanner_node->token_stack.size() == "
<<scanner_node->token_stack.size()
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

Token_Type curr_token= scanner_node->token_stack.top();



#ifdef DEBUG_OUTPUT
temp_strm<<"`curr_token.type' == "<<token_map[curr_token.type]
<<" ("<<curr_token.type<<")."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

if(curr_token.type==STRING)
strcpy(value->string_value,curr_token.value.string_value);
else if(curr_token.type==INTEGER)
value->int_value= curr_token.value.int_value;
else if(curr_token.type==FLOAT)
value->float_value= curr_token.value.float_value;
else
{
value->pointer_value= curr_token.value.pointer_value;
curr_token.value.pointer_value= 0;
}

scanner_node->token_stack.pop();

return curr_token.type;

}

else
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `scanner_node->token_stack.size() == 0."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

}





/*:59*//*60:*/
#line 2168 "scanner.web"


#ifdef DEBUG_OUTPUT
temp_strm<<"Entering `yylex'."<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

#if 0 
#ifdef DEBUG_OUTPUT
temp_strm<<"`scanner_node->in_filename' == "<<scanner_node->in_filename<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif
#endif


/*:60*//*61:*/
#line 2202 "scanner.web"


char curr_char= 0;
char next_char= 0;
string curr_string= "";
string curr_id= "";
int curr_value= 0;

string curr_integer_str= "";
string curr_float_str= "";

while(curr_char!=EOF)
{
curr_char= scanner_node->in_strm.get();

#ifdef DEBUG_OUTPUT
temp_strm<<curr_char;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



/*:61*//*62:*/
#line 2237 "scanner.web"


if(curr_char=='#'
&&(state==NULL_STATE
||state==COLLECTING_ID
||state==COLLECTING_INTEGER
||state==COLLECTING_FLOAT))
{


#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Discarding comment.  ***"<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

while(!(curr_char=='\n'||curr_char==EOF))
{
curr_char= scanner_node->in_strm.get();
if(curr_char==EOF)
goto FINISH;

}

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished discarding comment.  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

}


/*:62*//*63:*/
#line 2280 "scanner.web"


else if(curr_char=='"')
{

/*:63*//*64:*/
#line 2288 "scanner.web"


if(state==COLLECTING_STRING)
{
state= state_stack.top();
state_stack.pop();


#ifdef DEBUG_OUTPUT

temp_strm<<endl<<"*** Finished collecting string."
<<endl
<<"`curr_string' == "<<curr_string.c_str()<<endl
<<"Exiting `yylex' successfully with return value "
<<keyword_map["STRING"]->value_name
<<" ("
<<keyword_map["STRING"]->value
<<")"
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

strcpy(value->string_value,curr_string.c_str());
curr_string= "";
return STRING;


}




/*:64*//*65:*/
#line 2328 "scanner.web"




else if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Starting to collect string.  ***"<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif
state_stack.push(state);
state= COLLECTING_STRING;
curr_string= "";
}




else if(state==COLLECTING_ID)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting keyword.  "
<<"`curr_id' == "<<curr_id
<<endl<<"***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



/*:65*//*66:*/
#line 2372 "scanner.web"


/*109:*/
#line 4094 "scanner.web"


map<string,Keyword_Type*> ::iterator keyword_iter= keyword_map.find(curr_id);



if(keyword_iter==keyword_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"In `yylex':  "
<<"`"<<curr_id<<"' not found in `keyword_map'."
<<endl
<<"Will search in `scanner_node->id_map'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

map<string,Id_Type*> ::iterator id_iter= scanner_node->id_map.find(curr_id);


/*:109*//*110:*/
#line 4121 "scanner.web"


if(id_iter==scanner_node->id_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' not found in "
<<"`scanner_node->id_map'.  Returning `VARIABLE_TEXT_SEGMENT'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

strcpy(value->string_value,curr_id.c_str());
curr_id= "";

scanner_node->in_strm.unget();

return VARIABLE_TEXT_SEGMENT;

}



/*:110*//*111:*/
#line 4150 "scanner.web"


else
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' found in "
<<"`scanner_node->id_map'."
<<endl
<<"Pushing `Token_Type' object onto `scanner_node->token_stack' "
<<"and returning `VARIABLE' ("<<VARIABLE<<")."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

Token_Type curr_token;
curr_token.value.pointer_value= scanner_node->id_map[curr_id];
curr_token.type= scanner_node->id_map[curr_id]->type;
scanner_node->token_stack.push(curr_token);

scanner_node->in_strm.unget();
curr_id= "";

value->int_value= 0;

return VARIABLE;


}



}




else
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"Keyword `"<<curr_id
<<"' found."
<<endl
<<"Exiting function successfully with return value "
<<keyword_iter->second->value_name<<" ("
<<keyword_iter->second->value<<")"
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

scanner_node->in_strm.unget();

return keyword_iter->second->value;

}





/*:111*/
#line 2374 "scanner.web"


}




/*:66*//*67:*/
#line 2384 "scanner.web"


else if(state==COLLECTING_INTEGER)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting integer.  "
<<"`curr_integer_str' == "<<curr_integer_str
<<"  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

value->int_value= atoi(curr_integer_str.c_str());

scanner_node->in_strm.unget();

return INTEGER;

}



/*:67*//*68:*/
#line 2414 "scanner.web"


else if(state==COLLECTING_FLOAT)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting float.  "
<<"`curr_float_str' == "<<curr_float_str
<<"  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

value->float_value= atof(curr_float_str.c_str());

scanner_node->in_strm.unget();

return FLOAT;

}


/*:68*//*69:*/
#line 2443 "scanner.web"


else
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Starting to collect string.  ***"<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif
state_stack.push(state);
state= COLLECTING_STRING;
curr_string= "";
}




}


/*:69*//*70:*/
#line 2479 "scanner.web"


else if(isalpha(curr_char)
||curr_char=='_'

||curr_char==''
||curr_char==''
||curr_char==''

||curr_char==''
||curr_char==''
||curr_char==''

||curr_char==''

||curr_char==''
||curr_char==''
||curr_char==''
||curr_char==''
||curr_char==''
||curr_char==''

||curr_char==''
||curr_char==''
||curr_char==''
||curr_char==''
||curr_char==''

||curr_char==''
||curr_char==''
||curr_char==''
||curr_char==''
||curr_char==''

||curr_char==''
||curr_char==''
||curr_char==''
||curr_char==''
||curr_char==''
||curr_char==''

||curr_char==''
||curr_char==''
||curr_char==''
||curr_char==''
||curr_char==''

||curr_char==''
||curr_char==''
||curr_char==''
||curr_char==''
||curr_char=='')

{



/*:70*//*71:*/
#line 2539 "scanner.web"


if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Read an alphabetical character "
<<"or the underline character in `NULL_STATE':"
<<endl<<"Entering state `COLLECTING_ID'. ***"<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif
state= COLLECTING_ID;
curr_id= "";
curr_id+= curr_char;


}




/*:71*//*72:*/
#line 2567 "scanner.web"


else if(state==COLLECTING_ID)
{
curr_id+= curr_char;

}




else if(state==COLLECTING_INTEGER)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting integer.  "
<<"`curr_integer_str' == "<<curr_integer_str
<<"  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

value->int_value= atoi(curr_integer_str.c_str());

scanner_node->in_strm.unget();

return INTEGER;

}





else if(state==COLLECTING_FLOAT)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting float.  "
<<"`curr_float_str' == "<<curr_float_str
<<"  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

value->float_value= atof(curr_float_str.c_str());

scanner_node->in_strm.unget();

return FLOAT;

}




/*:72*//*73:*/
#line 2634 "scanner.web"


else if(state==COLLECTING_STRING)
{
curr_string+= curr_char;

}



}



/*:73*//*74:*/
#line 2656 "scanner.web"


else if(isdigit(curr_char))
{



if(state==NULL_STATE)
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Read a digit in `NULL_STATE'.  "
<<"Entering state `COLLECTING_INTEGER'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif
curr_integer_str+= curr_char;

state= COLLECTING_INTEGER;

continue;

}



/*:74*//*75:*/
#line 2688 "scanner.web"


else if(state==COLLECTING_ID)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting keyword.  "
<<"`curr_id' == "<<curr_id
<<endl<<"***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



/*:75*//*76:*/
#line 2710 "scanner.web"


/*109:*/
#line 4094 "scanner.web"


map<string,Keyword_Type*> ::iterator keyword_iter= keyword_map.find(curr_id);



if(keyword_iter==keyword_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"In `yylex':  "
<<"`"<<curr_id<<"' not found in `keyword_map'."
<<endl
<<"Will search in `scanner_node->id_map'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

map<string,Id_Type*> ::iterator id_iter= scanner_node->id_map.find(curr_id);


/*:109*//*110:*/
#line 4121 "scanner.web"


if(id_iter==scanner_node->id_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' not found in "
<<"`scanner_node->id_map'.  Returning `VARIABLE_TEXT_SEGMENT'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

strcpy(value->string_value,curr_id.c_str());
curr_id= "";

scanner_node->in_strm.unget();

return VARIABLE_TEXT_SEGMENT;

}



/*:110*//*111:*/
#line 4150 "scanner.web"


else
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' found in "
<<"`scanner_node->id_map'."
<<endl
<<"Pushing `Token_Type' object onto `scanner_node->token_stack' "
<<"and returning `VARIABLE' ("<<VARIABLE<<")."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

Token_Type curr_token;
curr_token.value.pointer_value= scanner_node->id_map[curr_id];
curr_token.type= scanner_node->id_map[curr_id]->type;
scanner_node->token_stack.push(curr_token);

scanner_node->in_strm.unget();
curr_id= "";

value->int_value= 0;

return VARIABLE;


}



}




else
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"Keyword `"<<curr_id
<<"' found."
<<endl
<<"Exiting function successfully with return value "
<<keyword_iter->second->value_name<<" ("
<<keyword_iter->second->value<<")"
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

scanner_node->in_strm.unget();

return keyword_iter->second->value;

}





/*:111*/
#line 2712 "scanner.web"


}




else if(state==COLLECTING_INTEGER)
{
curr_integer_str+= curr_char;
}



else if(state==COLLECTING_FLOAT)
{
curr_float_str+= curr_char;
}



else if(state==COLLECTING_STRING)
{
curr_string+= curr_char;
}




}



/*:76*//*77:*/
#line 2748 "scanner.web"


else if(curr_char=='\\')
{



/*:77*//*78:*/
#line 2758 "scanner.web"


if(state==COLLECTING_ID)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting keyword.  "
<<"`curr_id' == "<<curr_id
<<endl<<"***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



/*:78*//*79:*/
#line 2780 "scanner.web"


/*109:*/
#line 4094 "scanner.web"


map<string,Keyword_Type*> ::iterator keyword_iter= keyword_map.find(curr_id);



if(keyword_iter==keyword_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"In `yylex':  "
<<"`"<<curr_id<<"' not found in `keyword_map'."
<<endl
<<"Will search in `scanner_node->id_map'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

map<string,Id_Type*> ::iterator id_iter= scanner_node->id_map.find(curr_id);


/*:109*//*110:*/
#line 4121 "scanner.web"


if(id_iter==scanner_node->id_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' not found in "
<<"`scanner_node->id_map'.  Returning `VARIABLE_TEXT_SEGMENT'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

strcpy(value->string_value,curr_id.c_str());
curr_id= "";

scanner_node->in_strm.unget();

return VARIABLE_TEXT_SEGMENT;

}



/*:110*//*111:*/
#line 4150 "scanner.web"


else
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' found in "
<<"`scanner_node->id_map'."
<<endl
<<"Pushing `Token_Type' object onto `scanner_node->token_stack' "
<<"and returning `VARIABLE' ("<<VARIABLE<<")."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

Token_Type curr_token;
curr_token.value.pointer_value= scanner_node->id_map[curr_id];
curr_token.type= scanner_node->id_map[curr_id]->type;
scanner_node->token_stack.push(curr_token);

scanner_node->in_strm.unget();
curr_id= "";

value->int_value= 0;

return VARIABLE;


}



}




else
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"Keyword `"<<curr_id
<<"' found."
<<endl
<<"Exiting function successfully with return value "
<<keyword_iter->second->value_name<<" ("
<<keyword_iter->second->value<<")"
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

scanner_node->in_strm.unget();

return keyword_iter->second->value;

}





/*:111*/
#line 2782 "scanner.web"


}







else if(state==COLLECTING_INTEGER)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting integer.  "
<<"`curr_integer_str' == "<<curr_integer_str
<<"  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

value->int_value= atoi(curr_integer_str.c_str());

scanner_node->in_strm.unget();

return INTEGER;

}





else if(state==COLLECTING_FLOAT)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting float.  "
<<"`curr_float_str' == "<<curr_float_str
<<"  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

value->float_value= atof(curr_float_str.c_str());

scanner_node->in_strm.unget();

return FLOAT;

}




/*:79*//*80:*/
#line 2848 "scanner.web"


if(state==COLLECTING_STRING)
{
curr_char= scanner_node->in_strm.get();
curr_string+= curr_char;
continue;

}


/*:80*//*81:*/
#line 2860 "scanner.web"


}


/*:81*//*83:*/
#line 2883 "scanner.web"


else if(curr_char=='=')
{



if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  "
<<"Got `='.  Returning `ASSIGN'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return ASSIGN;
}



else if(state==COLLECTING_STRING)
{
curr_string+= curr_char;
}



else if(state==COLLECTING_ID)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting keyword.  "
<<"`curr_id' == "<<curr_id
<<endl<<"***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



/*:83*//*84:*/
#line 2937 "scanner.web"


/*109:*/
#line 4094 "scanner.web"


map<string,Keyword_Type*> ::iterator keyword_iter= keyword_map.find(curr_id);



if(keyword_iter==keyword_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"In `yylex':  "
<<"`"<<curr_id<<"' not found in `keyword_map'."
<<endl
<<"Will search in `scanner_node->id_map'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

map<string,Id_Type*> ::iterator id_iter= scanner_node->id_map.find(curr_id);


/*:109*//*110:*/
#line 4121 "scanner.web"


if(id_iter==scanner_node->id_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' not found in "
<<"`scanner_node->id_map'.  Returning `VARIABLE_TEXT_SEGMENT'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

strcpy(value->string_value,curr_id.c_str());
curr_id= "";

scanner_node->in_strm.unget();

return VARIABLE_TEXT_SEGMENT;

}



/*:110*//*111:*/
#line 4150 "scanner.web"


else
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' found in "
<<"`scanner_node->id_map'."
<<endl
<<"Pushing `Token_Type' object onto `scanner_node->token_stack' "
<<"and returning `VARIABLE' ("<<VARIABLE<<")."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

Token_Type curr_token;
curr_token.value.pointer_value= scanner_node->id_map[curr_id];
curr_token.type= scanner_node->id_map[curr_id]->type;
scanner_node->token_stack.push(curr_token);

scanner_node->in_strm.unget();
curr_id= "";

value->int_value= 0;

return VARIABLE;


}



}




else
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"Keyword `"<<curr_id
<<"' found."
<<endl
<<"Exiting function successfully with return value "
<<keyword_iter->second->value_name<<" ("
<<keyword_iter->second->value<<")"
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

scanner_node->in_strm.unget();

return keyword_iter->second->value;

}





/*:111*/
#line 2939 "scanner.web"


}



else if(state==COLLECTING_INTEGER)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting integer.  "
<<"`curr_integer_str' == "<<curr_integer_str
<<"  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

value->int_value= atoi(curr_integer_str.c_str());

scanner_node->in_strm.unget();

return INTEGER;

}




else if(state==COLLECTING_FLOAT)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting float.  "
<<"`curr_float_str' == "<<curr_float_str
<<"  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

value->float_value= atof(curr_float_str.c_str());

scanner_node->in_strm.unget();

return FLOAT;

}



}


/*:84*//*85:*/
#line 3007 "scanner.web"


else if(curr_char=='+')
{



if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  "
<<"Got `+'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

next_char= scanner_node->in_strm.peek();
if(next_char=='=')
{
scanner_node->in_strm.get();
return PLUS_ASSIGN;
}

else
return PLUS;


}

goto COMMON_PUNCTUATION;


}


/*:85*//*86:*/
#line 3056 "scanner.web"


else if(curr_char=='&')
{



if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  "
<<"Got `&'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

next_char= scanner_node->in_strm.peek();
if(next_char=='=')
{
scanner_node->in_strm.get();
return AND_ASSIGN;
}
else if(next_char=='!')
{
scanner_node->in_strm.get();
return AND_NOT;
}

else
return AND;


}

goto COMMON_PUNCTUATION;



}


/*:86*//*87:*/
#line 3111 "scanner.web"


else if(curr_char=='|')
{



if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  "
<<"Got `|'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

next_char= scanner_node->in_strm.peek();
if(next_char=='=')
{
scanner_node->in_strm.get();
return OR_ASSIGN;
}
else if(next_char=='!')
{
scanner_node->in_strm.get();
return OR_NOT;
}
else
return OR;

}

goto COMMON_PUNCTUATION;




}



/*:87*//*88:*/
#line 3166 "scanner.web"


else if(curr_char=='^')
{



if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  "
<<"Got `^'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

next_char= scanner_node->in_strm.peek();
if(next_char=='=')
{
scanner_node->in_strm.get();
return XOR_ASSIGN;
}
else if(next_char=='!')
{
scanner_node->in_strm.get();
return XOR_NOT;
}
else
return XOR;


}

goto COMMON_PUNCTUATION;



}



/*:88*//*89:*/
#line 3221 "scanner.web"


else if(curr_char=='!')
{



if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  "
<<"Got `!'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

next_char= scanner_node->in_strm.peek();
if(next_char=='=')
{
scanner_node->in_strm.get();
return NOT_ASSIGN;
}
else
return NOT;


}

else
goto COMMON_PUNCTUATION;



}



/*:89*//*90:*/
#line 3272 "scanner.web"


else if(curr_char==':')
{



if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  "
<<"Got `:'.  Returning `COLON'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return COLON;
}

goto COMMON_PUNCTUATION;



}



/*:90*//*91:*/
#line 3313 "scanner.web"


else if(curr_char==';')
{



if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  "
<<"Got `;'.  Returning `SEMI_COLON'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return SEMI_COLON;
}

goto COMMON_PUNCTUATION;



}



/*:91*//*92:*/
#line 3354 "scanner.web"


else if(curr_char==',')
{



if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex',  "
<<"Got `,'.  Returning `COMMA'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return COMMA;
}

goto COMMON_PUNCTUATION;



}



/*:92*//*93:*/
#line 3395 "scanner.web"


else if(curr_char=='%')
{



if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex',  "
<<"Got `%'.  Returning `PERCENT'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return PERCENT;
}

goto COMMON_PUNCTUATION;



}



/*:93*//*94:*/
#line 3436 "scanner.web"


else if(curr_char=='-')
{



if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex',  "
<<"Got `,'.  Returning `HYPHEN'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return HYPHEN;
}

goto COMMON_PUNCTUATION;



}


/*:94*//*95:*/
#line 3481 "scanner.web"


else if(curr_char=='.')
{



if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  "
<<"Got `.'.  Returning `PERIOD'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return PERIOD;
}



else if(state==COLLECTING_STRING)
{
curr_string+= curr_char;
}



else if(state==COLLECTING_ID)
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting id.  "
<<"`curr_id' == "<<curr_id
<<endl<<"***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif




/*:95*//*96:*/
#line 3535 "scanner.web"


/*109:*/
#line 4094 "scanner.web"


map<string,Keyword_Type*> ::iterator keyword_iter= keyword_map.find(curr_id);



if(keyword_iter==keyword_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"In `yylex':  "
<<"`"<<curr_id<<"' not found in `keyword_map'."
<<endl
<<"Will search in `scanner_node->id_map'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

map<string,Id_Type*> ::iterator id_iter= scanner_node->id_map.find(curr_id);


/*:109*//*110:*/
#line 4121 "scanner.web"


if(id_iter==scanner_node->id_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' not found in "
<<"`scanner_node->id_map'.  Returning `VARIABLE_TEXT_SEGMENT'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

strcpy(value->string_value,curr_id.c_str());
curr_id= "";

scanner_node->in_strm.unget();

return VARIABLE_TEXT_SEGMENT;

}



/*:110*//*111:*/
#line 4150 "scanner.web"


else
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' found in "
<<"`scanner_node->id_map'."
<<endl
<<"Pushing `Token_Type' object onto `scanner_node->token_stack' "
<<"and returning `VARIABLE' ("<<VARIABLE<<")."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

Token_Type curr_token;
curr_token.value.pointer_value= scanner_node->id_map[curr_id];
curr_token.type= scanner_node->id_map[curr_id]->type;
scanner_node->token_stack.push(curr_token);

scanner_node->in_strm.unget();
curr_id= "";

value->int_value= 0;

return VARIABLE;


}



}




else
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"Keyword `"<<curr_id
<<"' found."
<<endl
<<"Exiting function successfully with return value "
<<keyword_iter->second->value_name<<" ("
<<keyword_iter->second->value<<")"
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

scanner_node->in_strm.unget();

return keyword_iter->second->value;

}





/*:111*/
#line 3537 "scanner.web"


}



else if(state==COLLECTING_INTEGER)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"*** Read `.' while collecting integer.  "
<<"Changing state to `COLLECTING_FLOAT'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

curr_float_str= curr_integer_str+curr_char;
curr_integer_str= "";
state= COLLECTING_FLOAT;

continue;

}



else if(state==COLLECTING_FLOAT)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting float.  "
<<"`curr_float_str' == "<<curr_float_str
<<"  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

value->float_value= atof(curr_float_str.c_str());

scanner_node->in_strm.unget();

return FLOAT;

}



}



/*:96*//*97:*/
#line 3604 "scanner.web"


else if(curr_char=='@')
{



if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex'@  "
<<"Got `@'.  Returning `AT_SYMBOL'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return AT_SYMBOL;
}

goto COMMON_PUNCTUATION;



}



/*:97*//*98:*/
#line 3645 "scanner.web"


else if(curr_char=='(')
{

if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  "
<<"Got `('.  Returning `OPEN_PARENTHESIS'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return OPEN_PARENTHESIS;
}

goto COMMON_PUNCTUATION;



}





/*:98*//*99:*/
#line 3686 "scanner.web"



else if(curr_char==')')
{


if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT

temp_strm<<"In `yylex':  "
<<"Got `)'.  Returning `CLOSE_PARENTHESIS'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return CLOSE_PARENTHESIS;
}

goto COMMON_PUNCTUATION;



}



/*:99*//*100:*/
#line 3728 "scanner.web"


else if(curr_char=='[')
{


if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  "
<<"Got `['.  Returning `OPEN_BRACKET'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return OPEN_BRACKET;
}


goto COMMON_PUNCTUATION;




}





/*:100*//*101:*/
#line 3772 "scanner.web"



else if(curr_char==']')
{

if(state==NULL_STATE)
{

#ifdef DEBUG_OUTPUT

temp_strm<<"In `yylex':  "
<<"Got `]'.  Returning `CLOSE_BRACKET'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return CLOSE_BRACKET;
}

goto COMMON_PUNCTUATION;



}





/*:101*//*102:*/
#line 3810 "scanner.web"


else if(isspace(curr_char))
{


/*:102*//*103:*/
#line 3819 "scanner.web"


if(state==NULL_STATE)
{
continue;

}



else if(state==COLLECTING_ID)
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting keyword.  "
<<"`curr_id' == "<<curr_id
<<endl<<"***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif




/*:103*//*104:*/
#line 3849 "scanner.web"


/*109:*/
#line 4094 "scanner.web"


map<string,Keyword_Type*> ::iterator keyword_iter= keyword_map.find(curr_id);



if(keyword_iter==keyword_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"In `yylex':  "
<<"`"<<curr_id<<"' not found in `keyword_map'."
<<endl
<<"Will search in `scanner_node->id_map'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

map<string,Id_Type*> ::iterator id_iter= scanner_node->id_map.find(curr_id);


/*:109*//*110:*/
#line 4121 "scanner.web"


if(id_iter==scanner_node->id_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' not found in "
<<"`scanner_node->id_map'.  Returning `VARIABLE_TEXT_SEGMENT'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

strcpy(value->string_value,curr_id.c_str());
curr_id= "";

scanner_node->in_strm.unget();

return VARIABLE_TEXT_SEGMENT;

}



/*:110*//*111:*/
#line 4150 "scanner.web"


else
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' found in "
<<"`scanner_node->id_map'."
<<endl
<<"Pushing `Token_Type' object onto `scanner_node->token_stack' "
<<"and returning `VARIABLE' ("<<VARIABLE<<")."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

Token_Type curr_token;
curr_token.value.pointer_value= scanner_node->id_map[curr_id];
curr_token.type= scanner_node->id_map[curr_id]->type;
scanner_node->token_stack.push(curr_token);

scanner_node->in_strm.unget();
curr_id= "";

value->int_value= 0;

return VARIABLE;


}



}




else
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"Keyword `"<<curr_id
<<"' found."
<<endl
<<"Exiting function successfully with return value "
<<keyword_iter->second->value_name<<" ("
<<keyword_iter->second->value<<")"
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

scanner_node->in_strm.unget();

return keyword_iter->second->value;

}





/*:111*/
#line 3851 "scanner.web"


}




/*:104*//*105:*/
#line 3861 "scanner.web"

else if(state==COLLECTING_STRING)
{
curr_string+= curr_char;
}




else if(state==COLLECTING_INTEGER)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting integer.  "
<<"`curr_integer_str' == "<<curr_integer_str
<<"  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

value->int_value= atoi(curr_integer_str.c_str());

scanner_node->in_strm.unget();

return INTEGER;

}



else if(state==COLLECTING_FLOAT)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting float.  "
<<"`curr_float_str' == "<<curr_float_str
<<"  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

value->float_value= atof(curr_float_str.c_str());

scanner_node->in_strm.unget();

return FLOAT;

}



}

MAIN_LOOP_END:

;




}


FINISH:

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"End of main loop."<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif


/*:105*//*106:*/
#line 3947 "scanner.web"


#ifdef DEBUG_OUTPUT
temp_strm<<"Exiting `yylex'."<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

#undef DEBUG_OUTPUT

return 0;





COMMON_PUNCTUATION:

/*107:*/
#line 3983 "scanner.web"




if(state==COLLECTING_STRING)
{
curr_string+= curr_char;
goto MAIN_LOOP_END;
}



else if(state==COLLECTING_ID)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting keyword.  "
<<"`curr_id' == "<<curr_id
<<endl<<"***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif



/*:107*//*108:*/
#line 4015 "scanner.web"


/*109:*/
#line 4094 "scanner.web"


map<string,Keyword_Type*> ::iterator keyword_iter= keyword_map.find(curr_id);



if(keyword_iter==keyword_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"In `yylex':  "
<<"`"<<curr_id<<"' not found in `keyword_map'."
<<endl
<<"Will search in `scanner_node->id_map'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

map<string,Id_Type*> ::iterator id_iter= scanner_node->id_map.find(curr_id);


/*:109*//*110:*/
#line 4121 "scanner.web"


if(id_iter==scanner_node->id_map.end())
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' not found in "
<<"`scanner_node->id_map'.  Returning `VARIABLE_TEXT_SEGMENT'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

strcpy(value->string_value,curr_id.c_str());
curr_id= "";

scanner_node->in_strm.unget();

return VARIABLE_TEXT_SEGMENT;

}



/*:110*//*111:*/
#line 4150 "scanner.web"


else
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `yylex':  `"<<curr_id<<"' found in "
<<"`scanner_node->id_map'."
<<endl
<<"Pushing `Token_Type' object onto `scanner_node->token_stack' "
<<"and returning `VARIABLE' ("<<VARIABLE<<")."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str();
#endif

Token_Type curr_token;
curr_token.value.pointer_value= scanner_node->id_map[curr_id];
curr_token.type= scanner_node->id_map[curr_id]->type;
scanner_node->token_stack.push(curr_token);

scanner_node->in_strm.unget();
curr_id= "";

value->int_value= 0;

return VARIABLE;


}



}




else
{
#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"Keyword `"<<curr_id
<<"' found."
<<endl
<<"Exiting function successfully with return value "
<<keyword_iter->second->value_name<<" ("
<<keyword_iter->second->value<<")"
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

scanner_node->in_strm.unget();

return keyword_iter->second->value;

}





/*:111*/
#line 4017 "scanner.web"


}



else if(state==COLLECTING_INTEGER)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting integer.  "
<<"`curr_integer_str' == "<<curr_integer_str
<<"  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

value->int_value= atoi(curr_integer_str.c_str());

scanner_node->in_strm.unget();

return INTEGER;

}




else if(state==COLLECTING_FLOAT)
{

#ifdef DEBUG_OUTPUT
temp_strm<<endl<<"*** Finished collecting float.  "
<<"`curr_float_str' == "<<curr_float_str
<<"  ***"
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
scanner_node->log_strm<<temp_strm.str();
temp_strm.str("");
#endif

value->float_value= atof(curr_float_str.c_str());

scanner_node->in_strm.unget();

return FLOAT;

}








/*:108*/
#line 3968 "scanner.web"


}




/*:106*/
#line 4230 "scanner.web"




/*:113*/
