/* * (1) Copyright and License. */

/* This file is part of the LDF Metadata Exchange Utilities,             */
/* a package for metadata exchange.                                      */

/* Copyright (C) 2007 Laurence D. Finston   */

/* The author is Laurence D. Finston.  */

/* The LDF Metadata Exchange Utilities are free software;                   */
/* you can redistribute them and/or modify                                  */
/* them under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation; either version 2 of the License, or        */
/* (at your option) any later version.                                      */

/* The LDF Metadata Exchange Utilities are distributed in the hope               */
/* that they will be useful, but WITHOUT ANY WARRANTY; without even              */
/* the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  */
/* See the GNU General Public License for more details.                          */

/* You should have received a copy of the GNU General Public License                   */
/* along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  */
/* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          */

/* The LDF Metadata Exchange Utilities are available for downloading from the  */
/* following FTP server:                                                       */
/* ftp:/*ftp.gwdg.de/pub/gnu2/iwfmdh/                                          */

/* Please send bug reports to lfinsto1@gwdg.de  */

/* The author can be contacted at:  */

/* Laurence D. Finston  */
/* Kreuzbergring 41     */
/* D-37075 Goettingen   */
/* Germany              */

/* lfinsto1@gwdg.de                */
/* s246794@stud.uni-goettingen.de  */


/*114:*/
#line 4235 "scanner.web"

/*3:*/
#line 106 "scanner.web"


#ifdef WIN_LDF
#pragma once
#endif


/*:3*/
#line 4236 "scanner.web"

using namespace std;
/*4:*/
#line 121 "scanner.web"


class Scanner_Type;
typedef Scanner_Type*Scanner_Node;

class Query_Type;
typedef Query_Type*Query_Node;

class Id_Type;
typedef Id_Type*Id_Node;

class Date_Time_Type;
typedef Date_Time_Type*Date_Time_Node;



/*:4*/
#line 4238 "scanner.web"

/*8:*/
#line 188 "scanner.web"


namespace Scan_Parse
{



/*:8*//*10:*/
#line 202 "scanner.web"



extern const unsigned int NULL_STATE;
extern const unsigned int COLLECTING_ID;
extern const unsigned int COLLECTING_STRING;
extern const unsigned int COLLECTING_INTEGER;
extern const unsigned int COLLECTING_FLOAT;



/*:10*//*11:*/
#line 214 "scanner.web"


struct Keyword_Type;

/*16:*/
#line 271 "scanner.web"


extern map<string,Keyword_Type*> keyword_map;


/*:16*/
#line 218 "scanner.web"

/*19:*/
#line 296 "scanner.web"


extern map<unsigned int,string> token_map;


/*:19*/
#line 219 "scanner.web"

/*20:*/
#line 321 "scanner.web"

int
initialize_maps(void);


/*:20*//*43:*/
#line 1791 "scanner.web"

int
show_keyword_map(Scanner_Type*scanner_node);

/*:43*//*47:*/
#line 1874 "scanner.web"

void*
variable_func(void*v,
char*name);



/*:47*//*48:*/
#line 1895 "scanner.web"

Id_Node
declare_variable_func(void*v,const unsigned short type,char*name);


/*:48*//*50:*/
#line 1920 "scanner.web"


void*
query_assignment_func_0(void*v,
void*object,
unsigned int assignment_type,
unsigned int arg_0,
unsigned int arg_1,
void*value,
bool negate);




/*:50*//*51:*/
#line 1944 "scanner.web"


int
query_assignment_func_1(Scanner_Node scanner_node,
Id_Node&curr_id_node,
void*&field_specifier,
int assignment_operator,
int negation_optional,
int match_term_optional,
void*&v,
int type);


/*:51*//*52:*/
#line 1967 "scanner.web"


int
datetime_assignment_func_0(void*v,
Date_Time_Node&curr_date_time_node,
int specifier,
int op,
void*val,
int type);



/*:52*//*53:*/
#line 1989 "scanner.web"


int
datetime_assignment_func_1(void*v,
Date_Time_Node&d,
int op,
void*&vec);



/*:53*//*55:*/
#line 2021 "scanner.web"

int
start_local_database_query_func(void*);


/*:55*//*56:*/
#line 2039 "scanner.web"

int
end_query_func(void*);


/*:56*/
#line 220 "scanner.web"


}




/*:11*/
#line 4239 "scanner.web"

/*57:*/
#line 2055 "scanner.web"

int
yylex(YYSTYPE*value,
void*parameter);


/*:57*/
#line 4240 "scanner.web"
















/*:114*/
