/* * (1) Copyright and License. */

/* This file is part of the LDF Metadata Exchange Utilities,             */
/* a package for metadata exchange.                                      */

/* Copyright (C) 2007 Laurence D. Finston   */

/* The author is Laurence D. Finston.  */

/* The LDF Metadata Exchange Utilities are free software;                   */
/* you can redistribute them and/or modify                                  */
/* them under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation; either version 2 of the License, or        */
/* (at your option) any later version.                                      */

/* The LDF Metadata Exchange Utilities are distributed in the hope               */
/* that they will be useful, but WITHOUT ANY WARRANTY; without even              */
/* the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  */
/* See the GNU General Public License for more details.                          */

/* You should have received a copy of the GNU General Public License                   */
/* along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  */
/* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          */

/* The LDF Metadata Exchange Utilities are available for downloading from the  */
/* following FTP server:                                                       */
/* ftp:/*ftp.gwdg.de/pub/gnu2/iwfmdh/                                          */

/* Please send bug reports to lfinsto1@gwdg.de  */

/* The author can be contacted at:  */

/* Laurence D. Finston  */
/* Kreuzbergring 41     */
/* D-37075 Goettingen   */
/* Germany              */

/* lfinsto1@gwdg.de                */
/* s246794@stud.uni-goettingen.de  */


/*35:*/
#line 1143 "scnrtype.web"

/*2:*/
#line 90 "scnrtype.web"


#include "localldf.h"

#ifdef NON_WIN_LDF
#include "nonwin.h"
#else
#include "stdafx.h"
#endif

#include "parser.hxx"
#include "dttmtype.h"
#include "idtype.h"
#include "scanner.h"
#include "querytyp.h"
#include "dtsrctyp.h"



/*:2*/
#line 1144 "scnrtype.web"

/*1:*/
#line 81 "scnrtype.web"


static char id_string[]
= "$Id: scnrtype.web,v 1.6 2007/02/13 20:41:41 lfinsto1 Exp $";



/*:1*/
#line 1145 "scnrtype.web"

using namespace std;
/*4:*/
#line 126 "scnrtype.web"


class Scanner_Type;
typedef Scanner_Type*Scanner_Node;

class Query_Type;
typedef Query_Type*Query_Node;

class Id_Type;
typedef Id_Type*Id_Node;


/*:4*/
#line 1147 "scnrtype.web"

/*5:*/
#line 149 "scnrtype.web"


struct
Token_Type
{
unsigned int type;
YYSTYPE value;

/*7:*/
#line 179 "scnrtype.web"

Token_Type(void);

/*:7*//*9:*/
#line 202 "scnrtype.web"

Token_Type(unsigned int ttype,YYSTYPE vvalue);

/*:9*/
#line 157 "scnrtype.web"


};


/*:5*/
#line 1148 "scnrtype.web"

/*11:*/
#line 235 "scnrtype.web"


class
Scanner_Type
{

/*12:*/
#line 271 "scnrtype.web"


friend
int
main(int,char*[]);

friend
int
yylex(YYSTYPE*,void*);

friend
int
yyparse(void*);


/*:12*//*14:*/
#line 335 "scnrtype.web"


friend
void*
Scan_Parse::variable_func(void*v,
char*name);

friend
Id_Node
Scan_Parse::declare_variable_func(void*v,
const unsigned short type,
char*name);

friend
void*
Scan_Parse::query_assignment_func_0(void*v,
void*object,
unsigned int assignment_type,
unsigned int arg_0,
unsigned int arg_1,
void*value,
bool negate);

friend
int
Scan_Parse::query_assignment_func_1(Scanner_Node scanner_node,
Id_Node&curr_id_node,
void*&field_specifier,
int assignment_operator,
int negation_optional,
int match_term_optional,
void*&v,
int type);

friend
int
Scan_Parse::start_local_database_query_func(void*v);

friend
int
Scan_Parse::end_query_func(void*v);

friend
int
Scan_Parse::datetime_assignment_func_0(void*v,
Date_Time_Node&curr_date_time_node,
int specifier,
int op,
void*val,
int type);

friend
int
Scan_Parse::datetime_assignment_func_1(void*v,
Date_Time_Node&d,
int op,
void*&vec);




/*:14*/
#line 241 "scnrtype.web"


char in_filename[128];
char log_filename[128];
ifstream in_strm;

map<string,Id_Type*> id_map;

stack<Token_Type> token_stack;

vector<float> float_vector;

public:

ofstream log_strm;

/*18:*/
#line 426 "scnrtype.web"

Scanner_Type(void);

/*:18*//*20:*/
#line 448 "scnrtype.web"

~Scanner_Type(void);

/*:20*//*22:*/
#line 524 "scnrtype.web"

int
initialize_id_map(void);


/*:22*//*24:*/
#line 584 "scnrtype.web"

Id_Node
lookup(char*name,bool create= false,unsigned int type= NULL_TYPE);



/*:24*/
#line 257 "scnrtype.web"


};



/*:11*/
#line 1149 "scnrtype.web"

/*8:*/
#line 183 "scnrtype.web"

Token_Type::Token_Type(void)
{

type= 0;
value.int_value= 0;

return;
}


/*:8*//*10:*/
#line 206 "scnrtype.web"

Token_Type::Token_Type(unsigned int ttype,YYSTYPE vvalue)
:type(ttype),value(vvalue)
{
return;
}




/*:10*/
#line 1150 "scnrtype.web"

/*19:*/
#line 430 "scnrtype.web"

Scanner_Type::Scanner_Type(void)
{

return;

}



/*:19*//*21:*/
#line 452 "scnrtype.web"

Scanner_Type::~Scanner_Type(void)
{
#if 0 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif


stringstream temp_strm;

#ifdef DEBUG_OUTPUT
temp_strm<<"Entering `~Scanner_Node'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(log_strm.is_open())
log_strm<<temp_strm.str();
temp_strm.str("");
#endif


for(map<string,Id_Type*> ::iterator iter= id_map.begin();
iter!=id_map.end();
++iter)
{
delete iter->second;
}

id_map.clear();


in_strm.close();

#ifdef DEBUG_OUTPUT
temp_strm<<"Exiting `~Scanner_Node'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(log_strm.is_open())
log_strm<<temp_strm.str();
temp_strm.str("");
#endif

log_strm.close();

return;

#undef DEBUG_OUTPUT

}



/*:21*//*23:*/
#line 530 "scnrtype.web"

int
Scanner_Type::initialize_id_map(void)
{


#if 0 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif

stringstream temp_strm;

#ifdef DEBUG_OUTPUT
temp_strm<<"Entering `Scanner_Node::initialize_id_map'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(log_strm.is_open())
log_strm<<temp_strm.str();
temp_strm.str("");
#endif



#ifdef DEBUG_OUTPUT
temp_strm<<"Exiting `Scanner_Node::initialize_id_map'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
if(log_strm.is_open())
log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return 0;

#undef DEBUG_OUTPUT

}



/*:23*//*25:*/
#line 591 "scnrtype.web"

Id_Node
Scanner_Type::lookup(char*name,bool create,unsigned int type)
{



#if 0 
#define DEBUG_OUTPUT
#else
#undef DEBUG_OUTPUT
#endif

stringstream temp_strm;

#ifdef DEBUG_OUTPUT
temp_strm<<"Entering `Scanner_Node::lookup'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif


Id_Node curr_id_node;

map<string,Id_Node> ::iterator iter= id_map.find(name);

if(iter==id_map.end())
{
curr_id_node= 0;
}



else
{
curr_id_node= iter->second;


/*:25*//*26:*/
#line 636 "scnrtype.web"


if(type!=curr_id_node->type)
{
temp_strm<<"WARNING!  In `Scanner_Node::lookup':"
<<endl
<<"`type' == `"
<<Scan_Parse::token_map[type]<<"' is not the same as "
<<"`curr_id_node->type' == `"
<<Scan_Parse::token_map[curr_id_node->type]<<"'."
<<endl
<<"Setting `type' to `"
<<Scan_Parse::token_map[curr_id_node->type]
<<"' and continuing."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");

type= curr_id_node->type;

}



/*:26*//*27:*/
#line 665 "scnrtype.web"


}



/*:27*//*28:*/
#line 674 "scnrtype.web"


if(strchr(name,'')==0)
{



if(curr_id_node!=0)
return curr_id_node;



else if(create==true)
{
curr_id_node= new Id_Type;
curr_id_node->name= name;
curr_id_node->type= type;

id_map[name]= curr_id_node;

return curr_id_node;
}



else
{
#ifdef DEBUG_OUTPUT
temp_strm<<"In `Scanner_Node::lookup':"
<<"`name' not found in `id_map' and `create' == 0."
<<endl
<<"Exiting function with return value 0.";

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return 0;

}



}


/*:28*//*29:*/
#line 726 "scnrtype.web"


else
{

stringstream curr_name_strm;
string curr_name;

{

int j= 0;

for(int i= 0;i<strlen(name);++i)
{
if(name[i]=='')
curr_name_strm<<'['<<float_vector[j++]<<']';

else
curr_name_strm<<name[i];

}

}


curr_name= curr_name_strm.str();

#ifdef DEBUG_OUTPUT
temp_strm<<"`curr_name' == "<<curr_name<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif



/*:29*//*30:*/
#line 768 "scnrtype.web"


if(curr_id_node->left==0)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"`"<<name<<"' refers to an empty array."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif




/*:30*//*31:*/
#line 790 "scnrtype.web"


if(create==false)
{
#ifdef DEBUG_OUTPUT
temp_strm<<"`create' == `false'.  Returning 0."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return 0;

}


/*:31*//*32:*/
#line 813 "scnrtype.web"


else
{

#ifdef DEBUG_OUTPUT
temp_strm<<"Creating array element for `"
<<curr_name<<"'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif

curr_id_node->left= new Id_Type;
curr_id_node->left->name= curr_name;
curr_id_node->left->type= type;
curr_id_node->left->up= curr_id_node;
return curr_id_node->left;

}

}


/*:32*//*33:*/
#line 844 "scnrtype.web"


else
{

#ifdef DEBUG_OUTPUT
temp_strm<<"`"<<name<<"' array isn't empty.  "
<<"Traversing."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif

curr_id_node= curr_id_node->left;




for(;;)
{



if(curr_name==curr_id_node->name)
{
#ifdef DEBUG_OUTPUT
temp_strm<<"`"<<curr_name<<"' exists.  Returning it."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif
return curr_id_node;

}



else if(curr_name.compare(curr_id_node->name)<0)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"`"<<curr_name<<"' < `"
<<curr_id_node->name<<"'.  "
<<"Traversing the tree leftwards."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif



if(curr_id_node->left!=0)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"`"<<curr_id_node->name<<"->left' exists.  "
<<"Continuing."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif

curr_id_node= curr_id_node->left;
continue;
}



else
{

#ifdef DEBUG_OUTPUT
temp_strm<<"`"<<curr_id_node->name<<"->left' doesn't exist."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif




if(create==true)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"Creating new `Id_Node' for `"<<curr_name<<"'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif
curr_id_node->left= new Id_Type;
curr_id_node->left->name= curr_name;
curr_id_node->left->type= type;
curr_id_node->left->up= curr_id_node;
return curr_id_node->left;

}


else
{
#ifdef DEBUG_OUTPUT
temp_strm<<"`create' == `false'.  "
<<"Not creating new `Id_Node' for `"
<<curr_name<<"'.  Returning 0."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return 0;

}




}



}



else if(curr_name.compare(curr_id_node->name)> 0)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"`"<<curr_name<<"' > `"
<<curr_id_node->name<<"'.  "
<<"Traversing the tree rightwards."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif



if(curr_id_node->right!=0)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"`"<<curr_id_node->name<<"->right' exists.  "
<<"Continuing."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif

curr_id_node= curr_id_node->right;
continue;

}



else
{

#ifdef DEBUG_OUTPUT
temp_strm<<"`"<<curr_id_node->name<<"->right' doesn't exist."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif



if(create==true)
{

#ifdef DEBUG_OUTPUT
temp_strm<<"Creating new `Id_Node' for `"<<curr_name<<"'."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif
curr_id_node->right= new Id_Type;
curr_id_node->right->name= curr_name;
curr_id_node->right->type= type;
curr_id_node->right->up= curr_id_node;
return curr_id_node->right;

}


else
{
#ifdef DEBUG_OUTPUT
temp_strm<<"`create' == `false'.  "
<<"Not creating new `Id_Node' for `"
<<curr_name<<"'.  Returning 0."
<<endl;

cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return 0;

}




}



}



}



}



}





#ifdef DEBUG_OUTPUT
temp_strm<<"Exiting `Scanner_Node::lookup'."
<<endl;
cerr_mutex.lock();
cerr<<temp_strm.str();
cerr_mutex.unlock();
log_strm<<temp_strm.str();
temp_strm.str("");
#endif

return 0;


#undef DEBUG_OUTPUT

}


/*:33*/
#line 1151 "scnrtype.web"




/*:35*/
