/* * (1) Copyright and License. */

/* This file is part of the LDF Metadata Exchange Utilities,             */
/* a package for metadata exchange.                                      */

/* Copyright (C) 2007 Laurence D. Finston   */

/* The author is Laurence D. Finston.  */

/* The LDF Metadata Exchange Utilities are free software;                   */
/* you can redistribute them and/or modify                                  */
/* them under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation; either version 2 of the License, or        */
/* (at your option) any later version.                                      */

/* The LDF Metadata Exchange Utilities are distributed in the hope               */
/* that they will be useful, but WITHOUT ANY WARRANTY; without even              */
/* the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  */
/* See the GNU General Public License for more details.                          */

/* You should have received a copy of the GNU General Public License                   */
/* along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  */
/* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          */

/* The LDF Metadata Exchange Utilities are available for downloading from the  */
/* following FTP server:                                                       */
/* ftp:/*ftp.gwdg.de/pub/gnu2/iwfmdh/                                          */

/* Please send bug reports to lfinsto1@gwdg.de  */

/* The author can be contacted at:  */

/* Laurence D. Finston  */
/* Kreuzbergring 41     */
/* D-37075 Goettingen   */
/* Germany              */

/* lfinsto1@gwdg.de                */
/* s246794@stud.uni-goettingen.de  */


/*36:*/
#line 1156 "scnrtype.web"


#ifndef SCNRTYPE_KNOWN
#define SCNRTYPE_KNOWN 1

/*3:*/
#line 111 "scnrtype.web"


#ifdef WIN_LDF
#pragma once
#endif


/*:3*/
#line 1161 "scnrtype.web"

using namespace std;
#include "scanner.h"
using namespace Scan_Parse;
/*4:*/
#line 126 "scnrtype.web"


class Scanner_Type;
typedef Scanner_Type*Scanner_Node;

class Query_Type;
typedef Query_Type*Query_Node;

class Id_Type;
typedef Id_Type*Id_Node;


/*:4*/
#line 1165 "scnrtype.web"

/*5:*/
#line 149 "scnrtype.web"


struct
Token_Type
{
unsigned int type;
YYSTYPE value;

/*7:*/
#line 179 "scnrtype.web"

Token_Type(void);

/*:7*//*9:*/
#line 202 "scnrtype.web"

Token_Type(unsigned int ttype,YYSTYPE vvalue);

/*:9*/
#line 157 "scnrtype.web"


};


/*:5*/
#line 1166 "scnrtype.web"

/*11:*/
#line 235 "scnrtype.web"


class
Scanner_Type
{

/*12:*/
#line 271 "scnrtype.web"


friend
int
main(int,char*[]);

friend
int
yylex(YYSTYPE*,void*);

friend
int
yyparse(void*);


/*:12*//*14:*/
#line 335 "scnrtype.web"


friend
void*
Scan_Parse::variable_func(void*v,
char*name);

friend
Id_Node
Scan_Parse::declare_variable_func(void*v,
const unsigned short type,
char*name);

friend
void*
Scan_Parse::query_assignment_func_0(void*v,
void*object,
unsigned int assignment_type,
unsigned int arg_0,
unsigned int arg_1,
void*value,
bool negate);

friend
int
Scan_Parse::query_assignment_func_1(Scanner_Node scanner_node,
Id_Node&curr_id_node,
void*&field_specifier,
int assignment_operator,
int negation_optional,
int match_term_optional,
void*&v,
int type);

friend
int
Scan_Parse::start_local_database_query_func(void*v);

friend
int
Scan_Parse::end_query_func(void*v);

friend
int
Scan_Parse::datetime_assignment_func_0(void*v,
Date_Time_Node&curr_date_time_node,
int specifier,
int op,
void*val,
int type);

friend
int
Scan_Parse::datetime_assignment_func_1(void*v,
Date_Time_Node&d,
int op,
void*&vec);




/*:14*/
#line 241 "scnrtype.web"


char in_filename[128];
char log_filename[128];
ifstream in_strm;

map<string,Id_Type*> id_map;

stack<Token_Type> token_stack;

vector<float> float_vector;

public:

ofstream log_strm;

/*18:*/
#line 426 "scnrtype.web"

Scanner_Type(void);

/*:18*//*20:*/
#line 448 "scnrtype.web"

~Scanner_Type(void);

/*:20*//*22:*/
#line 524 "scnrtype.web"

int
initialize_id_map(void);


/*:22*//*24:*/
#line 584 "scnrtype.web"

Id_Node
lookup(char*name,bool create= false,unsigned int type= NULL_TYPE);



/*:24*/
#line 257 "scnrtype.web"


};



/*:11*/
#line 1167 "scnrtype.web"


#endif 















/*:36*/
