@q variabls.web@>
@q Created by Laurence D. Finston (LDF) 2006.11.02.@>

@q $Id: variabls.w,v 1.5 2007/02/13 20:42:15 lfinsto1 Exp $ @>

@q * (1) Copyright and License. @>

@q This file is part of the LDF Metadata Exchange Utilities,            @>
@q a package for metadata exchange.                                     @>
@q It contains code from the the IWF Metadata Harvester, a package for  @>
@q metadata harvesting.                                                 @> 

@q The following copyright notice applies to the contents of this file up to  @>      
@q and including January 31, 2007:                                            @> 

@q Copyright (C) 2006, 2007 IWF Wissen und Medien gGmbH  @>

@q The following copyright notice applies to all changes and additions to this file  @>      
@q starting on February 1, 2007:                                                     @> 

@q Copyright (C) 2007 Laurence D. Finston  @>

@q The state of this file as of January 31, 2007 is stored in the  	  @>    
@q revision of this file with the symbolic tag "LAST_IWF"          	  @>
@q in the CVS repository for the LDF Metadata Exchange Utilities:  	  @>
@q http://cvs.savannah.nongnu.org/viewcvs/iwf-mdh/?root=iwf-mdh    	  @>
@q If necessary, changes and additions after this date can be determined  @>
@q by comparing this revision with later ones using the GNU diffutils:    @>
@q http://www.gnu.org/software/diffutils/diffutils.html                   @>

@q The author is Laurence D. Finston.  @>

@q The LDF Metadata Exchange Utilities are free software;                  @>
@q you can redistribute them and/or modify                                 @>
@q them under the terms of the GNU General Public License as published by  @>
@q the Free Software Foundation; either version 2 of the License, or       @>
@q (at your option) any later version.                                     @>

@q The LDF Metadata Exchange Utilities are distributed in the hope               @>          
@q that they will be useful, but WITHOUT ANY WARRANTY; without even              @>
@q the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  @>
@q See the GNU General Public License for more details.                          @>

@q You should have received a copy of the GNU General Public License                   @>
@q along with the LDF Metadata Exchange Utilities; if not, write to the Free Software  @>
@q Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA          @>

@q The LDF Metadata Exchange Utilities are available for downloading from the @>
@q following FTP server:                                                      @>
@q ftp://ftp.gwdg.de/pub/gnu2/iwfmdh/                                         @>

@q "@@" stands for a single "at"-sign in the following email adresses.  @>

@q Please send bug reports to lfinsto1@@gwdg.de  @>

@q The author can be contacted at: @>

@q Laurence D. Finston @>
@q Kreuzbergring 41    @>
@q D-37075 Goettingen  @>
@q Germany             @>

@q lfinsto1@@gwdg.de               @>
@q s246794@@stud.uni-goettingen.de @>




@q ** (2) Variables.@>
@*1 Variables (\filename{variabls.w}).
\initials{LDF 2006.11.02.}

\LOG
\initials{LDF 2006.11.02.}
Added this file.
\ENDLOG

@
@<\filename{variabls.w}@>=
static char variabls_id_string[] 
   = "$Id: variabls.w,v 1.5 2007/02/13 20:42:15 lfinsto1 Exp $"; 

@q *** (3) \variable name>.@>
@*2 \variable name>.
\initials{LDF 2006.11.02.}

\LOG
\initials{LDF 2006.11.02.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> variable_name@>

@q **** (4) variable_name: variable_segment_list.@>
@*3 \variable name> $\longrightarrow$ \variable segment list>.
\initials{LDF 2006.11.02.}

@<Parser rules@>=

@=variable_name: variable_segment_list@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif


    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

#ifdef DEBUG_OUTPUT    

    temp_strm << endl 
              << "Rule `variable_name: variable_segment_list'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

#if 0 /* 1 */ 
    Token_Type curr_token;
    curr_token.type  = yychar;
    curr_token.value = yylval;
#endif 

    scanner_node->token_stack.push(Token_Type(yychar, yylval));

    @=$$@> = Scan_Parse::variable_func(parameter, @=$1@>);

    yyclearin;

#undef DEBUG_OUTPUT 
};

@q *** (3) \variable segment list>.@>
@*2 \variable segment list>.
\initials{LDF 2006.11.02.}

\LOG
\initials{LDF 2006.11.02.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <string_value> variable_segment_list@>


@q **** (4) variable_segment_list: VARIABLE_TEXT_SEGMENT.@>
@*3 \variable segment list> $\longrightarrow$ \.{VARIABLE\_TEXT\_SEGMENT}.
\initials{LDF 2006.11.02.}

\LOG
\initials{LDF 2006.11.02.}
Added this rule.
\ENDLOG


@<Parser rules@>=

@=variable_segment_list: VARIABLE_TEXT_SEGMENT@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    scanner_node->float_vector.clear();

#ifdef DEBUG_OUTPUT 


    temp_strm << endl 
              << "Rule `variable_segment_list: VARIABLE_TEXT_SEGMENT'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    strcpy(@=$$@>, @=$1@>);

#undef DEBUG_OUTPUT 
};


@q **** (4) variable_segment_list: variable_segment_list VARIABLE_TEXT_SEGMENT.@>
@*3 \variable segment list> $\longrightarrow$ (etc\PERIOD).
\variable segment list> $\longrightarrow$ \variable segment list>
\.{VARIABLE\_TEXT\_SEGMENT}.
\initials{LDF 2006.11.02.}

\LOG
\initials{LDF 2006.11.02.}
Added this rule.
\ENDLOG


@<Parser rules@>=

@=variable_segment_list: variable_segment_list VARIABLE_TEXT_SEGMENT@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 

#ifdef DEBUG_OUTPUT 
    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `variable_segment_list: variable_segment_list "
              << "VARIABLE_TEXT_SEGMENT'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    strcpy(@=$$@>, @=$1@>);
    strcat(@=$$@>, @=$2@>);

#undef DEBUG_OUTPUT 
};

@q **** (4) variable_segment_list: variable_segment_list subscript.@>
@*3 \variable segment list> $\longrightarrow$ (etc\PERIOD).
\variable segment list> $\longrightarrow$ \variable segment list>
\subscript>.
\initials{LDF 2006.11.03.}

\LOG
\initials{LDF 2006.11.03.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=variable_segment_list: variable_segment_list subscript@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);
    scanner_node->float_vector.push_back(@=$2@>); 

#ifdef DEBUG_OUTPUT 


    temp_strm << endl 
              << "Rule `variable_segment_list: variable_segment_list "
              << "subscript'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    strcat(@=$$@>, "");

#undef DEBUG_OUTPUT
};

@q **** (4) subscript.@>
@*3 \subscript>.
\initials{LDF 2006.11.03.}

\LOG
\initials{LDF 2006.11.03.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <float_value> subscript@>

@q **** (4) subscript: INTEGER.@>
@*3 \subscript> $\longrightarrow$ \.{INTEGER}.
\initials{LDF 2006.11.03.}

\LOG
\initials{LDF 2006.11.03.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=subscript: INTEGER@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `subscript: INTEGER'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    @=$$@> = static_cast<float>(@=$1@>); 

#undef DEBUG_OUTPUT
};

@q **** (4) subscript: FLOAT.@>
@*3 \subscript> $\longrightarrow$ \.{FLOAT}.
\initials{LDF 2006.11.03.}

\LOG
\initials{LDF 2006.11.03.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=subscript: FLOAT@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `subscript: FLOAT'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    @=$$@> = @=$1@>;

#undef DEBUG_OUTPUT
};

@q **** (4) subscript: OPEN_BRACKET INTEGER CLOSE_BRACKET.@>

@*3 \subscript> $\longrightarrow$ \.{OPEN\_BRACKET} 
\.{INTEGER} \.{CLOSE\_BRACKET}.
\initials{LDF 2006.11.03.}

\LOG
\initials{LDF 2006.11.03.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=subscript: OPEN_BRACKET INTEGER CLOSE_BRACKET@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `subscript: OPEN_BRACKET INTEGER CLOSE_BRACKET'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    @=$$@> = static_cast<float>(@=$2@>);

#undef DEBUG_OUTPUT
};

@q **** (4) subscript: OPEN_BRACKET FLOAT CLOSE_BRACKET.@>

@*3 \subscript> $\longrightarrow$ \.{OPEN\_BRACKET} 
\.{FLOAT} \.{CLOSE\_BRACKET}.
\initials{LDF 2006.11.03.}

\LOG
\initials{LDF 2006.11.03.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=subscript: OPEN_BRACKET FLOAT CLOSE_BRACKET@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif


#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `subscript: OPEN_BRACKET FLOAT CLOSE_BRACKET'." 
              << endl;

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");
#endif 

    @=$$@> = @=$2@>;

#undef DEBUG_OUTPUT
};

@q **** (4) query_variable.@>
@*3 \query variable>.
\initials{LDF 2006.11.02.}

\LOG
\initials{LDF 2006.11.02.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> query_variable@>

@q ***** (5) query_variable: VARIABLE QUERY_TYPE.@>
@*4 \query variable> $\longrightarrow$ \.{VARIABLE} \.{QUERY TYPE}.
\initials{LDF 2006.11.02.}

The semantic value of the |QUERY_TYPE| token is the |Id_Type| object 
associated with the name specified by the semantic value of the |VARIABLE| 
token, or 0, if there is no |Id_Type| object.
\initials{LDF 2006.11.02.}

\LOG
\initials{LDF 2006.11.02.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=query_variable: VARIABLE QUERY_TYPE@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif


#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `query_variable: VARIABLE QUERY_TYPE'." 
              << endl;

    if (@=$2@> == 0)
    {
        temp_strm << "The semantic value of `QUERY_TYPE' == 0.  Not showing."
                  << endl;
    }

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");

    if (@=$2@> != 0)
    {
       static_cast<Id_Node>(@=$2@>)->show("`QUERY_TYPE':");
    }

#endif 

    @=$$@> = @=$2@>;

#undef DEBUG_OUTPUT

};

@q ***** (5) query_variable: variable_name QUERY_TYPE.@>
@*4 \query variable> $\longrightarrow$ \variable name> \.{QUERY TYPE}.
\initials{LDF 2006.11.02.}

\LOG
\initials{LDF 2006.11.02.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=query_variable: variable_name QUERY_TYPE@>
{

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 


#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `query_variable: variable_name QUERY_TYPE'." 
              << endl;

    if (@=$2@> == 0)
    {
        temp_strm << "The semantic value of `QUERY_TYPE' == 0.  Not showing."
                  << endl;
    }

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");

#if 0 /* 1 */ 
    if (@=$2@> != 0)
    {
       static_cast<Id_Node>(@=$2@>)->show("`QUERY_TYPE':");
    }
#endif 

#endif 

   @=$$@> = @=$2@>;

#undef DEBUG_OUTPUT
};

@q **** (4) datasource_variable.@>
@*3 \datasource variable>.
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> datasource_variable@>

@q ***** (5) datasource_variable: VARIABLE DATASOURCE_TYPE.@>
@*4 \datasource variable> $\longrightarrow$ \.{VARIABLE} \.{DATASOURCE TYPE}.
\initials{LDF 2006.12.08.}

The semantic value of the |DATASOURCE_TYPE| token is the |Id_Type| object 
associated with the name specified by the semantic value of the |VARIABLE| 
token, or 0, if there is no |Id_Type| object.
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datasource_variable: VARIABLE DATASOURCE_TYPE@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif


#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `datasource_variable: VARIABLE DATASOURCE_TYPE'." 
              << endl;

    if (@=$2@> == 0)
    {
        temp_strm << "The semantic value of `DATASOURCE_TYPE' == 0.  Not showing."
                  << endl;
    }

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");

    if (@=$2@> != 0)
    {
       static_cast<Id_Node>(@=$2@>)->show("`DATASOURCE_TYPE':");
    }

#endif 

    @=$$@> = @=$2@>;

#undef DEBUG_OUTPUT

};

@q ***** (5) datasource_variable: variable_name DATASOURCE_TYPE.@>
@*4 \datasource variable> $\longrightarrow$ \variable name> \.{DATASOURCE TYPE}.
\initials{LDF 2006.12.08.}

\LOG
\initials{LDF 2006.12.08.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datasource_variable: variable_name DATASOURCE_TYPE@>
{

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 


#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `datasource_variable: variable_name DATASOURCE_TYPE'." 
              << endl;

    if (@=$2@> == 0)
    {
        temp_strm << "The semantic value of `DATASOURCE_TYPE' == 0.  Not showing."
                  << endl;
    }

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");

    if (@=$2@> != 0)
    {
       static_cast<Id_Node>(@=$2@>)->show("`DATASOURCE_TYPE':");
    }

#endif 

   @=$$@> = @=$2@>;

#undef DEBUG_OUTPUT
};



@q **** (4) string_variable.@>
@*3 \string variable>.
\initials{LDF 2006.11.16.}

\LOG
\initials{LDF 2006.11.16.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> string_variable@>

@q ***** (5) string_variable: VARIABLE STRING_TYPE.@>
@*4 \string variable> $\longrightarrow$ \.{VARIABLE} \.{STRING TYPE}.
\initials{LDF 2006.11.16.}

The semantic value of the |STRING_TYPE| token is the |Id_Type| object 
associated with the name specified by the semantic value of the |VARIABLE| 
token, or 0, if there is no |Id_Type| object.
\initials{LDF 2006.11.16.}

\LOG
\initials{LDF 2006.11.16.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=string_variable: VARIABLE STRING_TYPE@>
{
#if 0 /* 1 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif

#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `string_variable: VARIABLE STRING_TYPE'." 
              << endl;
    if (@=$2@> == 0)
    {
        temp_strm << "The semantic value of `STRING_TYPE' == 0.  Not showing."
                  << endl;
    }

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");

    if (@=$2@> != 0)
    {
       static_cast<Id_Node>(@=$2@>)->show("`STRING_TYPE':");
    }

#endif 

    @=$$@> = @=$2@>;

#undef DEBUG_OUTPUT

};

@q ***** (5) string_variable: variable_name STRING_TYPE.@>
@*4 \string variable> $\longrightarrow$ \variable name> \.{STRING TYPE}.
\initials{LDF 2006.11.16.}

\LOG
\initials{LDF 2006.11.16.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=string_variable: variable_name STRING_TYPE@>
{

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 


#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `string_variable: variable_name STRING_TYPE'." 
              << endl;

    if (@=$2@> == 0)
    {
        temp_strm << "The semantic value of `STRING_TYPE' == 0.  Not showing."
                  << endl;
    }

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");

    if (@=$2@> != 0)
    {
       static_cast<Id_Node>(@=$2@>)->show("`STRING_TYPE':");
    }

#endif 

   @=$$@> = @=$2@>;

#undef DEBUG_OUTPUT
};

@q ***** (5) @>

@q **** (4) datetime_variable.@>
@*3 \datetime variable>.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this type declaration.
\ENDLOG

@<Type declarations for non-terminal symbols@>=
@=%type <pointer_value> datetime_variable@>

@q ***** (5) datetime_variable: VARIABLE DATETIME_TYPE.@>
@*4 \datetime variable> $\longrightarrow$ \.{VARIABLE} \.{DATETIME TYPE}.
\initials{LDF 2006.11.02.}

The semantic value of the |DATETIME_TYPE| token is the |Id_Type| object 
associated with the name specified by the semantic value of the |VARIABLE| 
token, or 0, if there is no |Id_Type| object.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datetime_variable: VARIABLE DATETIME_TYPE@>
{
#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif


#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `datetime_variable: VARIABLE DATETIME_TYPE'." 
              << endl;
#endif 

    @=$$@> = @=$2@>;

#undef DEBUG_OUTPUT

};

@q ***** (5) datetime_variable: variable_name DATETIME_TYPE.@>
@*4 \datetime variable> $\longrightarrow$ \variable name> \.{DATETIME TYPE}.
\initials{LDF 2006.12.15.}

\LOG
\initials{LDF 2006.12.15.}
Added this rule.
\ENDLOG

@<Parser rules@>=

@=datetime_variable: variable_name DATETIME_TYPE@>
{

#if 1 /* 0 */ 
#define DEBUG_OUTPUT 
#else
#undef DEBUG_OUTPUT
#endif 


#ifdef DEBUG_OUTPUT 

    Scanner_Node scanner_node = static_cast<Scanner_Node>(parameter);

    temp_strm << endl 
              << "Rule `datetime_variable: variable_name DATETIME_TYPE'." 
              << endl;

    if (@=$2@> == 0)
    {
        temp_strm << "The semantic value of `DATETIME_TYPE' == 0.  Not showing."
                  << endl;
    }

    cerr_mutex.lock();
    cerr <<  temp_strm.str();
    cerr_mutex.unlock();
    scanner_node->log_strm << temp_strm.str();
    temp_strm.str("");

#if 0 /* 1 */ 
    if (@=$2@> != 0)
    {
       static_cast<Id_Node>(@=$2@>)->show("`DATETIME_TYPE':");
    }
#endif 

#endif 

   @=$$@> = @=$2@>;

#undef DEBUG_OUTPUT
};




@q **** (4) @>

@q *** (3) @>

@q ** (2) @>

@q * (1) Emacs-Lisp code for use in indirect buffers.  LDF 2006.10.11.@>

@q (progn (outline-mode) (abbrev-mode t) (ignore '(                          @>
@q )) (setq outline-regexp (concat (char-to-string 64) "q [*\f]+")) (ignore'(@>
@q )) (make-variable-buffer-local 'outline-regexp))                          @>

@q * (1) Local Variables for Emacs  @>

@q Local Variables: @>
@q mode:Outline @>
@q abbrev-mode:t @>
@q eval:(setq outline-regexp (concat (char-to-string 64) "q [*\f]+")) @>
@q End: @>
